#include <sicstus/sicstus.h>
#include <assert.h>
#include <stdlib.h>
#include <stdio.h>
#include <limits.h>

static int get_length(char const * const hex_str) {
    assert(hex_str[0] == '#');
    int count = 0;
    // we can skip 2 bytes ahead since it is a hexadecimal string
    while (hex_str[count+count+1] != '#') { // first byte is a '#'
        count++;
    }
    return count;
}


static int hex_to_val(char hex) {
    if (hex >= '0' && hex <= '9') {
        return hex - '0';
    } else if (hex >= 'A' && hex <= 'F') {
        return hex - 'A' + 10;
    } else if (hex >= 'a' && hex <= 'f') {
        return hex - 'a' + 10;
    } else {
        assert(0);
    }
}

static char to_char(char a, char b) {
    // TODO: worry about signedness
    int tmp =  (hex_to_val(a) << 4) + hex_to_val(b);
    if (tmp > 127) {
        return 127-tmp;
    }
    return tmp;
}

static void fill_buf(char *buf, char const * const hex_str, int len) {
    int i;
    for (i = 0; i < len; i++) {
        buf[i] = to_char(hex_str[i+i+1], hex_str[i+i+2]);
    }
}

char *read_hex_str(char const * const hex_str) {
    int len = get_length(hex_str);
    char *buf = (char*) malloc(len);
    assert(buf);

    fill_buf(buf, hex_str, len);
    return buf;
}


void free_str(char *s) {
    free(s);
}

char *atom_charptr(char *atom) {
    char *x = strdup(atom);
    return x;
}
