:- module(graphiso_test,[
          testgi/0, bench/0]).

:- use_module(graphiso).


:- use_module('../../src/module_information.pl').

:- module_info(group,symmetry).
:- module_info(description,'Just to test graphiso.').
:- module_info(revision,'$Rev$').
:- module_info(lastchanged,'$LastChangedDate$').



testgi :- assert(user:library_directory('.')),
    graphiso_init,
    prob_get_number_of_colours(5),

    print(start_graph1),nl,flush_output(user_output),
    prob_start_graph(5),
    prob_set_colour_of_node(0,1),
    prob_set_colour_of_node(1,1),
    prob_set_colour_of_node(2,2),
    prob_set_colour_of_node(3,2),
    prob_set_colour_of_node(4,2),
    prob_add_edge(0,1),
    prob_add_edge(1,2),
    prob_add_edge(2,3),

    prob_exists_graph(X),
    print(prob_exists_graph1(X)),nl,
    print('^ Should be negative number'),nl,
    (X== -1 -> print('OK'),nl ; print('ERROR'),nl,halt(1)),
    flush_output(user_output),

    print(start_graph2),nl,flush_output(user_output),
    prob_start_graph(5),
    prob_set_colour_of_node(0,1),
    prob_set_colour_of_node(1,1),
    prob_set_colour_of_node(2,2),
    prob_set_colour_of_node(3,2),
    prob_set_colour_of_node(4,2),
    prob_add_edge(0,1),
    prob_add_edge(1,4),
    prob_add_edge(4,3),

    prob_exists_graph(Y),
    print(prob_exists_graph2(Y)),nl,
    print('^ Should be positive number'),nl,
    (Y==1 -> print('OK'),nl ; print('ERROR'),nl,halt(1)),
    flush_output(user_output),


    print(start_graph3),nl,flush_output(user_output),
    prob_start_graph(5),
    prob_set_colour_of_node(0,1),
    prob_set_colour_of_node(1,1),
    prob_set_colour_of_node(2,2),
    prob_set_colour_of_node(3,2),
    prob_set_colour_of_node(4,1), /* <== */
    prob_add_edge(0,1),
    prob_add_edge(1,4),
    prob_add_edge(4,3),

    prob_exists_graph(Z),
    print(prob_exists_graph3(Z)),nl,
    print('^ Should be negative number'),nl,
    (Z== -2 -> print('OK'),nl ; print('ERROR'),nl,halt(1)),
    flush_output(user_output).


% an example where nauty is pretty slow:

bench :- graphiso_init,
         statistics(runtime,[_,_]),
         prob_get_number_of_colours(23),
         addg(X1),
         statistics(runtime,[_,T2]),
         print(time_for_nauty(T2)),nl,
         addg(X2),
         statistics(runtime,[_,T1]),
         print(time(T1,X1,X2)),nl,
         prob_free_storage.

addg(X) :-
  prob_start_graph(15),
  prob_set_colour_of_node(8,6),
  prob_add_edge(8,3),
  prob_add_edge(8,13),
  prob_add_edge(8,5),
  prob_set_colour_of_node(6,6),
  prob_add_edge(6,1),
  prob_add_edge(6,11),
  prob_add_edge(6,5),
  prob_set_colour_of_node(4,5),
  prob_add_edge(4,9),
  prob_add_edge(4,0),
  prob_set_colour_of_node(2,5),
  prob_add_edge(2,7),
  prob_add_edge(2,0),
  prob_set_colour_of_node(14,5),
  prob_add_edge(14,9),
  prob_add_edge(14,13),
  prob_set_colour_of_node(12,5),
  prob_add_edge(12,7),
  prob_add_edge(12,11),
  prob_exists_graph(X).

