#ifndef HASHTRIE_H_INCLUDED
#define HASHTRIE_H_INCLUDED


#include <stdint.h>
#include "hash.h"


#include "tnode.h"
#include "shm_common.h"

typedef struct hashtrie {
    struct shm_env *shm;
} hashtrie;



hashtrie get_trie(struct semap_env senv, const key_t start);
void teardown_hashtrie(hashtrie *t, const int server, const int id);
size_t trie_get_checked_states_count(const hashtrie t);
size_t trie_count_elements(const hashtrie t);
char *trie_iterate(const hashtrie t, size_t *blocklen);
int get_max_depth(const hashtrie t);
void trie_put(const hashtrie t, const char digest[HASH_LEN], void const * const infos);
void *get(const hashtrie t, const char key[HASH_LEN]);
int trie_contains(const hashtrie t, const char key[HASH_LEN]);
int trie_contains_processed(const hashtrie t, const char key[HASH_LEN]);

int64_t lookup_index(const hashtrie t,
                     char const * const key);

size_t trie_count_via_iterate(const hashtrie t);
#endif
