#include <assert.h>

#include <zmq.h>
#include <czmq.h>

#include "../worker/wprocessor.h"
#include "../common/msg_headers.h"

static void test_send_small_stats(zsock_t * const push, zsock_t * const pull) {
    char const * const worker_id = "123";
    size_t queuesize = 421337;
    send_small_stats(push, atoi(worker_id), queuesize);
    
    int header;
    char *id;
    size_t *qs;
    size_t size;
    int rc = zsock_recv(pull, "isb", &header, &id, (char*) &qs, &size);
    assert(rc == 0);

    assert(header == IS_SMALL_STATS);
    assert(0 == strcmp(id, worker_id));
    assert(*qs == 421337);
    assert(size == sizeof(size_t));

    free(qs);
    free(id);
    printf(".");
}


int main(int argc, char *argv[]) {
    zsock_t *pull = zsock_new_pull("inproc://foo-pull");
    zsock_t *push = zsock_new_push("inproc://foo-pull");

    test_send_small_stats(push, pull);

    zsock_destroy(&pull);
    zsock_destroy(&push);

    puts("");
    return 0;
}
