#ifndef WPROCESSOR_H_INCLUDED
#define WPROCESSOR_H_INCLUDED

#include <zmq.h>
#include <czmq.h>

#include <sicstus/sicstus.h>

#include "../common/queue.h"
#include "../common/hashtrie.h"

/* send a small statistic package via zocket.
 * The package consists of:
 *   a header
 *   the worker ID 
 *   the queuesize.
 */
void send_small_stats(zsock_t * const zocket_push,
                      const int id,
                      const size_t q_size);

struct wprocessor_args {
    wQueue *q;
    zsock_t *push;
    int worker_id;
    SP_pred_ref process_pred;
    hashtrie trie;
    int fd_logfile;
};

int processor_timer_fn(zloop_t *loop, int timer_id, void *args);

void processor(wQueue * const q,
               zsock_t * const push,
               const int worker_id,
               const SP_pred_ref process_pred,
               const hashtrie trie,
               int fd_logfile);

#endif
