:- module(choice_point_profiler,[register_choice_point/4, visit_choice_point/2, portray_choice_points/0]).


:- dynamic next_id/1.
next_id(1).

get_next_id(X) :- retract(next_id(X)), X1 is X+1, assert(next_id(X1)).

:- dynamic choice_point/3.

register_choice_point(Expr,Prio,_LWF,ID) :-
  choice_point(Expr,Prio,ID),!.
register_choice_point(Expr,Prio,LWF,ID) :-
   get_next_id(ID),
   assert(choice_point(Expr,Prio,ID)),
   assert_lwf_grounded(ID,LWF).
   
:- dynamic lwf_grounded/1.
:- block assert_lwf_grounded(?,-).
assert_lwf_grounded(ID,_LWF) :- lwf_grounded(ID) -> true ; assert(lwf_grounded(ID)).


:- dynamic choice_taken/3.

visit_choice_point(ID,Nr) :- 
   (retract(choice_taken(ID,Nr,Count)) -> true ; Count=0),
   C1 is Count+1,
   assert(choice_taken(ID,Nr,C1)).

:- use_module(translate,[print_bexpr/1]).
portray_choice_points :-
   choice_point(Expr,Prio,ID),
   print(ID), print(' : '), print(Prio), print(' = '),
   translate:print_bexpr(Expr),nl,
   (lwf_grounded(ID) -> true ; print(' '),print('Not Grounded'),nl),
   choice_taken(ID,Choice,Nr),
   print(' '), print(Choice), print(' :: '), print(Nr),nl,
   fail.
portray_choice_points.

% choice_point_profiler:portray_choice_points.
