:- module(kernel_sym_break_order,[sym_break_set/1]).

% we could try and use an attribute to store previous value !
% currently it is important to call sym_break-set as early as possible to ensure
% that it is run before other predicates which instantiate a list element
% one solution: call it from basic_type

% current problems: SetLogInefficiencies3.mch in Makefile_test

:- use_module(clpfd_interface).

:- block sym_break_set(-).
sym_break_set([H|T]) :- !, %print(sym_break_set(H,T)),nl,
   (nonvar(H) -> sym_break_set(T) ; sym_break_set2(T,H)).
sym_break_set(_).

:- block sym_break_set2(-,?).
sym_break_set2([H|T],PreviousValue) :- !, % print(sym_break_set2(H,T,PreviousValue)),nl,
  (nonvar(H) -> sym_break_set2(T,PreviousValue)
   ; %print(sym_break(PreviousValue,H)),nl,
     ordered_sym_break_value(PreviousValue,H),
     sym_break_set2(T,H)).
sym_break_set2(_,_).

:- block ordered_sym_break_value(-,-).
%ordered_sym_break_value(no_value,_) :- !. % we have no previous value to compare with
ordered_sym_break_value(A,B) :- print(ordered_sym_break_value(A,B)),nl,fail.
ordered_sym_break_value(int(X),int(Y)) :- !,clpfd_lt(X,Y,_).
ordered_sym_break_value(fd(X,T),fd(Y,T)) :- !, print(fd_sym_break(X,Y,T)),nl,clpfd_lt(X,Y,_).
ordered_sym_break_value(pred_false,R) :- !, R=pred_true.
ordered_sym_break_value(pred_true,_) :- !, fail.
ordered_sym_break_value((X,_V),(Y,_W)) :- !, ordered_sym_leq(X,Y). % TODO: improve
%ordered_value(string(X),string(Y),Eq) :- !, less_equal_atomic_term(X,Y,Eq).
ordered_sym_break_value(_,_).

% require X <= Y + provide_feedback
:- block ordered_sym_leq(-,-).
ordered_sym_leq(int(X),int(Y)) :- !,clpfd_leq(X,Y,_).
ordered_sym_leq(fd(X,T),fd(Y,T)) :- !, clpfd_leq(X,Y,_).
ordered_sym_leq(pred_false,_R) :- !, true.
ordered_sym_leq(pred_true,R) :- !, R=pred_true. %,Cmp=eq.
ordered_sym_leq((X,_V),(Y,_W)) :- !, ordered_sym_leq(X,Y).
ordered_sym_leq(_,_).