/* ------------------
% first version to compute the relational composition symbolically:
% we can now compute: i = %x.(x:INTEGER|x+1) & f = (i;i;i;i) & res = f(2000)
%  or even {x,y|x<y} = r & r2 = (r;r) &  20|->y : r2
% TO DO: treat closure([X],[couple(T1,T2)],P)  like closure([X1,X2],[T1,T2],P')
%        treat closure([X1,X2,X3],[T1,T2,T3],P) like closure([X12,X3],[couple(T1,T2),T3],P')
% THIS IS VERY SIMILAR TO symbolic_composition(C1,C2,symbolic,C3) if we have two closures; but seems a bit faster
% TO DO: maybe throw this code away nonetheless
symbolic_composition(Closure1,Closure2,closure(PR,TR,BRS)) :- % print(sym(Closure1,Closure2)),nl,trace,
% ERROR: what if identifier Y=V !!  <---------------- LEADS TO ERROR
    closure_mapping_to(Closure1, OtherParams,OtherTypes, Y,TY, B1),
    binary_closure(Closure2,  V,TV, W,TW, B2),
    TV=TY, % check that types match
    append(OtherParams,[W],PR),
    append(OtherTypes,[TW],TR),
    gensym:gensym('__FRESH__',FRESHID), % maybe we can avoid generating fresh ids if not necessary
    % if Rel2 is a function (which it currently is !) we can maybe just apply it if no restriction on domain ?
    bsyntaxtree:rename_bt(B1,[rename(Y,FRESHID)],RB1),
    bsyntaxtree:rename_bt(B2,[rename(V,FRESHID)],RB2),
    bsyntaxtree:conjunct_predicates([RB1,RB2],CB),
    FRESH = b(identifier(FRESHID),TY,[]),
    b_interpreter_components:create_unsimplified_exists([FRESH],CB,BR),
    bsyntaxtree:mark_bexpr_as_symbolic(BR,BRS) ,print('RESULT: '),translate:print_bvalue(closure(PR,TR,BRS)).

closure_mapping_to(closure([X],[TX],P),  [X1],[T1], X2,T2, NewP) :- !,
    % try and translate this into a binary closure; will arise e.g. in symbolic closures for closure1 operator
    binary_closure(closure([X],[TX],P),   X1,T1,  X2,T2, NewP).
closure_mapping_to(closure(Args,Types,Pred),  OtherParams,OtherTypes, RangeVar,RangeType, Pred) :-
    append(OtherTypes,[RangeType],Types), OtherTypes \= [],
    append(OtherParams,[RangeVar],Args).

binary_closure(closure([X,Y],[TX,TY],P),  X,TX, Y,TY, P) :- !.
binary_closure(closure([X],[couple(T1,T2)],P),   X1,T1,  X2,T2, NewP) :-
   gensym:gensym('__FRESH__',X1), gensym:gensym('__FRESH__',X2),
   BX1 = b(identifier(X1),T1,[]), BX2 = b(identifier(X2),T2,[]),
   X12_Pair = b(couple(BX1,BX2),couple(T1,T2),[]),
   bsyntaxtree:replace_id_by_expr(P,X,X12_Pair,NewP),
   print('BINARY: '),translate:print_bvalue(closure([X1,X2],[T1,T2],NewP)),nl.
-------------------- */


% --------------------
% a new experimental version of image; unfortunately it does not yet seem to pay off :-(
% it is not yet called from above
% use_module(bsets_clp), bsets_clp:image_for_list_relation([(int(1),int(2))],[int(1)],Result)
% use_module(bsets_clp), bsets_clp:image_for_list_relation([(int(1),int(2))|T],[int(1),int(3)],Result)
% bsets_clp:image_for_list_relation([(int(1),int(2))|T],[int(1),int(3)],Result), T=[(int(2),A)], ground(Result), Result==[int(2)]
% bsets_clp:image_for_list_relation([(int(1),int(2))|T],[int(1),int(3)],Result), T=[(int(3),int(55))|T2], nonvar(Result),...
/*
image_for_list_relation(List,S,Result) :-
  image_for_list_relation_propagate(List,S,PQ,PQ,true,Count),
  terminate_propagator_queue(Count,PQ),
  add_image_to_result(PQ,[],Result).

:- block add_image_to_result(-,?,?).
add_image_to_result(empty,_,Result) :- empty_set(Result).
add_image_to_result(solution(YMEMRES,Y,PQ),ImageSoFar,Result) :- % print(sol(YMEMRES,Y,PQ)),nl, %%
   (YMEMRES=pred_true
      -> membership_test(ImageSoFar,Y,MemRes),add_image_to_result_mem(MemRes,Y,PQ,ImageSoFar,Result)
      ;  add_image_to_result(PQ,ImageSoFar,Result)
   ).
:- block add_image_to_result_mem(-,?,?,?,?).
add_image_to_result_mem(pred_false,Y,PQ,ImageSoFar,Result) :- % print(add_to_result(Y,ImageSoFar,Result)),nl,
   add_element(Y,ImageSoFar,ImageSoFar2),
   equal_cons(Result,Y,Res2), % was: equal_object([Y|Res2],Result), TO DO: use _wf version
   add_image_to_result(PQ,ImageSoFar2,Res2).
add_image_to_result_mem(pred_true,_Y,PQ,ImageSoFar,Result) :- % print(skip(_Y)),nl,
  add_image_to_result(PQ,ImageSoFar,Result).

:- block image_for_list_relation_propagate(-,?, ?,?,?,?).
image_for_list_relation_propagate([],_S, _PQ1,_PQ2,_Done,0).
image_for_list_relation_propagate([(X,Y)|T],S,PQ1,PQ2,PrevDone,s(Count)) :-
   membership_test(S,X,MemRes),
   (PrevDone==true -> PQ=PQ2 ; PQ=PQ1),
   add_to_propagator_queue(MemRes,Y,PQ,NewPQ,Done),
   image_for_list_relation_propagate(T,S,PQ,NewPQ,Done,Count).

:- block terminate_propagator_queue(-,?).
terminate_propagator_queue(0,PQ) :-
  (PQ=empty -> true ;
    var(PQ) -> fail ; add_error_fail(terminate_propagator_queue,'Illegal tail (should be var): ',PQ)).
terminate_propagator_queue(s(X),PQ) :- terminate_propagator_queue2(PQ,X).
:- block terminate_propagator_queue2(-,?).
terminate_propagator_queue2(PQ,X) :-
  (PQ=solution(_,_,PQT) -> terminate_propagator_queue(X,PQT)
    ; add_error(terminate_propagator_queue2,'Illegal tail (should be solution/3): ',PQ)).

:- block add_to_propagator_queue(-,?,?,?,?).
add_to_propagator_queue(Result,ID,PropagatorQueue,NewPQ,Done) :-
  add_solution_to_queue(PropagatorQueue,Result,ID,NewPQ,Done).

add_solution_to_queue(PropagatorQueue,Result,ID,NewPQ,Done) :- %% print(add_prop(Result,ID,PropagatorQueue)),nl, %%
  (var(PropagatorQueue) -> PropagatorQueue = solution(Result,ID,NewPQ), Done=true
   ; PropagatorQueue = solution(_,_,Tail) -> add_solution_to_queue(Tail,Result,ID,NewPQ,Done)
   ; add_error_fail(add_solution_to_queue,'Illegal PropagatorQueue: ', PropagatorQueue)
  ).
  */
% -------------------- END of experimental version for image
