
% closure (reflexive) now done in ast_cleanup:

/* reflexive & transitive closure */
closure0_for_explicit_set(avl_set(A),Res) :-
   avl_domain(A,List),
   closure1_for_explicit_set(avl_set(A),Res1),
   (Res1==[] -> A2=empty ; Res1 = avl_set(A2)),
   add_id_pairs(List,none,A2,A3),
   construct_avl_set(A3,S3),
   kernel_objects:equal_object(Res,S3,closure0_for_explicit_set).

add_id_pairs([],_,R,R).
add_id_pairs([Key|T],LastX,AVL,Res) :-
    (Key = (X,Y) -> true ; add_error_and_fail(add_id_pairs,'Not a relation element: ',Key)),
    (X=Y -> AVL2=AVL /* must already be in closure1 result */
          ; (LastX==X -> AVL1=AVL ; avl_store((X,X),AVL,true,AVL1)), % already added
            avl_store((Y,Y),AVL1,true,AVL2)
    ),
    add_id_pairs(T,X,AVL2,Res).

/* FROM bsets_clp.pl: */

/* The transitive & reflexive closure of a relation */

:- assert_must_succeed((bsets_clp:relational_reflexive_closure([(int(1),int(4))],X),
                        kernel_objects:equal_object(X,[(int(1),int(1)),(int(1),int(4)),(int(4),int(4))]))).
:- assert_must_succeed((bsets_clp:relational_reflexive_closure([(int(1),int(4)),(int(4),int(2))],X),
                        kernel_objects:equal_object(X,[(int(1),int(1)),(int(2),int(2)),(int(4),int(4)),(int(1),int(4)),(int(4),int(2)),
                                             (int(1),int(2))]))).
:- assert_must_succeed((bsets_clp:relational_reflexive_closure([(int(1),int(4)),(int(4),int(2)),(int(2),int(3))],X),
kernel_objects:equal_object(X,[(int(1),int(1)),(int(2),int(2)),(int(3),int(3)),(int(4),int(4)),
                                      (int(1),int(4)),(int(4),int(2)),(int(2),int(3)),
                                             (int(4),int(3)),(int(1),int(2)),(int(1),int(3))]))).

:- block relational_reflexive_closure(-,?).
relational_reflexive_closure(Relation,Result) :-
    try_expand_and_convert_to_avl_with_check(Relation,ARelation,relational_reflexive_closure),
    relational_reflexive_closure2(ARelation,Result).
:- block relational_reflexive_closure2(-,?).
relational_reflexive_closure2(ARelation,Result) :- % print_term_summary(closure(ARelation,Result)),
    (closure0_for_explicit_set(ARelation,Res)
      -> kernel_objects:equal_object(Res,Result)
      ; (expand_custom_set_to_list(ARelation,ERelation,_,relational_reflexive_closure2),
         is_full_relation(ERelation,WaitVar),
         compute_trans_closure(ERelation,Result1,WaitVar),
        % print(adding_id(ERelation,Result1)),nl,
         rel_iterate0(ERelation,Result1,Result)
        %, print(done(Result)),nl
        )
    ).

% -------------------
:- assert_must_succeed(exhaustive_kernel_check_wfdet(bsets_clp:in_closure0_membership_test_wf((int(11),int(12)),[(int(11),int(3))],pred_false,WF),WF)).
:- assert_must_succeed(exhaustive_kernel_check_wfdet(bsets_clp:in_closure0_membership_test_wf((int(11),int(11)),[(int(11),int(3))],pred_true,WF),WF)).
:- assert_must_succeed(exhaustive_kernel_check_wfdet(bsets_clp:in_closure0_membership_test_wf((int(11),int(3)),[(int(11),int(3))],pred_true,WF),WF)).

:- block in_closure0_membership_test_wf(?,-,?,?).
in_closure0_membership_test_wf((A,B),CSRelation,MemRes,WF) :-
    equality_objects_wf(A,B,MemRes1,WF),
    (MemRes1==pred_true -> MemRes=pred_true
      ; in_closure1_membership_test_wf((A,B),CSRelation,MemRes2,WF),
        b_interpreter_check:disjoin(MemRes1,MemRes2,MemRes,priority(1),priority(1000),WF)
    ).



/* not used at the moment:
% compute the worst case: max(card(rel[{x}]) for x:dom(rel))
% this can be done using a simple traversal
avl_out_degree(AS,Degree) :- avl_out_degree_aux(AS,'$none',0,0,_,_,Degree).
avl_out_degree_aux(empty,K,N,R,K,N,R).
avl_out_degree_aux(node((KeyFrom,_KeyTo),_true,_,L,R),CurKey,CurNr,DegreeSoFar,OutKey,OutNr,OutRes) :-
   avl_out_degree_aux(L,CurKey,CurNr,DegreeSoFar, OutKey1,OutNr1,OutRes1),
   (OutKey1 = KeyFrom -> NextNr is OutNr1+1, DegreeSoFar2 = OutRes1
     ; NextNr is 1,
      (OutNr1 > OutRes1 -> DegreeSoFar2 = OutNr1 ; DegreeSoFar2 = OutRes1)
    ),
   avl_out_degree_aux(R,KeyFrom,NextNr,DegreeSoFar2, OutKey,OutNr,OutRes).
*/
