% (c) 2009-2018 Lehrstuhl fuer Softwaretechnik und Programmiersprachen,
% Heinrich Heine Universitaet Duesseldorf
% This software is licenced under EPL 1.0 (http://www.eclipse.org/org/documents/epl-v10.html)


:- module(custom_explicit_sets,[is_set_value/2,
                                is_custom_explicit_set/1, is_custom_explicit_set/2, is_custom_explicit_set_nonvar/1,
                                %equal_explicit_sets/2,
                                equal_explicit_sets_wf/3,
                                not_equal_explicit_sets/2,
                                equality_explicit_sets/3,
                                is_empty_explicit_set/1, is_empty_explicit_set_wf/2, is_empty_closure_wf/4,
                                is_non_empty_explicit_set/1, is_non_empty_explicit_set_wf/2,
                                test_empty_explicit_set/2,
                                is_definitely_maximal_set/1,
                                explicit_set_cardinality/2,  explicit_set_cardinality_wf/3,
                                explicit_set_cardinality_for_wf/2,
                                card_for_specific_custom_set/3,  % only succeeds if we can compute it efficiently
                                efficient_card_for_set/3, % same, but also for lists
                                quick_custom_explicit_set_approximate_size/2, avl_approximate_size/2,
                                is_infinite_explicit_set/1, is_infinite_closure/3,
                                is_infinite_global_set/1,
                                dont_expand_this_explicit_set/1, dont_expand_this_explicit_set/2,
                                dont_expand_symbolic_explicit_set/1,
                                definitely_expand_this_explicit_set/1,
                                mark_closure_as_symbolic/2, mark_closure_as_recursive/2, mark_closure/3,
                                is_symbolic_closure/1, is_symbolic_closure/3,
                                is_recursive_closure/3,
                                is_infinite_or_very_large_explicit_set/1,
                                is_infinite_or_very_large_explicit_set/2,
                                is_cartesian_product_closure/3,
                                expand_custom_set/2, expand_custom_set_wf/4,
                                try_expand_custom_set/2, try_expand_custom_set_wf/4,
                                expand_custom_set_to_list/2, expand_custom_set_to_list/4,
                                expand_custom_set_to_list_gg/4,
                                try_expand_custom_set_to_list/4,
                                expand_interval_closure_to_avl/3,
                                expand_custom_set_to_list_now/2,
                                expand_closure_to_avl_or_list/5,
                                expand_only_custom_closure_global/3, %try_expand_only_custom_closure_global/2,
                                expand_and_convert_to_avl_set/2,
                                ord_list_to_avlset_direct/3, sorted_ground_normalised_list_to_avlset/3,
                                try_expand_and_convert_to_avl/2, convert_to_avl/2,
                                should_be_converted_to_avl_from_lists/1, should_be_converted_to_avl/1,
                                try_expand_and_convert_to_avl_with_check/3,
                                try_expand_and_convert_to_avl_unless_large/2,
                                try_expand_and_convert_to_avl_unless_very_large/2,
                                try_expand_and_convert_to_avl_if_smaller_than/3,
                                quick_propagation_element_information/4,
                                element_of_custom_set/2, element_of_custom_set_wf/3,
                                element_of_closure/5,
                                check_element_of_function_closure/6,
                                not_element_of_custom_set_wf/3,
                                membership_custom_set/3, membership_custom_set_wf/4, membership_avl_set_wf/4,
                                quick_test_avl_membership/3,

                                is_efficient_custom_set/1,
                                remove_minimum_element_custom_set/3,

                                is_maximal_global_set/1, quick_is_definitely_maximal_set/1,
                                is_one_element_custom_set/2, singleton_set/2,
                                construct_one_element_custom_set/2,

                                %closure0_for_explicit_set/2,
                                closure1_for_explicit_set/2, closure1_for_explicit_set_from/3,
                                check_in_domain_of_avlset/2,
                                domain_of_explicit_set/2, range_of_explicit_set/2,
                                is_avl_partial_function/1,
                                is_avl_total_function_over_domain/2,
                                quick_definitely_maximal_total_function_avl/1,
                                is_avl_relation/1,
                                is_avl_relation_over_domain/3,
                                is_avl_relation_over_range/3,
                                is_not_avl_relation_over_domain_range/4, is_not_avl_relation_over_range/3,
                                is_avl_sequence/1,
                                is_injective_avl_relation/2,
                                invert_explicit_set/2, union_of_explicit_set/3,
                                union_generalized_explicit_set/3,
                                difference_of_explicit_set_wf/4,
                                intersection_of_explicit_set_wf/4, intersection_with_interval_closure/3,
                                image_for_id_closure/3, image_for_explicit_set/4,
                                rel_composition_for_explicit_set/3,
                                element_can_be_added_or_removed_to_avl/1,
                                add_element_to_explicit_set/3, remove_element_from_explicit_set/3,
                                delete_element_from_explicit_set/3,
                                apply_to_avl_set/5,
                                min_of_explicit_set/2, max_of_explicit_set/2,
                                sum_or_mul_of_explicit_set/3,
                                %sum_of_range_custom_explicit_set/2, mul_of_range_custom_explicit_set/2,
                                domain_restriction_explicit_set_wf/4,
                                range_restriction_explicit_set_wf/4,
                                domain_subtraction_explicit_set_wf/4,
                                range_subtraction_explicit_set_wf/4,
                                override_pair_explicit_set/4,
                                direct_product_explicit_set/3,
                                override_custom_explicit_set/3,

                                subset_of_explicit_set/4, not_subset_of_explicit_set/4,
                            	test_subset_of_explicit_set/5,

                                conc_custom_explicit_set/2,
                                prefix_of_custom_explicit_set/4, suffix_of_custom_explicit_set/4,
                                concat_custom_explicit_set/3, prepend_custom_explicit_set/3,
                                append_custom_explicit_set/3,
                                tail_sequence_custom_explicit_set/4,
                                last_sequence_explicit_set/2, %first_sequence_explicit_set/2,
                                front_sequence_custom_explicit_set/2,
                                reverse_custom_explicit_set/2,
                                size_of_custom_explicit_set/3,

                                get_first_avl_elements/4,
                                construct_avl_from_lists/2, equal_avl_tree/2,
                                is_non_expanded_closure/1, % from closures
                                construct_closure/4, is_closure/4, % from closures
                                construct_member_closure/4, % from closures

                                construct_interval_closure/3,
                                is_interval_closure/3, is_interval_closure/5,
                                is_interval_closure_or_integerset/3,

                                is_powerset_closure/3,

                                dom_range_for_specific_closure/4,
                                dom_for_specific_closure/3,
                                dom_for_lambda_closure/2,
                                get_range_id_expression/3,
                                portray_custom_explicit_set/1,
                                closure_occurs_check/4
                                ]).

:- use_module(error_manager).
:- use_module(self_check).
:- use_module(library(avl)).
:- use_module(kernel_waitflags).
:- use_module(kernel_tools).
:- use_module(delay).
:- use_module(tools).
:- use_module(avl_tools).

:- use_module(module_information,[module_info/2]).
:- module_info(group,kernel).
:- module_info(description,'This module provides customised operations for the custom explicit set representations of ProB (closures, avl_sets and global_sets).').

:- use_module(tools_printing,[print_term_summary/1, print_error/1]).
:- use_module(preferences,[preference/2]).
:- use_module(kernel_objects,[equal_object/2, equal_object/3]).
:- use_module(kernel_freetypes,[enumerate_freetype/3,freetype_cardinality/2,
                                is_infinite_freetype/1, is_empty_freetype/1,
                                is_non_empty_freetype/1, test_empty_freetype/2]).

:- use_module(closures).
:- use_module(b_compiler).

:- load_files(library(system), [when(compile_time), imports([environ/2])]).

/* These meta_predicate declarations do not seem to have the right effect;
   the predicates below return code, they do not get passed code
:- meta_predicate card_for_specific_custom_set(*,*,0).
:- meta_predicate card_for_specific_closure(*,*,0).
:- meta_predicate is_a_relation(*,*,*,*,*,*,0).
:- meta_predicate subset_of_explicit_set(*,*,0,*).
:- meta_predicate not_subset_of_explicit_set(*,*,0,*).
*/

construct_avl_from_lists(S,Res) :- (convert_to_avl(S,CS) -> true ; print(convert_to_avl_failed(S,CS)),nl,CS=S),
    %(CS=S -> true ; (print_term_summary(constructed_avl(S,CS)),nl)),
   % print(construct_avl_from_lists(S,CS,Res)),nl,
    Res = CS.

:- use_module(tools,[safe_sort/3]).
:- block normalised_list_to_avl_when_ground(-,?).
normalised_list_to_avl_when_ground(S,R) :- % call if you are not sure that S will be ground; e.g. after closure expansion
    ground_value_check(S,GS),
    blocking_normalised_list_to_avl(GS,S,R).
:- block blocking_normalised_list_to_avl(-,?,?).
blocking_normalised_list_to_avl(_,S,R) :- normalised_list_to_avl(S,R).

normalised_list_to_avl(S,R) :- safe_sort(normalised_list_to_avl,S,SS),
                               ord_list_to_avlset_direct(SS,AVL,normalised_list_to_avl),
			       equal_object(AVL,R). % due to co-routine, R can now be instantiated

%set_to_avl(List,R) :- empty_avl(A), add_to_avl(List,A,AR), R=avl_set(AR).
add_to_avl([],R,R).
add_to_avl([H|T],AVL,AVLOUT) :-  avl_store(H,AVL,true,AVL1),
   add_to_avl(T,AVL1,AVLOUT).


% get only the first x elements of an AVL tree
get_first_avl_elements(empty,_,R,all) :- !,R=[].
get_first_avl_elements(AVL,X,FirstXEls,CutOff) :-
   avl_min(AVL,Min), get_first_els(X,Min,AVL,FirstXEls,CutOff).

get_first_els(X,_,_AVL,R,CutOff) :- X<1,!,R=[], CutOff=not_all.
get_first_els(X,Cur,AVL,[Cur|T],CutOff) :-
    (avl_next(Cur,AVL,Nxt) ->  X1 is X-1,get_first_els(X1,Nxt,AVL,T,CutOff)
     ; T=[],CutOff=all).

%expand_and_try_convert_to_avl(C,R) :- is_closure(C,_,_,_), expand_custom_set(C,EC), expand_and_convert_to_avl
%expand_and_convert_to_avl(C,R) :- convert_to_avl(C,R).

 /* convert all list data-values (with all-sub-values) into avl-form */
 /* assumption: the value is ground when convert_to_avl is called */

:- load_files(library(system), [when(compile_time), imports([environ/2])]).
:- if(environ(prob_safe_mode,true)).
convert_to_avl(X,R) :- \+ ground_value(X), !, add_error(convert_to_avl,'Non-ground argument: ',convert_to_avl(X,R)), R=X.
:- endif.
convert_to_avl(X,R) :- var(X), !, add_error(convert_to_avl,'Variable argument: ',convert_to_avl(X,R)), R=X.
convert_to_avl(closure(P,T,B),R) :- !, % print(not_converting_closure(P)),nl, %trace,
    R=closure(P,T,B).
%convert_to_avl(closure_x(_P,_T,_B,E),R) :- !, convert_to_avl(E,R).
convert_to_avl(avl_set(A),R) :- !,(A==empty -> add_warning(convert_to_avl,'Emtpy avl_set'), R=[]
   ;  R=avl_set(A)).
convert_to_avl([],R) :- !,R=[].
convert_to_avl((A,B),(CA,CB)) :- !,convert_to_avl(A,CA), convert_to_avl(B,CB).
convert_to_avl(fd(A,T),R) :- !, R=fd(A,T).
convert_to_avl(int(X),R) :- !, R=int(X).
convert_to_avl(string(X),R) :- !, R=string(X).
convert_to_avl(term(X),R) :- !, R=term(X).
convert_to_avl(freetype(X),R) :- !, R=freetype(X).
convert_to_avl(freeval(ID,Case,Value),R) :- !, R=freeval(ID,Case,CValue),convert_to_avl(Value,CValue).
convert_to_avl(pred_false /* bool_false */,R) :- !, R=pred_false /* bool_false */.
convert_to_avl(pred_true /* bool_true */,R) :- !, R=pred_true /* bool_true */.
convert_to_avl(rec(Fields),R) :- !, convert_fields(Fields,CFields), R=rec(CFields).
convert_to_avl(global_set(GS),R) :- !, R=global_set(GS).
convert_to_avl([H|T],R) :- !, convert_cons_to_avl_inside_set(H,T,R).
%convert_to_avl(abort(X),_R) :- print(deprecetated_convert_to_avl(abort(X))),nl,!, fail.
convert_to_avl(X,R) :- add_internal_error('Unknown term: ',convert_to_avl(X,R)), R=X.


convert_fields(Var,R) :- var(Var),!,
   add_internal_error('Var arg: ',convert_fields(Var,R)),fail.
convert_fields([],[]).
convert_fields([field(FieldName,Value)|T],[field(FieldName,CValue)|CT]) :-
   convert_to_avl_inside_set(Value,CValue),
   convert_fields(T,CT).

l_convert_to_avl([],[]).
l_convert_to_avl(avl_set(A),R) :- expand_custom_set(avl_set(A),ES,l_convert_to_avl),
    l_convert_to_avl(ES,R).
l_convert_to_avl(closure(P,T,B),R) :- expand_custom_set(closure(P,T,B),ES,l_convert_to_avl),
    l_convert_to_avl(ES,R).
l_convert_to_avl([H|T],[CH-true|CT]) :- convert_to_avl_inside_set(H,CH), l_convert_to_avl(T,CT).

%add_true([],[]).
%add_true([H|T],[H-true|TT]) :- add_true(T,TT).


:- assert_must_succeed((X=(fd(1,'Name'),fd(2,'Name')),
  custom_explicit_sets:convert_to_avl_inside_set(X,R), R==X)).

convert_to_avl_inside_set(Var,R) :- var(Var),!,
   add_internal_error('Var arg: ',convert_to_avl_inside_set(Var,R)),fail.
:- if(environ(prob_safe_mode,true)).
convert_to_avl_inside_set(fd(A,T),R) :- var(A),!,
   add_error(convert_to_avl,'Non-ground FD-Term: ',convert_to_avl_inside_set(fd(A,T),R)), R=fd(A,T).
convert_to_avl_inside_set(int(X),R) :- var(X),!,
   add_error(convert_to_avl,'Non-ground integer: ',convert_to_avl_inside_set(int(X),R)), R=int(X).
convert_to_avl_inside_set(string(X),R) :- var(X),!,
   add_error(convert_to_avl,'Non-ground string: ',convert_to_avl_inside_set(string(X),R)), R=string(X).
:- endif.
convert_to_avl_inside_set(closure(P,T,B),R) :- !,
   expand_closure_to_avl(P,T,B,R).  % inside a set, the closure needs to be expanded to check against other elements
%convert_to_avl_inside_set(closure_x(_P,_T,_B,E),R) :- !, convert_to_avl_inside_set(E,R).
convert_to_avl_inside_set(avl_set(A),R) :- !, normalise_avl_set(A,R).  %AVL's inside other AVL's need to be normalised !
convert_to_avl_inside_set([],R) :- !,R=[].
convert_to_avl_inside_set((A,B),(CA,CB)) :- !,convert_to_avl_inside_set(A,CA), convert_to_avl_inside_set(B,CB).
convert_to_avl_inside_set(fd(A,T),R) :- !, R=fd(A,T).
convert_to_avl_inside_set(int(X),R) :- !, R=int(X).
convert_to_avl_inside_set(string(X),R) :- !, R=string(X).
convert_to_avl_inside_set(term(X),R) :- !, R=term(X).
convert_to_avl_inside_set(freetype(X),R) :- !,
    expand_custom_set(freetype(X),EC,check), convert_to_avl_inside_set(EC,R).
convert_to_avl_inside_set(freeval(ID,Case,Value),R) :- !,
     R=freeval(ID,Case,CValue),convert_to_avl_inside_set(Value,CValue).
convert_to_avl_inside_set(rec(Fields),R) :- !, convert_fields(Fields,CFields), R=rec(CFields).
convert_to_avl_inside_set(pred_false /* bool_false */,R) :- !, R=pred_false /* bool_false */.
convert_to_avl_inside_set(pred_true /* bool_true */,R) :- !, R=pred_true /* bool_true */.
convert_to_avl_inside_set(global_set(GS),R) :- !,
    % first check if GS infinite integer set: in this case do not expand; there can be no confusion with finite avl_sets
    (is_infinite_global_set(GS) -> R = global_set(GS)
     ; expand_only_custom_closure_global(global_set(GS),EC,check), convert_to_avl_inside_set(EC,R)).
convert_to_avl_inside_set([H|T],R) :-  !,convert_cons_to_avl_inside_set(H,T,R).
convert_to_avl_inside_set(X,R) :- print(unknown_term_convert_to_avl_inside_set(X)),nl, R=X.

normalise_avl_set(A,R) :- A=node(_,_,0,empty,empty), !,R=avl_set(A).
normalise_avl_set(A,R) :-
  avl_to_list(A,L),
  ord_list_to_avlset_direct(L,R,convert_to_avl_inside_set).  %AVL's inside other AVL's need to be normalised !

convert_cons_to_avl_inside_set(H,T,R) :- T==[], !,
   convert_to_avl_inside_set(H,CH),
   R = avl_set(node(CH,true,0,empty,empty)).
convert_cons_to_avl_inside_set(H,T,R) :- l_convert_to_avl([H|T],S),
   sort(S,SS),
   ord_list_to_avlset_direct(SS,R,convert_to_avl_inside_set).

/*
a sort that checks that there are no repetitions; throws errors for set_extension findall conversions
:- use_module(library(samsort)).
%mysort(S,SS) :- !, sort(S,SS).
mysort(S,SS2) :- samsort(S,SS),
     check_repetition(SS),
     sort(SS,SS2).

check_repetition([]).
check_repetition([H|T]) :- check_repetition_aux(T,H).
check_repetition_aux([],_).
check_repetition_aux([H|T],Prev) :-
   (H=Prev -> add_internal_error('Repeated element in list: ',H),trace
    ; check_repetition_aux(T,H)).
*/

is_set_value(X,Origin) :- var(X), !,print(is_set_value(Origin)),nl,fail.
is_set_value([],_) :- !.
is_set_value([_|_],_) :- !.
is_set_value(X,_) :- is_custom_explicit_set(X).

is_custom_explicit_set(X,Origin) :- var(X), !,print(var_is_custom_explicit_set(Origin)),nl,fail.
is_custom_explicit_set(X,_) :- is_custom_explicit_set(X).

is_custom_explicit_set(X) :- var(X), !,print(var_is_custom_explicit_set),nl,fail.
is_custom_explicit_set(global_set(_)).
is_custom_explicit_set(freetype(_)).
%is_custom_explicit_set(integer_global_set(_)).
is_custom_explicit_set(avl_set(_)).
%is_custom_explicit_set(closure_x(_Parameters,_PT,_Cond,_Exp)).
is_custom_explicit_set(closure(_Parameters,_PT,_Cond)).

% use if you know the argument to be nonvar
is_custom_explicit_set_nonvar(global_set(_)).
is_custom_explicit_set_nonvar(freetype(_)).
is_custom_explicit_set_nonvar(avl_set(_)).
is_custom_explicit_set_nonvar(closure(_Parameters,_PT,_Cond)).

:- assert_must_succeed(( custom_explicit_sets:portray_custom_explicit_set(avl_set(empty)) )).
:- use_module(translate,[translate_bvalue/2]).
portray_custom_explicit_set(S) :- translate:translate_bvalue(S,A), format(A,[]),nl.

/* a predicate to check equality of two custom explicit sets */

%equal_explicit_sets(A,B) :- equal_explicit_sets_wf(A,B,no_wf_available).

%equal_explicit_sets(X,Y) :- print_term_summary(equal_explicit_sets(X,Y)),fail.
:- block equal_explicit_sets_wf(-,?,?), equal_explicit_sets_wf(?,-,?).
equal_explicit_sets_wf(A,B,WF) :- equal_explicit_sets4(A,B,allow_expansion,WF).

%equal_explicit_sets4(A,B,R,_WF) :- print(eqxs(A,B,R)),nl,fail.
equal_explicit_sets4(global_set(X),global_set(Y),_,_WF) :- !,X=Y.
equal_explicit_sets4(global_set(B),avl_set(A),E,WF) :- !,equal_explicit_sets4(avl_set(A),global_set(B),E,WF).
equal_explicit_sets4(freetype(X),freetype(Y),_,_WF) :- !,X=Y.
equal_explicit_sets4(avl_set(A),avl_set(B),_,_WF) :- !,
    equal_avl_tree(A,B). %, print(equal),nl. % alternatively, we could normalise avl_trees and only store normalised versions
equal_explicit_sets4(avl_set(A),I2,_,_WF) :-
    is_interval_closure_or_integerset(I2,L2,U2),!, % also covers I2=global_set(...)
    avl_equal_to_interval(A,L2,U2).
equal_explicit_sets4(avl_set(A),global_set(B),_,_WF) :-  \+ b_global_sets:b_integer_set(B), !, % integersets dealt with above
   explicit_set_cardinality(global_set(B),Card), %print(check_equal(B,Card)),nl,
   Card \= inf, %as avl_set must be finite
   explicit_set_cardinality(avl_set(A),Card). /* the sets must be identical as global_set contains all values */
equal_explicit_sets4(closure(P,T,B),avl_set(A),E,WF) :- !, equal_explicit_sets4(avl_set(A),closure(P,T,B),E,WF).
equal_explicit_sets4(I1,I2,_,_WF) :- is_interval_closure_or_integerset(I1,L1,U1),
   is_interval_closure_or_integerset(I2,L2,U2), !,  %print(eq_interval(L1,U1,L2,U2)),nl,
   L1=L2, U1=U2.
equal_explicit_sets4(CPA,CPB,_,_WF) :-
   is_cartesian_product_closure(CPA,A1,A2), is_cartesian_product_closure(CPB,B1,B2),!,
   %print_term_summary(equal_cartesian(A1,A2,B1,B2)),
   equal_cartesian_product(A1,A2,B1,B2).
% what if both subset or relations or functions ... closure: TO DO: add support
equal_explicit_sets4(S1,S2,_,WF) :-
   is_not_member_value_closure_or_integerset(S1,TYPE,MS1),
   is_not_member_value_closure_or_integerset(S2,TYPE,MS2),
   !,
   kernel_objects:equal_object_wf(MS1,MS2,equal_explicit_sets4,WF).
equal_explicit_sets4(closure(P,T,B),closure(P,T,B2),_,_WF) :-
       % nl,print(check_eq),nl,print(B),nl,print(B2),nl, %
    same_texpr_body(B,B2),!.
%equal_explicit_sets4(X,Y) :-   X==Y,!.
equal_explicit_sets4(Set1,Set2,allow_expansion,WF) :- % print(eq(Set1,Set2)),nl,
    %kernel_objects:test_finite_set(Set1,F1), kernel_objects:test_finite_set(Set2,F2), equal_expansions(F1,F2,Set1,Set2)
    card_for_specific_custom_set(Set1,Card1,Code1), card_for_specific_custom_set(Set2,Card2,Code2),
    !,
    call(Code1), call(Code2),
    % TO DO: if one of the two sets is infinite, then it would be enough to know that the other is not infinite for failure without expansion
    equal_expansions(Card1,Card2,Set1,Set2,WF).
equal_explicit_sets4(Set1,Set2,allow_expansion,WF) :- equal_expansions(0,0,Set1,Set2,WF).

:- block equal_expansions(-,?,?,?,?).
equal_expansions(F1,F2,Set1,Set2,WF) :- (number(F1);number(F2)),!,
% NOTE: sometimes we get inf for finite but very large sets
    F1=F2, % unify; can propagate info back to closure; e.g.  prj2(BOOL,NAT) = prj2(BOOL,0..n)
    equal_expansions2(F1,F2,Set1,Set2,WF).
equal_expansions(F1,F2,Set1,Set2,WF) :-
    %print(eq(F1,F2,Set1,Set2)),nl,
    equal_expansions2(F1,F2,Set1,Set2,WF).

:- block equal_expansions2(-,?,?,?,?), equal_expansions2(?,-,?,?,?).
%equal_expansions(0,0,avl_set(A),closure(P,T,B)) :- check_subset ?? in both directions ?
%equal_expansions2(inf,inf,Set1,Set2,WF) :- WF \= no_wf_available, !, % symbolic treatment
equal_expansions2(F,F,Set1,Set2,WF) :-
    % only expand if both sets have same cardinality
    % print_term_summary(equal_expansion(F,Set1,Set2)),nl,
    equal_expansions3(Set1,Set2,WF).

% TO DO: check if this brings something:
%equal_expansions3(avl_set(A),closure(P,T,B),_WF) :- !,
%    expand_closure_to_avl_or_list(P,T,B,E2,check), % in case E2 is avl_set; we can use equal_avl_tree
%    ((nonvar(E2),E2=avl_set(B2))
%     -> print(eql_avl),nl, print_term_summary(equal_avl_tree(A,B2)),nl, equal_avl_tree(A,B2)
%      ; print(eql_non_avl),nl,equal_object(avl_set(A),E2,equal_expansions3)
%    ).
equal_expansions3(Set1,Set2,WF) :-
    expand_custom_set_wf(Set1,E1,equal_expansions1,WF), % print_term_summary(expanded_set1(E1)),nl,
    expand_custom_set_wf(Set2,E2,equal_expansions2,WF),
    %  print_term_summary(check_equal_exp(E1,E2)),nl,
    E1=E2.  /* ensure that ordering is same for all representations ! */
% for two closures: we could try and solve a constraint instead: that !Paras.(Body1 <=> Body2) ??


:- use_module(kernel_equality,[eq_atomic/4, equality_objects/3]).
/* maybe rewrite equal_explicit_sets and not_... to use this to avoid maintaining multiple versions */
equality_explicit_sets(global_set(X),global_set(Y),R) :- !, kernel_equality:eq_atomic(X,Y,set,R).
equality_explicit_sets(global_set(B),avl_set(A),R) :- !,equality_explicit_sets(avl_set(A),global_set(B),R).
equality_explicit_sets(freetype(X),freetype(Y),R) :- !, kernel_equality:eq_atomic(X,Y,set,R).
equality_explicit_sets(avl_set(A),avl_set(B),R) :- !,
    (equal_avl_tree(A,B) -> R=pred_true ; R=pred_false). % alternatively, we could normalise avl_trees and only store normalised versions
equality_explicit_sets(avl_set(A),I2,R) :- is_interval_closure_or_integerset(I2,L2,U2),!, % also covers I2=global_set(...)
    avl_equality_to_interval(A,L2,U2,R).
equality_explicit_sets(avl_set(A),global_set(B),R) :-  \+ b_global_sets:b_integer_set(B), !,
   explicit_set_cardinality(global_set(B),Card), %print(check_equal(B,Card)),nl,
   ((Card \= inf, %as avl_set must be finite
     explicit_set_cardinality(avl_set(A),Card))
     -> R=pred_true /* the sets must be identical as global_set contains all values */
     ;  R=pred_false).
equality_explicit_sets(closure(P,T,B),avl_set(A),R) :- !, equality_explicit_sets(avl_set(A),closure(P,T,B),R).
equality_explicit_sets(I1,I2,R) :- is_interval_closure_or_integerset(I1,L1,U1),
   is_interval_closure_or_integerset(I2,L2,U2), !, %print(eq_interval(L1,U1,L2,U2)),nl,
   equality_objects((int(L1),int(U1)),(int(L2),int(U2)),R).
equality_explicit_sets(CPA,CPB,R) :-
   is_cartesian_product_closure(CPA,A1,A2), is_cartesian_product_closure(CPB,B1,B2),!,
   % print_term_summary(equality_cartesian(A1,A2,B1,B2)),
   equality_cartesian_product(A1,A2,B1,B2,R).
equality_explicit_sets(S1,S2,R) :-
   is_not_member_value_closure_or_integerset(S1,TYPE,MS1),
   is_not_member_value_closure_or_integerset(S2,TYPE,MS2),!,
   kernel_equality:equality_objects_with_type(TYPE,MS1,MS2,R).
equality_explicit_sets(closure(P,T,B),closure(P,T,B2),R) :-
     % print(check_eq),nl,print(B),nl,print(B2),nl,
    same_texpr_body(B,B2),!,R=pred_true.
% TO DO: add complement sets

/* Cartesian Product Comparison */
:- use_module(kernel_equality,[empty_cartesian_product/3]).
% A1*A2 = B1*B2  <=>  (((A1={} or A2={}) & (B1={} or B2={})) or (A1=B1 & A2=B2))
equal_cartesian_product(A1,A2,B1,B2) :- equality_cartesian_product(A1,A2,B1,B2,pred_true).
not_equal_cartesian_product(A1,A2,B1,B2) :- equality_cartesian_product(A1,A2,B1,B2,pred_false).

equality_cartesian_product(A1,A2,B1,B2,R) :- empty_cartesian_product(A1,A2,EmptyA),
   equality_cart_product2(EmptyA,A1,A2,B1,B2,R).
:- block equality_cart_product2(-, ?,?,?,?,?).
equality_cart_product2(pred_true,_,_,B1,B2,R) :- empty_cartesian_product(B1,B2,R).
equality_cart_product2(pred_false,A1,A2,B1,B2,R) :- equality_objects((A1,A2),(B1,B2),R). % TO DO: call equality_objects_wf

/* COMPARING AVL-SET with INTERVAL */

% check if an avl tree is equal to an interval range
avl_equal_to_interval(_A,L2,U2) :- %print(equal_interval(L2,U2)),nl,
   infinite_interval(L2,U2),!,fail. % otherwise infinite & avl_set is finite
% we can now assume L2, U2 are numbers (but could not yet be instantiated)
avl_equal_to_interval(A,L2,U2) :- %print(check_avl_interval(A,L2,U2)),nl,
    avl_min(A,int(L2)), avl_max(A,int(U2)),
    Card is 1+U2-L2, %print(Card),nl,
    explicit_set_cardinality(avl_set(A),Card). % sets are equal: same size + same lower & upper bound

avl_not_equal_to_interval(A,L2,U2) :- avl_equality_to_interval(A,L2,U2,pred_false).

avl_equality_to_interval(_A,L2,U2,R) :-
    infinite_interval(L2,U2),!,R=pred_false. % interval infinite & avl_set is finite
% we can now assume L2, U2 are numbers (but could not yet be instantiated)
avl_equality_to_interval(A,L2,U2,R) :-  % print(avl_equality_to_interval(L2,U2)),nl,
    avl_min(A,int(AL)), avl_max(A,int(AU)),
    Card is 1+AU-AL, %print(Card),nl,
    explicit_set_cardinality(avl_set(A),ACard),
    equality_objects((int(ACard),(int(AL),int(AU))),
                     (int(Card),(int(L2),int(U2))),R). % sets are equal if same size + same lower & upper bound

/* COMPARING TWO CLOSURES */

% check if two wrapped expressions are equal (modulo associated Info, e.g. source loc info)
% and checking inserted values for equality (sometimes storing a closure will convert small inner closures into AVL sets)
same_texpr_body(E1,E2) :- empty_avl(E),same_texpr_body(E1,E,E2).
same_texpr_body(b(E1,Type,_),AVL,b(E2,Type,_)) :- same_texpr2(E1,AVL,E2).

:- use_module(bsyntaxtree,[safe_syntaxelement/5, is_set_type/2]).
same_texpr2(value(V1),_,value(V2)) :- !,same_value_inside_closure(V1,V2).
same_texpr2(lazy_let_expr(ID,LHS,RHS),AVL,lazy_let_expr(ID2,LHS2,RHS2)) :- !,
   same_texpr_body(LHS,AVL,LHS2),
   avl_store(ID,AVL,ID2,NewAVL),
   same_texpr_body(RHS,NewAVL,RHS2).
same_texpr2(lazy_let_pred(ID,LHS,RHS),AVL,lazy_let_pred(ID2,LHS2,RHS2)) :- !,
   same_texpr_body(LHS,AVL,LHS2),
   avl_store(ID,AVL,ID2,NewAVL),
   same_texpr_body(RHS,NewAVL,RHS2).
same_texpr2(lazy_lookup(ID1), AVL,lazy_lookup(ID2)) :- !, avl_fetch(ID1,AVL,ID2).
same_texpr2(E1,AVL,E2) :-
  functor(E1,F,Arity),
  functor(E2,F,Arity),
  safe_syntaxelement(E1,Subs1,_Names1,_List1,Constant),
  safe_syntaxelement(E2,Subs2,_Names2,_List2,Constant),
  same_sub_expressions(Subs1,AVL,Subs2).

allow_expansion(avl_set(_),closure(P,T,B)) :- is_small_specific_custom_set(closure(P,T,B),100).
allow_expansion(closure(P,T,B),avl_set(_)) :- is_small_specific_custom_set(closure(P,T,B),100).

same_sub_expressions([],_,[]).
same_sub_expressions([H1|T1],AVL,[H2|T2]) :- same_texpr_body(H1,AVL,H2),
   same_sub_expressions(T1,AVL,T2).

same_value_inside_closure(V1,V2) :- var(V1),!, V1==V2.
same_value_inside_closure(_,V2) :- var(V2),!,fail.
same_value_inside_closure(rec(Fields1),rec(Fields2)) :- !,
   % sets of records come in this form: struct(b(value(rec(FIELDS)),record(_),_))
   same_fields_inside_closure(Fields1,Fields2).
same_value_inside_closure(V1,V2) :- % print(check_eq(V1,V2)),nl,
     % we could attempt this only if the outer closure was large/infinite ??
     is_custom_explicit_set(V1), is_custom_explicit_set(V2),
     !,
     (allow_expansion(V1,V2) -> EXP=allow_expansion ; EXP = no_expansion),
     equal_explicit_sets4(V1,V2,EXP,no_wf_available). % usually only sets compiled differently inside closures
same_value_inside_closure(V1,V2) :- V1==V2.

same_fields_inside_closure(V1,V2) :- var(V1),!, V1==V2.
same_fields_inside_closure(_,V2) :- var(V2),!,fail.
same_fields_inside_closure([],[]).
same_fields_inside_closure([field(Name,V1)|T1],[field(Name,V2)|T2]) :-
    same_value_inside_closure(V1,V2),
    same_fields_inside_closure(T1,T2).

/*
same_texpr_body_debug(H1,H2) :-
   (same_texpr_body(H1,H2) -> true
      ; print('FAIL: '),nl,
        translate:print_bexpr(H1),nl, translate:print_bexpr(H2),nl, print(H1),nl, print(H2),nl, fail). */

%test(Y2,Z2) :- empty_avl(X), avl_store(1,X,2,Y), avl_store(2,X,3,Z),
%      avl_store(2,Y,3,Y2), avl_store(1,Z,2,Z2), equal_avl_tree(Y2,Z2).

%equal_avl_tree(A,B) :- avl_min(A,Min), avl_min(B,Min), cmp(Min,A,B).
%cmp(El,A,B) :-
%  (avl_next(El,A,Nxt) -> (avl_next(El,B,Nxt), cmp(Nxt,A,B))
%     ; \+ avl_next(El,B,Nxt) ).

% The following is faster than using avl_next
equal_avl_tree(A,B) :-
%   statistics(walltime,[WT1,_]),if(equal_avl_tree2(A,B),true,(statistics(walltime,[_,W]),print(wall(W)),nl)).
%equal_avl_tree2(A,B) :-
  avl_min(A,Min),
  !,
  avl_min(B,Min),
  avl_max(A,Max), avl_max(B,Max),
  % maybe also check avl_height +/- factor of 1.4405 (page 460, Knuth 3) ? but it seems this would trigger only extremely rarely
  %avl_height(A,H1), avl_height(A,H2), log(check(Min,Max,H1,H2)),
  avl_domain(A,L), avl_domain(B,L).
equal_avl_tree(empty,_) :- !, format(user_error,'*** Warning: empty AVL tree in equal_avl_tree~n',[]).
equal_avl_tree(A,B) :- add_internal_error('Illegal AVL tree: ',equal_avl_tree(A,B)),fail.

/* a predicate to check equality of two custom explicit sets */

:- block not_equal_explicit_sets(-,?), not_equal_explicit_sets(?,-).
%not_equal_explicit_sets(X,Y) :- print_term_summary(not_equal_explicit_sets(X,Y)),nl,fail.
not_equal_explicit_sets(global_set(X),global_set(Y)) :- !,dif(X,Y).
not_equal_explicit_sets(global_set(B),avl_set(A)) :- !,
    \+ equal_explicit_sets4(avl_set(A),global_set(B),allow_expansion,no_wf_available).
not_equal_explicit_sets(freetype(X),freetype(Y)) :- !,dif(X,Y).
not_equal_explicit_sets(avl_set(A),avl_set(B)) :- !,
    \+ equal_avl_tree(A,B). %, print(not_equal),nl.
%not_equal_explicit_sets(X,Y) :- X==Y,!,fail.
not_equal_explicit_sets(avl_set(A),I2) :- is_interval_closure_or_integerset(I2,L2,U2),!, % also covers I2=global_set(...)
    avl_not_equal_to_interval(A,L2,U2).
not_equal_explicit_sets(avl_set(A),global_set(B)) :- !,
  \+ equal_explicit_sets4(avl_set(A),global_set(B),allow_expansion,no_wf_available).
not_equal_explicit_sets(closure(P,T,B),avl_set(A)) :- !,
   not_equal_explicit_sets(avl_set(A),closure(P,T,B)).
not_equal_explicit_sets(I1,I2) :- is_interval_closure_or_integerset(I1,L1,U1),
  is_interval_closure_or_integerset(I2,L2,U2), !, %print(neq_interval(L1,U1,L2,U2)),nl,
  dif((L1,U1),(L2,U2)). % maybe we should call not_equal_objects on integers (not on inf values)?
not_equal_explicit_sets(CPA,CPB) :-
   is_cartesian_product_closure(CPA,A1,A2), is_cartesian_product_closure(CPB,B1,B2),!,
   %print_term_summary(not_equal_cartesian(A1,A2,B1,B2)),
   not_equal_cartesian_product(A1,A2,B1,B2).
not_equal_explicit_sets(S1,S2) :-
   is_not_member_value_closure_or_integerset(S1,TYPE,MS1),
   is_not_member_value_closure_or_integerset(S2,TYPE,MS2),!,
   kernel_objects:not_equal_object(MS1,MS2).
not_equal_explicit_sets(closure(P,T,B),closure(P,T,B2)) :-
    % print(check_eq),nl,print(B),nl,print(B2),nl,
    same_texpr_body(B,B2),!,fail.
% TO DO: maybe support interval & avl_set comparison
not_equal_explicit_sets(Set1,Set2) :-
    card_for_specific_custom_set(Set1,Card1,Code1), card_for_specific_custom_set(Set2,Card2,Code2),
    call(Code1), call(Code2),!,
    not_equal_expansions(Card1,Card2,Set1,Set2).
not_equal_explicit_sets(Set1,Set2) :- not_equal_expansions(0,0,Set1,Set2).


:- block not_equal_expansions(-,?,?,?), not_equal_expansions(?,-,?,?).
not_equal_expansions(F1,F2,_,_) :- F1 \= F2,!. % sets guaranteed to be different
not_equal_expansions(F,F,Set1,Set2) :-
    % only expand if both sets have same cardinality
    expand_custom_set(Set1,E1,not_equal_expansions1),
    expand_custom_set(Set2,E2,not_equal_expansions2),
   %  print_term_summary(check_equal_exp(E1,E2)),nl,
    dif(E1,E2).  /* ensure that ordering is same for all representations ! */
% for two closures: we could try and solve a constraint instead: that !Paras.(Body1 <=> Body2) ??

:- use_module(b_global_sets,[b_empty_global_set/1, b_non_empty_global_set/1, b_global_set_cardinality/2]).
is_empty_explicit_set_wf(closure(P,T,B),WF) :- !,
   is_empty_closure_wf(P,T,B,WF).
is_empty_explicit_set_wf(S,_WF) :- is_empty_explicit_set(S).

   % with WF we can delay computing Card; see test 1272 / card({x|x:1..10 & x*x<i}) = 0 & i>1
% TO DO: ideally we could just write this: is_empty_closure_wf(P,T,B,WF) :- closure_cardinality(P,T,B,0,WF). ; but empty_set / not_exists optimisation not triggered in closure_cardinality (yet); would avoid duplicate code
is_empty_closure_wf(P,T,B,WF) :-   % translate:print_bvalue(closure(P,T,B)),nl,%trace,
    is_lambda_value_domain_closure(P,T,B, DomainValue,_Expr),!,
    kernel_objects:empty_set_wf(DomainValue,WF).
is_empty_closure_wf(P,T,B,WF) :- is_cartesian_product_closure_aux(P,T,B,A1,A2),!,
    very_approximate_cardinality(A1,C1,WF),
    very_approximate_cardinality(A2,C2,WF),   % print(cart_closure_card(C1,C2)),nl,
    blocking_safe_mul(C1,C2,0).
is_empty_closure_wf(P,T,B,_WF) :-
   card_for_specific_closure2(P,T,B,CC,Code),!,call(Code),CC=0.
is_empty_closure_wf(P,T,Body,WF) :-
    WF \== no_wf_available, % only do this if we have a WF store; see comments for closure_cardinality ; code relevant for test 1272; card({x|x:1..10 & x*x<i}) = 0 & i>1
    \+ ground_bexpr(Body), % otherwise better to use not_test_exists below (e.g., Bosch v6 Codespeed benchmark)
    b_interpreter_check:reify_closure_with_small_cardinality(P,T,Body, WF, ReifiedList),
    !,
    clpfd:domain(ReifiedList,0,1),
    clpfd:sum(ReifiedList,'#=',0).
is_empty_closure_wf(P,T,B,WF) :-  !,  % try and check that not(#(P).(B)); i.e., there is no solution for the Body B; solves tests 1542, detecting that {x|x>100 & x mod 102 = 2} = {} is false
    % print(empty_closure_test(P)),nl, translate:print_bexpr(B),nl,
    gen_typed_ids(P,T,TypedParas),
    b_interpreter:b_not_test_exists(TypedParas,B,[used_ids([])],[],[],WF). % used_ids are empty, as all variables already compiled into values

% very_approximate_cardinality: only required to return 0 for empty set, and number or inf for non-empty set, tested in 1893
:- block very_approximate_cardinality(-,?,?).
very_approximate_cardinality(avl_set(A),C,_) :- !, (A=empty -> print(empty_avl),nl,C=0 ; C=1).
very_approximate_cardinality([],C,_) :- !, C=0.
very_approximate_cardinality([_|_],C,_) :- !, C=1.
very_approximate_cardinality(Set,C,WF) :- kernel_objects:cardinality_as_int_wf(Set,int(C),WF).
% TO DO: maybe call is_empty_closure or similar for closures

gen_typed_ids([],[],[]).
gen_typed_ids([ID|IT],[Type|TT],[b(identifier(ID),Type,[])|TTT]) :- gen_typed_ids(IT,TT,TTT).


is_empty_explicit_set(global_set(GS)) :- !, b_empty_global_set(GS).
is_empty_explicit_set(freetype(ID)) :- !, kernel_freetypes:is_empty_freetype(ID).
is_empty_explicit_set(avl_set(A)) :- !,
   (var(A) -> add_warning(is_empty_explicit_set,'Variable avl_set')
   ; empty_avl(A), add_warning(is_empty_explicit_set,'Empty avl_set')
   ).
is_empty_explicit_set(C) :- card_for_specific_closure(C,CC,Code),!,call(Code),CC=0.
is_empty_explicit_set(ES) :- expand_custom_set(ES,[],is_empty_explicit_set).
 % alternative solution for closures: we could generate an Exists if Expansion not given

is_non_empty_explicit_set(CS) :- is_non_empty_explicit_set_wf(CS,no_wf_available).

is_non_empty_explicit_set_wf(global_set(GS),_WF) :- !, b_non_empty_global_set(GS).
is_non_empty_explicit_set_wf(freetype(ID),_WF) :- !, kernel_freetypes:is_non_empty_freetype(ID).
is_non_empty_explicit_set_wf(avl_set(A),_WF) :- !,
  (empty_avl(A) -> print('### Warning: empty avl_set (2)'),nl,fail
    ; true).
is_non_empty_explicit_set_wf(closure(P,T,B),WF) :- !, is_non_empty_closure_wf(P,T,B,WF).
%is_non_empty_explicit_set_wf(ES,_WF) :- expand_custom_set(ES,[_|_],is_non_empty_explicit_set).


% TO DO: this code is a bit redundant with is_empty_closure_wf
is_non_empty_closure_wf(P,T,B,WF) :-    %print(closure_card(P,T,B,Card,WF)),trace,
    is_lambda_value_domain_closure(P,T,B, DomainValue,_Expr),!,
    kernel_objects:not_empty_set_wf(DomainValue,WF).
is_non_empty_closure_wf(P,T,B,WF) :- is_cartesian_product_closure_aux(P,T,B,A1,A2),!,
    very_approximate_cardinality(A1,C1,WF),
    very_approximate_cardinality(A2,C2,WF),  %print(cart_closure_card(C1,C2)),nl,
    blocking_safe_mul(C1,C2,CC),gt0(CC).
is_non_empty_closure_wf(P,T,B,_WF) :-
   card_for_specific_closure2(P,T,B,CC,Code),!,call(Code),gt0(CC).
% TO DO: reify_closure_with_small_cardinality
is_non_empty_closure_wf(P,T,B,WF) :- WF \== no_wf_available, % otherwise enumeration of test_exists will behave strangely; leading to enumeration warnings,... [TO DO: ensure we always have a WF or fix this below ?]
    !,  % try and check that not(#(P).(B)); i.e., there is no solution for the Body B; solves tests 1542; test 1146 also triggers this code
    (debug_mode(off) -> true ; print(non_empty_closure_test(P)),nl, translate:print_bexpr(B),nl),
    gen_typed_ids(P,T,TypedParas),
    b_interpreter:b_test_exists(TypedParas,B,[used_ids([])],[],[],WF).   % used_ids are empty, as all variables already compiled into values
% some rules for set_subtraction, ... closures ?? if left part infinite and right part finite it must be infinite
is_non_empty_closure_wf(P,T,B,_WF) :-
   expand_custom_set(closure(P,T,B),[_|_],is_non_empty_closure_wf).

test_empty_explicit_set(V,Res) :- var(V),!,
  add_internal_error('Illegal call: ',test_empty_explicit_set(V,Res)),fail.
test_empty_explicit_set(global_set(GS),Res) :- !,
  (b_empty_global_set(GS) -> Res=pred_true ; Res=pred_false).
test_empty_explicit_set(freetype(ID),Res) :- !, kernel_freetypes:test_empty_freetype(ID,Res).
test_empty_explicit_set(avl_set(A),Res) :- !,
   (var(A) -> add_warning(test_empty_explicit_set,'Variable avl_set'), Res=pred_true
   ; empty_avl(A), add_warning(test_empty_explicit_set,'Empty avl_set'), Res = pred_true
   ; Res=pred_false).
test_empty_explicit_set(C,Res) :- card_for_specific_closure(C,CC,Code),!,call(Code),
   check_zero(CC,Res).
test_empty_explicit_set(ES,Res) :- expand_custom_set(ES,ExpES,test_empty_explicit_set),
    kernel_equality:eq_empty_set(ExpES,Res).

:- block check_zero(-,?).
check_zero(0,R) :- !, R=pred_true.
check_zero(_,pred_false).

:- block gt0(-).
gt0(CC) :- (CC=inf -> true ; CC>0).

% a version to compute cardinality for
explicit_set_cardinality_for_wf(closure(P,T,B),Card) :-
    is_symbolic_closure_or_symbolic_mode(P,T,B),!,
    Card = inf. % assume card is infinite for WF computation; it may be finite!
% TO DO: maybe never expand closures here !? -> closure_cardinality can expand closure !!!!!!
explicit_set_cardinality_for_wf(CS,Card) :-
    on_enumeration_warning(
        explicit_set_cardinality(CS,Card),
        (debug_println(assuming_inf_card_for_wf), % see test 1519 for relevance
         Card = inf)). % assume card is infinite for WF computation; it may be finite!

explicit_set_cardinality(CS,Card) :- explicit_set_cardinality_wf(CS,Card,no_wf_available).

explicit_set_cardinality_wf(global_set(GS),Card,_) :- !,b_global_set_cardinality(GS,Card).
explicit_set_cardinality_wf(freetype(GS),Card,_WF) :- !, freetype_cardinality(GS,Card).
explicit_set_cardinality_wf(avl_set(S),Card,_WF) :- !,avl_size(S,Card).
explicit_set_cardinality_wf(closure(P,T,B),Card,WF) :- closure_cardinality(P,T,B,Card,WF).

:- use_module(performance_messages).
closure_cardinality(P,T,B,Card,WF) :- %print(closure_card(P,T,B,Card,WF)),trace,
    is_lambda_value_domain_closure(P,T,B, DomainValue,_Expr),!,
    % print(lambda_closure_card(DomainValue)),nl,
    kernel_objects:cardinality_as_int_wf(DomainValue,int(Card),WF). % always compute it; card_for_specific_closure will only compute it if it can be done efficiently
closure_cardinality(P,T,B,Card,WF) :- is_cartesian_product_closure_aux(P,T,B,A1,A2),!,
    kernel_objects:cardinality_as_int_wf(A1,int(C1),WF),
    kernel_objects:cardinality_as_int_wf(A2,int(C2),WF),  %print(cart_closure_card(C1,C2)),nl,
    blocking_safe_mul(C1,C2,Card).
% TO DO: card_for_specific_closure2 calls is_lambda_value_domain_closure and is_cartesian_product_closure_aux again !
closure_cardinality(P,T,B,Card,_WF) :-
   card_for_specific_closure2(P,T,B,CC,Code),!,call(Code),Card=CC.
closure_cardinality(P,T,Body,Card,WF) :-
    (WF == no_wf_available -> CBody=Body
      ; %print('START COMPILE card: '),translate:print_bexpr(Body),nl,
        b_compiler:b_compile(Body,P,[],[],CBody)
        %,print(' COMPILED FOR card: '), translate:print_bexpr(CBody),nl
        %,nl,print(Body),nl, print(CBody),nl,nl
    ),
    % reify will work better if we used b_compiler:compile so that more sets can be detected as small
    closure_cardinality2(P,T,CBody,Card,WF).
closure_cardinality2(P,T,Body,Card,WF) :-
    % print(try_reify(P,WF)),nl,trace,
    WF \== no_wf_available, % only do this if we have a WF store
    if(b_interpreter_check:reify_closure_with_small_cardinality(P,T,Body, WF, ReifiedList),
       true,
       (perfmessagecall(reification_of_closure_for_card_failed(P),translate:print_bexpr(Body),Body),fail)),
    %print(reified_list(ReifiedList)),nl,
    !,
    clpfd:domain(ReifiedList,0,1),
    clpfd:sum(ReifiedList,'#=',Card),
    % in this case we know card to be finite ! TO DO: ensure that check_finite propagates Card variable
    debug_println(9,reified_cardinality_sum(ReifiedList,Card)). % clpfd:fd_dom(Card,Dom),print(dom(Card,Dom)),nl.
% should we add a special check if Card=0 ? usually Card not instantiated at this point !
%closure_cardinality(P,T,B,Card,WF) :- Card==0, %is_symbolic_closure(P,T,B),
%    !, is_empty_closure_wf(P,T,B,WF).
closure_cardinality2(P,T,B,Card,_WF) :-
    % TO DO: bexpr_variables(ClosureBody,ClosureWaitVars) and wait until those are bound; if Card = 0 -> empty_set; we can try to reifiy again
    expand_custom_set(closure(P,T,B),Expansion,closure_cardinality),
%    (var(Expansion)
%     -> format('Could not reify ~w : ',[Card]), translate:print_bvalue(closure(P,T,B)),nl,
%        when(nonvar(Card), format('Card bound ~w ~n',[Card]))
%      ; true),
    my_length(Expansion,0,Card).

:- block my_length(-,?,?).
my_length([],A,A).
my_length([_|T],A,R) :- A1 is A+1, my_length(T,A1,R).

% compute domain and range for specific relations;
% not the closure is total over the domain and surjective over the range
% WARNING: this should never enumerate on its own, it is often called with
%          a cut straight after it; if some enumeration happens then only first solution
%          will be pursued (e.g., cond_assign_eq_obj)
dom_range_for_specific_closure([],[],[],function(bijection)).
dom_range_for_specific_closure(closure(P,T,Pred),Domain,Range,Functionality) :-
      %% print(trying_card_for_specific_closure(P,T,Pred)),nl, trace,%%
     dom_range_for_specific_closure2(P,T,Pred, Domain,Range,Functionality).

dom_range_for_specific_closure2(Par,Typ,Body, Domain,Range,Functionality) :-
    is_member_closure(Par,Typ,Body,TYPE,SET),
     % print(trying_member(SET,TYPE)),nl, %%
    dom_range_for_member_closure(SET,TYPE,Domain,Range,Functionality),!.
dom_range_for_specific_closure2(Par,Typ,Body, DOMAIN,RANGE,Functionality) :-
   is_cartesian_product_closure_aux(Par,Typ,Body,SET1,SET2),!,
   (singleton_set(SET2,_)
     -> Functionality = function(total) % function if card(SET2)=1
      ; Functionality=relation),
   % print(dom_range_cart(Par,SET1,SET2)),nl,
   kernel_equality:equality_objects(SET1,[],EqRes1), cond_assign_eq_obj(EqRes1,RANGE,[],SET2), % if SET1=[] then Range=[]
   kernel_equality:equality_objects(SET2,[],EqRes2), cond_assign_eq_obj(EqRes2,DOMAIN,[],SET1). %if SET2=[] then Domain=[]
dom_range_for_specific_closure2(Par,Typ,Body, DomainRange,DomainRange,function(bijection)) :-
    is_id_closure_over(Par,Typ,Body,DomainRange,_).



%total_function(closure([_zzzz_unary,_zzzz_binary],[integer,integer],b(equal(b(identifier(_zzzz_unary),integer,[generated]),b(identifier(_zzzz_binary),integer,[generated])),pred,[])),global_set(INTEGER),global_set(INTEGER))

dom_range_for_member_closure(identity(b(value(SET1),ST1,_)),_SEQT,SET1,SET1,function(bijection)) :-
   is_set_type(ST1,_). /* _SEQT=id(T1) */
dom_range_for_member_closure(cartesian_product(b(value(SET1),ST1,_), b(value(SET2),ST2,_)),
                        couple(T1,T2), DOMAIN, RANGE,Functionality) :-
   is_set_type(ST1,T1), is_set_type(ST2,T2),
   (singleton_set(SET2,_)
     -> Functionality = function(total) % function if card(SET2)=1
      ; Functionality=relation),
   kernel_equality:equality_objects(SET1,[],EqRes1), cond_assign_eq_obj(EqRes1,RANGE,[],SET2), % if SET1=[] then Range=[]
   kernel_equality:equality_objects(SET2,[],EqRes2), cond_assign_eq_obj(EqRes2,DOMAIN,[],SET1). %if SET2=[] then Domain=[]

:- block cond_assign_eq_obj(-,?,?,?).
%cond_assign_eq_obj(PTF,R,A,B) :- var(PTF), add_error(cond_assign_eq_obj,'block declaration bug warning: ',cond_assign_eq_obj(PTF,R,A,B)),fail. % comment in to detect if affected by block declaration bug
cond_assign_eq_obj(pred_true,Res,A,_) :- equal_object(Res,A,cond_assign_eq_obj_1).
cond_assign_eq_obj(pred_false,Res,_,B) :- equal_object(Res,B,cond_assign_eq_obj_2).

is_cartesian_product_closure(closure(Par,Typ,Body),SET1,SET2) :-
   is_cartesian_product_closure_aux(Par,Typ,Body,SET1,SET2).
%is_cartesian_product_closure_aux(Par,Types,Body,_,_) :- print(try_cart(Par,Types,Body)),nl,fail.
is_cartesian_product_closure_aux(Par,Types,b(truth,pred,Info),SET1,SET2) :- Par=[_,_|_],!,
   append(LPar,[RParID],Par), append(LTypes,[RType],Types),
   construct_closure_if_necessary(LPar,LTypes,b(truth,pred,Info),SET1),
   construct_closure_if_necessary([RParID],[RType],b(truth,pred,Info),SET2).
   %print(cart_closure_truth(LPar,RParID,SET1,SET2)),nl.
is_cartesian_product_closure_aux(Par,Types,Body,SET1,SET2) :- Par=[_,_|_],!,
   append(LPar,[RParID],Par), append(LTypes,[RType],Types),!,
   % print('try split: '), print(LPar), print('<->'), print(RParID), print(' '),translate:print_bexpr(Body),nl, %%
   split_conjunct(Body,[RParID], RConjL, LPar, LConjL),
   bsyntaxtree:conjunct_predicates(RConjL,RConj), bsyntaxtree:conjunct_predicates(LConjL,LConj),
   % print('split : '), print(LPar), print(' : '), translate:print_bexpr(LConj),nl, %%
   % print('        '), print(RParID), print(' : '), translate:print_bexpr(RConj),nl, %%
   construct_closure_if_necessary(LPar,LTypes,LConj,SET1),
   construct_closure_if_necessary([RParID],[RType],RConj,SET2).
is_cartesian_product_closure_aux(Par,Typ,Body,SET1,SET2) :-
   SET = cartesian_product(b(value(SET1),ST1,_), b(value(SET2),ST2,_)),
   is_member_closure(Par,Typ,Body,couple(T1,T2),SET),
   is_set_type(ST1,T1), is_set_type(ST2,T2),!.
%is_cartesian_product_closure_aux([ID1,ID2],[T1,T2],FBody,SET1,SET2) :-  % is this not redundant  wrt split ??
% % a closure of the form {ID1,ID2|ID1 : SET1 & ID2 : SET2} ;
% % can get generated when computing domain symbolically of lambda abstraction
%   % print(try_cart(ID1,ID2,Body)),nl, trace,
%   FBody =  b(Body,pred,_),
%   is_cartesian_product_body(Body,ID1,ID2,T1,T2,SET1,SET2). % ,print(cart_res(SET1,SET2)),nl.

% try and split conjunct into two disjoint parts (for detecting cartesian products)
% on the specified variables
% fails if it cannot be done
split_conjunct(b(PRED,pred,Info),Vars1,C1,Vars2,C2) :-
   split_conjunct_aux(PRED,Info,Vars1,C1,Vars2,C2).
split_conjunct_aux(truth,_Info,_Vars1,C1,_Vars2,C2) :- !,C1=[],C2=[].
split_conjunct_aux(conjunct(A,B),_Info,Vars1,C1,Vars2,C2) :- !, % TO DO: use DCG
    split_conjunct(B,Vars1,CB1,Vars2,CB2), !, % Note: conjunct_predicates will create inner conjunct in A and atomic Expression in B
    split_conjunct(A,Vars1,CA1,Vars2,CA2),!,
    append(CA1,CB1,C1), append(CA2,CB2,C2).
split_conjunct_aux(E,Info,Vars1,C1,_Vars2,C2) :- unique_id_comparison(E,ID),!,
   (member(ID,Vars1) -> C1=[b(E,pred,Info)], C2=[] ; C1=[], C2=[b(E,pred,Info)]).

unique_id_comparison(less(b(L,_,_),b(R,_,_)), ID) :- unique_id_comparison_aux(L,R,ID).
unique_id_comparison(less_equal(b(L,_,_),b(R,_,_)), ID) :- unique_id_comparison_aux(L,R,ID).
unique_id_comparison(greater(b(L,_,_),b(R,_,_)), ID) :- unique_id_comparison_aux(L,R,ID).
unique_id_comparison(greater_equal(b(L,_,_),b(R,_,_)), ID) :- unique_id_comparison_aux(L,R,ID).
unique_id_comparison(member(b(identifier(ID),_,_),b(V,_,_)), ID) :- explicit_value(V).
unique_id_comparison(subset(b(identifier(ID),_,_),b(V,_,_)), ID) :- explicit_value(V).
unique_id_comparison(equal(b(L,_,_),b(R,_,_)), ID) :- unique_id_comparison_aux(L,R,ID). % means we also detect something like %x.(x : INTEGER|0) as cartesian product
% what about not_equal

unique_id_comparison_aux(identifier(ID),V,ID) :- !,explicit_value(V).
unique_id_comparison_aux(V,identifier(ID),ID) :- explicit_value(V).

explicit_value(value(_)) :- !.
explicit_value(integer(_)) :- !.
explicit_value(unary_minus(TV)) :- !, explicit_tvalue(TV).
explicit_value(interval(TV1,TV2)) :- !,
   explicit_tvalue(TV1), explicit_tvalue(TV2).
%explicit_value(seq(B)) :- !, explicit_tvalue(B). % are encoded as values by b_compile
%explicit_value(seq1(B)) :- !, explicit_tvalue(B).
%explicit_value(iseq(B)) :- !, explicit_tvalue(B).
%explicit_value(iseq1(B)) :- !, explicit_tvalue(B).
%explicit_value(struct(B)) :- !, explicit_tvalue(B).
%explicit_value(rec(Fields)) :- !, explicit_tfields(Fields).
explicit_value(total_bijection(A,B)) :- !,  explicit_tvalue(A),explicit_tvalue(B). % see test 1897 for cases below
explicit_value(total_injection(A,B)) :- !,  explicit_tvalue(A),explicit_tvalue(B).
explicit_value(total_function(A,B)) :- !,  explicit_tvalue(A),explicit_tvalue(B).
explicit_value(total_surjection(A,B)) :- !,  explicit_tvalue(A),explicit_tvalue(B).
explicit_value(partial_function(A,B)) :- !,  explicit_tvalue(A),explicit_tvalue(B).
explicit_value(partial_injection(A,B)) :- !,  explicit_tvalue(A),explicit_tvalue(B).
explicit_value(partial_surjection(A,B)) :- !,  explicit_tvalue(A),explicit_tvalue(B).
explicit_value(relations(A,B)) :- !,  explicit_tvalue(A),explicit_tvalue(B).
explicit_value(total_relation(A,B)) :- !,  explicit_tvalue(A),explicit_tvalue(B).
explicit_value(surjection_relation(A,B)) :- !,  explicit_tvalue(A),explicit_tvalue(B).
explicit_value(total_surjection_relation(A,B)) :- !,  explicit_tvalue(A),explicit_tvalue(B).
explicit_value(string_set) :- !.
%explicit_value(X) :- print_term_summary(explicit_check_failed(X)),nl,fail.

explicit_tvalue(b(B,_,_)) :- !, explicit_value(B).

%explicit_tfields(V) :- var(V),!,fail.
%explicit_tfields([]).
%explicit_tfields([field(N,V)|T]) :- ground(N),explicit_tvalue(V),explicit_tfields(T).

 %   conjunct_predicates([CA1,CB1],C1),
 %   conjunct_predicates([CA2,CB2],C2).

/* *********
is_cartesian_product_body(conjunct(A,B),ID1,ID2,_T1,_T2,SET1,SET2) :- !,
    member_pred_value(A,CID1,CSET1),
    member_pred_value(B,CID2,CSET2),
   % print(cart(CID1,CT1,CSET1,CID2,CT2,CSET2)),nl,
   (ID1=CID1,ID2=CID2,SET1=CSET1,SET2=CSET2 ; ID1=CID2,ID2=CID1,SET1=CSET2,SET2=CSET1).
is_cartesian_product_body(A,ID1,ID2,T1,T2,SET1,SET2) :-
   member_pred_value2(A,AID,ASET),
   (   AID=ID1 -> SET1=ASET, construct_closure_if_necessary([ID2],[T2],b(truth,pred,[]),SET2)
     ; AID=ID2 -> SET2=ASET, construct_closure_if_necessary([ID1],[T1],b(truth,pred,[]),SET1)).

member_pred_value(b(B,pred,_), ID,VAL) :- print(member_pred_value2(B,ID,VAL)),nl,
    member_pred_value2(B,ID,VAL).
member_pred_value2(member(b(identifier(ID),_CT1,_),b(value(VAL),_SCT1,_)), ID,VAL). %_SCT1 = set(CT1)
*/

% check if we have POW(SET1) or SET1<->SET2 (equiv. to POW(SET1*SET2))
is_full_powerset_or_relations_or_struct_closure(closure(Par,Typ,Body),SUBSETS) :-
   %TYPE = set(T),
   is_member_closure(Par,Typ,Body,TYPE,SET),
   is_full_powset_aux(SET,TYPE,SUBSETS).

:- use_module(library(lists),[maplist/3]).
is_full_powset_aux(pow_subset(b(value(SET1),set(T1),_)),set(T1),[SET1]).
is_full_powset_aux(relations(S1,S2),set(couple(T1,T2)),[SET1,SET2]) :-
  S1 = b(value(SET1),set(T1),_), S2 = b(value(SET2),set(T2),_).
is_full_powset_aux(struct(b(value(rec(FIELDS)),record(_),_)),record(_),FieldValueSets) :-
   maplist(get_field_val,FIELDS,FieldValueSets).

get_field_val(field(_,Val),Val).

%[field(duration,global_set('INTEGER')),field(rhythm,global_set('INTEGER')),field(slot,avl_set(...))]

is_powerset_closure(closure(Par,Typ,Body),Type,Subset) :-
   is_set_type(TYPE,T),
   is_member_closure(Par,Typ,Body,TYPE,SET),
   nonvar(SET),
   is_powset_aux(SET,Type,b(VS,set(T),_))  ,
   nonvar(VS), VS = value(Subset). %,print(powerset(Subset)),nl.
is_powset_aux(pow_subset(A),pow,A).
is_powset_aux(pow1_subset(A),pow1,A).
is_powset_aux(fin_subset(A),fin,A).
is_powset_aux(fin1_subset(A),fin1,A).

% group together closures which can be treated like cartesian products in the sense that:
%  Closure is empty if either Set1 or Set2  (could also be empty in other conditions though)
%  Closure is subset of other Closure if same Constructor and both sets are subsets
/* is_cartesian_product_like_closure(Closure,Constructor,Set1,Set2) :-
  is_cartesian_product_closure(Closure,S11,S12),!,
  Constructor = cartesian_product,Set1=S11,Set2=S12.
is_cartesian_product_like_closure(closure(Par,Typ,Body),Constructor,Set1,Set2) :-
   is_member_closure(Par,Typ,Body,TYPE,SET),
   is_cart_like_relation(SET,Constructor,b(value(Set1),set(_T1),_), b(value(Set1),set(_T2),_)).
is_cart_like_relation(relations(A,B),relations,A,B).
is_cart_like_relation(partial_function(A,B),partial_function,A,B).
is_cart_like_relation(partial_injection(A,B),partial_injection,A,B). */

% (closure([_zzzz_unary],[set(couple(integer,string))],b(member(b(identifier(_zzzz_unary),set(couple(integer,string)),[]),b(relations(b(value(global_set(INTEGER)),set(integer),[]),b(value(global_set(STRING)),set(string),[])),set(set(couple(integer,string))),[])),pred,[])))
%       1      1 Fail: custom_explicit_sets:is_powset_aux(relations(b(value(global_set('INTEGER')),set(integer),[]),b(value(global_set('STRING')),set(string),[])),couple(integer,string),_19584) ?

% card_for_specific_custom_set(+Set,-Cardinality,-CodeToComputeCardinality)
% succeeds if card can be computed efficiently
card_for_specific_custom_set(CS,C,Cd) :- var(CS),!,
    add_internal_error('Internal error: var ',card_for_specific_custom_set(CS,C,Cd)),fail.
card_for_specific_custom_set(global_set(GS),Card,true) :- !, b_global_set_cardinality(GS,Card).
card_for_specific_custom_set(avl_set(S),Card,true) :- !,avl_size(S,Card).
card_for_specific_custom_set(closure(P,T,B),Card,CodeToComputeCard) :-
     card_for_specific_closure2(P,T,B,Card,CodeToComputeCard).

card_for_specific_closure(closure(P,T,Pred),Card,CodeToComputeCard) :-
      % print(trying_card_for_specific_closure(P,T,Pred)),nl, trace,%%
     card_for_specific_closure2(P,T,Pred,Card,CodeToComputeCard).
      % nl, print(calling(CodeToComputeCard)),nl,nl. %%
%card_for_specific_closure(closure_x(P,T,Pred,_Exp),Card,CodeToComputeCard) :-
%     card_for_specific_closure2(P,T,Pred,Card,CodeToComputeCard).

:- use_module(btypechecker,[couplise_list/2]).
:- use_module(bsyntaxtree,[is_truth/1]).
card_for_specific_closure2(_,Types,Body,Card,Code) :- is_truth(Body),!,
    % TO DO: also treat multiple parameters
    couplise_list(Types,Type),
    Code=kernel_objects:max_cardinality(Type,Card).
card_for_specific_closure2(Par,Typ,Body, Card,Code) :-
    is_special_infinite_closure(Par,Typ,Body),!,Card=inf, Code=true.
card_for_specific_closure2(Par,Typ,Body, Card,Code) :- %print(try(Par,Typ,Body)),nl,
    is_geq_leq_interval_closure(Par,Typ,Body,Low,Up), !,
    % print(geq_leq(Par,Low,Up,Body)),nl,
    card_of_interval_inf(Low,Up,Card),  %print(Card),nl,
    Code=true.
 % TO DO: deal with non-infinite not_member_closures, prj1, prj2, id, ...
card_for_specific_closure2(Par,Typ,Body, Card,Code) :-
    is_lambda_value_domain_closure(Par,Typ,Body, DomainValue,_Expr),!, nonvar(DomainValue),
    efficient_card_for_set(DomainValue,Card,Code).
card_for_specific_closure2(Par,Typ,Body, Card,Code) :-
    is_cartesian_product_closure_aux(Par,Typ,Body,A1,A2),!, nonvar(A1), nonvar(A2),
    efficient_card_for_set(A1,Card1,Code1),
    efficient_card_for_set(A2,Card2,Code2),
    Code = (Code1,Code2, custom_explicit_sets:blocking_safe_mul(Card1,Card2,Card)).
card_for_specific_closure2(Par,Typ,Body, Card,Code) :-
    is_member_closure(Par,Typ,Body,TYPE,SET),
    nonvar(SET),!,
    card_for_member_closure(SET,TYPE,Card,Code).
    % Note: _ExprInfo could have: contains_wd_condition,
    % but if lambda is well-defined we compute the correct card ; if not then card is not well-defined anyway
    % maybe we should check contains_wd_condition produce a warning msg ?

% inner values can sometimes be a list, e.g., [pred_true,pred_false] for BOOL
efficient_card_for_set(VAR,_,_) :- var(VAR),!,fail.
efficient_card_for_set([],Card,Code) :- !, Card=0,Code=true.
efficient_card_for_set([_|T],Card,Code) :- known_length(T,1,C), !, Card = C, Code=true.
efficient_card_for_set(CS,Card,Code) :- card_for_specific_custom_set(CS,Card,Code).
known_length(X,_,_) :- var(X),!,fail.
known_length([],A,A).
known_length([_|T],A,R) :- A1 is A+1, known_length(T,A1,R).
known_length(avl_set(S),Acc,Res) :- avl_size(S,Card), %nl,print(known_length_avl(Card)),nl,nl,
    Res is Acc+Card.
% TO DO: also support closures

card_for_member_closure(parallel_product(b(value(A1),ST1,_),b(value(A2),ST1,_)),_T,Card,CodeToComputeCard) :- !,
    nonvar(A1), nonvar(A2),
    efficient_card_for_set(A1,Card1,Code1),
    efficient_card_for_set(A2,Card2,Code2),
    % cardinality computed like for cartesian_product
    CodeToComputeCard = (Code1,Code2, custom_explicit_sets:blocking_safe_mul(Card1,Card2,Card)).
card_for_member_closure(seq(b(value(SET1),ST1,_)),_SEQT,Card,CodeToComputeCard) :- !, /* _SEQT=seq(T1) */
        is_set_type(ST1,_T1),
        CodeToComputeCard = custom_explicit_sets:seq_card(SET1,Card).
card_for_member_closure(seq1(b(value(SET1),ST1,_)),_SEQT,Card,CodeToComputeCard) :- !, /* _SEQT=seq1(T1) */
        is_set_type(ST1,_T1),
        CodeToComputeCard = custom_explicit_sets:seq1_card(SET1,Card).
card_for_member_closure(perm(b(value(SET1),ST1,_)),_SEQT,Card,CodeToComputeCard) :- !, /* _SEQT=perm(T1) */
        is_set_type(ST1,_T1),
        CodeToComputeCard = (kernel_objects:cardinality_as_int(SET1,int(SCard)),
                             custom_explicit_sets:blocking_factorial(SCard,Card)).
card_for_member_closure(iseq(b(value(SET1),ST1,_)),_SEQT,Card,CodeToComputeCard) :- !, /* _SEQT=iseq(T1) */
        is_set_type(ST1,_T1),
        CodeToComputeCard = (kernel_objects:cardinality_as_int(SET1,int(SCard)),
                             custom_explicit_sets:blocking_nr_iseq(SCard,Card)).
card_for_member_closure(iseq1(b(value(SET1),ST1,_)),_SEQT,Card,CodeToComputeCard) :- !, /* _SEQT=iseq1(T1) */
        is_set_type(ST1,_T1),
        CodeToComputeCard = (kernel_objects:cardinality_as_int(SET1,int(SCard)),
                             custom_explicit_sets:blocking_nr_iseq1(SCard,Card)).
card_for_member_closure(identity(b(value(SET1),ST1,_)),_SEQT,Card,CodeToComputeCard) :- !, /* _SEQT=id(T1) */
        is_set_type(ST1,_T1),
        CodeToComputeCard = %(print(computing_card(id(SET1))),nl,
        kernel_objects:cardinality_as_int(SET1,int(Card)).
card_for_member_closure(struct(b(value(RECF),record(_FieldSetTypes),_)), record(_FieldTypes),
         Card,CodeToComputeCard) :- %print(card_for_member_struct(FIELDS,_FieldTypes)),nl,
         nonvar(RECF), RECF=rec(FIELDS),
         !,
         CodeToComputeCard = custom_explicit_sets:get_field_cardinality(FIELDS,Card).
% now dealt with separately above: card_for_member_closure(cartesian_product(b(value(SET1),set(T1),_), b(value(SET2),set(T2),_)),
%                        couple(T1,T2), Card,CodeToComputeCard) :- !,
%                        %% print(trying_cart(SET1,TYPE)),nl, %%
%           CodeToComputeCard =
%           (kernel_objects:cardinality_as_int(SET1,int(SCard1)),
%            kernel_objects:cardinality_as_int(SET2,int(SCard2)),
%            custom_explicit_sets:blocking_safe_mul(SCard1,SCard2,Card)             ).
card_for_member_closure(POW,TYPE, Card,CodeToComputeCard) :- %print(trying_pow(POW,TYPE)),nl,
           (POW = pow_subset(b(value(SET),TYPE,_)) ;
            POW = fin_subset(b(value(SET),TYPE,_))),!,
            CodeToComputeCard =
           (kernel_objects:cardinality_as_int(SET,int(SCard)),
            custom_explicit_sets:blocking_safe_pow2(SCard,Card)
           % ,(when(nonvar(Card),(print(set_res_safe_pow2(SCard,Card)),nl,trace)))
                 %% ,print(pow_card(SCard,Card)),nl %%
           ).
card_for_member_closure(POW,TYPE, Card,CodeToComputeCard) :- %%print(trying_pow1(POW,TYPE)),nl,
           (POW = pow1_subset(b(value(SET),TYPE,_)) ;
            POW = fin1_subset(b(value(SET),TYPE,_))),!,
            CodeToComputeCard =
           (kernel_objects:cardinality_as_int(SET,int(SCard)),
            custom_explicit_sets:blocking_safe_pow2(SCard,C1),
            custom_explicit_sets:safe_dec(C1,Card)
                  %%,print(pow1_card(SCard,Card)),nl %%
                 ).
card_for_member_closure(RELEXPR,SType, Card,CodeToComputeCard) :-
          is_set_type(SType,couple(T1,T2)),
          is_a_relation(RELEXPR, b(value(DOM),set(T1),_),
                                 b(value(RAN),set(T2),_), DCard,RCard,Card,RELCODE),!,
          CodeToComputeCard  =
          ( %%print(card_for_relations(DOM,T1,RAN,T2)),nl,
           kernel_objects:cardinality_as_int(DOM,int(DCard)),
           kernel_objects:cardinality_as_int(RAN,int(RCard)),
           when((ground(DCard),ground(RCard)),
                (call(RELCODE) %%, print(rel_card(DCard,RCard,Card)),nl %%
                ))).
card_for_member_closure(BODY, integer, Card,CodeToComputeCard) :- % print(try_interval(BODY)),nl,
   is_interval_set(BODY,Low,Up),!,
   CodeToComputeCard = custom_explicit_sets:card_of_interval_inf(Low,Up,Card).
card_for_member_closure(value(Value), _Type, Card,CodeToComputeCard) :-
   % we have a closure of the type {x|x:S}; equivalent to S
   ((nonvar(Value),Value=closure(P,T,B))
     -> % cardinality_as_int may expand it ! is bad if e.g. we called this code to check if a closure is infinite
        card_for_specific_closure2(P,T,B,Card,CodeToComputeCard) % will not expand, but fail if cannot be computed
        % TO DO: provide an argument: precise_or_efficient
     ;  CodeToComputeCard = kernel_objects:cardinality_as_int(Value,int(Card))
    ).
%card_for_member_closure(BODY, Type, Card,CodeToComputeCard) :- print(try_card(BODY,Type)),nl,fail.
  % TO DO: add maybe other common closures ?  simple value closure
  % also: what if subexpressions are not of value() type ?

:- public safe_dec/2. % used in card_for_member_closure
:- block safe_dec(-,?).
safe_dec(inf,R) :- !, R=inf.
safe_dec(X,R) :- R is X-1.

:- public seq_card/2. % used in card_for_member_closure
:- block seq_card(-,?).
%seq_card(A,B) :- print(seq_card(A,B)),nl,fail.
seq_card([],R) :- !,R=1.
seq_card(_,inf).

:- public seq1_card/2. % used in card_for_member_closure
:- block seq1_card(-,?).
seq1_card([],R) :- !,R=0.
seq1_card(_,inf).

:- public get_field_cardinality/2. % used in card_for_member_closure
get_field_cardinality([],1).
get_field_cardinality([field(_Name,Value)|T],ResCard) :-
   kernel_objects:cardinality_as_int(Value,int(SCard1)),
   get_field_cardinality(T,RestCard), blocking_safe_mul(SCard1,RestCard,ResCard).
  % print(field_card(_Name,SCard1,Value,ResCard)),nl.

:- block blocking_safe_mul(-,-,?).
blocking_safe_mul(A,B,R) :-
   (  A==0 -> R=0
    ; B==0 -> R=0
    ; A==1 -> R=B
    ; B==1 -> R=A
    ; blocking_safe_mul2(A,B,R) ).

:- block blocking_safe_mul2(-,?,?), blocking_safe_mul2(?,-,?).
blocking_safe_mul2(A,B,Res) :-
  (safe_mul(A,B,Res)  -> true
   ; (var(Res), frozen(Res,[])) -> nl,print('*** FAILED: '), print(safe_mul(A,B,Res)),nl, %trace, % could happen for something like prj2(BOOL,NAT) = prj2(BOOL,0..n)
                 fail).

:- public blocking_safe_pow2/2. % used in card_for_member_closure above
:- block blocking_safe_pow2(-,?).
blocking_safe_pow2(A,Res) :- % print(safe_pow2(A,Res)),nl,
   (safe_pow2(A,Res) -> true
    ; var(Res) -> nl,print('*** FAILED: '), print(safe_pow2(A,Res)),nl,fail).

:- assert_must_succeed((blocking_factorial(5,R),R==120)).
:- assert_must_succeed((blocking_factorial(0,R),R==1)).
:- assert_must_succeed((blocking_factorial(1,R),R==1)).
:- assert_must_succeed((blocking_factorial(3,R),R==6)).
:- assert_must_succeed((blocking_factorial(inf,R),R==inf)).
:- block blocking_factorial(-,?).
blocking_factorial(inf,R) :- !, R=inf.
blocking_factorial(X,R) :- X<0,!, add_error(blocking_factorial,'Negative arg: ',blocking_factorial(X,R)),R=0.
blocking_factorial(X,R) :- X>1000,!,
    % here we overapproximate: throw finite warning in Disprover mode ? or when checking for finite
    R=inf.
 % Note: blocking_safe_pow2(X,R) reports inf for X>1023; for X=171 blocking_factorial gives a result
 % which is greater than 2**1024 :
% X=171,custom_explicit_sets:blocking_factorial(X,R),custom_explicit_sets:blocking_safe_pow2(1023,R2), R>2*R2.
% debug:time(custom_explicit_sets:fact(10000,1,_)) --> 170 ms
% debug:time(custom_explicit_sets:fact(1000,1,_)) --> 0 ms
blocking_factorial(A,Res) :- fact(A,1,Res).

fact(0,Acc,Res) :- !,Res=Acc.
fact(N,Acc,Res) :- (Acc=inf -> Res=inf
 ; safe_mul(N,Acc,NAcc), N1 is N-1, fact(N1,NAcc,Res)).


:- assert_must_succeed((custom_explicit_sets:blocking_factorial_k(5,5,R),R==120)).
:- assert_must_succeed((blocking_factorial_k(5,2,R),R==20)).
:- assert_must_succeed((blocking_factorial_k(5,1,R),R==5)).
:- assert_must_succeed((blocking_factorial_k(5,0,R),R==1)).
:- assert_must_succeed((blocking_factorial_k(5,3,R),R==60)).
:- assert_must_succeed((blocking_factorial_k(5,4,R),R==120)).
:- assert_must_succeed((blocking_factorial_k(5,6,R),R==0)).
:- assert_must_succeed((blocking_factorial_k(0,0,R),R==1)).
:- assert_must_succeed((blocking_factorial_k(0,1,R),R==0)).
:- assert_must_succeed((blocking_factorial_k(1,1,R),R==1)).
:- assert_must_succeed((blocking_factorial_k(2,1,R),R==2)).
:- assert_must_succeed((blocking_factorial_k(2,2,R),R==2)).
:- assert_must_succeed((blocking_factorial_k(3,3,R),R==6)).
:- assert_must_succeed((blocking_factorial_k(inf,1,R),R==inf)).
:- assert_must_succeed((blocking_factorial_k(inf,0,R),R==1)).
:- assert_must_succeed((blocking_factorial_k(inf,inf,R),R==inf)).
:- assert_must_succeed((blocking_factorial_k(2,inf,R),R==0)).
% blocking_factorial_k(N,K,Res) ::  Res = N*(N-1)*...*(N-K+1)
% Number of ways to choose sequences of K different objects amongst a pool of N objects
:- block blocking_factorial_k(-,?,?),blocking_factorial_k(?,-,?).
blocking_factorial_k(_X,0,R) :- !, R=1.
blocking_factorial_k(inf,_,R) :- !, R=inf.
blocking_factorial_k(_N,K,R) :- K=inf,!, R=0.
blocking_factorial_k(N,K,R) :- K>N,!, R=0.
blocking_factorial_k(A,K,Res) :- fact_k(A,K,1,Res).

fact_k(0,_,Acc,Res) :- !, Res=Acc.
fact_k(_,K,Acc,Res) :- K<1,!,Res=Acc.
fact_k(N,K,Acc,Res) :-   (Acc=inf -> Res=inf
 ; safe_mul(N,Acc,NAcc), N1 is N-1, K1 is K-1, fact_k(N1,K1,NAcc,Res)).


:- assert_must_succeed((choose_nk(3,3,R),R==1)).
:- assert_must_succeed((choose_nk(3,2,R),R==3)).
:- assert_must_succeed((choose_nk(3,1,R),R==3)).
:- assert_must_succeed((choose_nk(3,0,R),R==1)).
:- block choose_nk(-,?,?), choose_nk(?,-,?).
choose_nk(N,K,Res) :- (K=0;K=N),!,Res=1.
choose_nk(N,K,Res) :- K > N/2,!, KN is N-K, choose_nk2(N,KN,Res).
choose_nk(N,K,Res) :- choose_nk2(N,K,Res).
choose_nk2(N,K,Res) :- blocking_factorial_k(N,K,NK), blocking_factorial(K,KF),
   safe_div(NK,KF,Res).

:- assert_must_succeed((safe_div(inf,10,R),R==inf)).
:- assert_must_succeed((safe_div(10,inf,R),R==0)).
:- assert_must_succeed((safe_div(10,5,R),R==2)).
:- assert_must_succeed((safe_div(10,6,R),R==1)).
:- block safe_div(-,?,?), safe_div(?,-,?).
safe_div(X,0,R) :- print(div_by_zero(X,0,R)),nl, !, R=inf.
safe_div(inf,K,R) :-
  (number(K) -> true ; print(safe_div(inf,K,R)),nl), !, R=inf.
safe_div(_N,inf,R) :- !, R=0.
safe_div(X,Y,Z) :- Z is X//Y.

:- assert_must_succeed((safe_minus(506,501,R),R==5)).
:- assert_must_succeed((safe_minus(inf,10,R),R==inf)).
:- assert_must_succeed((safe_minus(10,inf,R),R==0)).
:- block safe_minus(-,?,?), safe_minus(?,-,?).
safe_minus(_,inf,R) :- !, print('### Warning: cannot compute X - inf'),nl, R=0.
safe_minus(inf,_,R) :- !, R=inf.
safe_minus(X,Y,R) :- R is X-Y.

:- assert_must_succeed((blocking_nr_iseq(2,R),R==5)).
:- assert_must_succeed((blocking_nr_iseq(0,R),R==1)).
:- assert_must_succeed((blocking_nr_iseq(1,R),R==2)).
:- assert_must_succeed((blocking_nr_iseq(3,R),R==16)).
:- assert_must_succeed((blocking_nr_iseq(inf,R),R==inf)).
:- block blocking_nr_iseq(-,?).
blocking_nr_iseq(inf,R) :- !, R=inf.
blocking_nr_iseq(X,R) :- X<0,!, add_error(blocking_nr_iseq,'Negative arg: ',blocking_nr_iseq(X,R)),R=0.
blocking_nr_iseq(X,R) :- X>500,!, R=inf.
 % Note: blocking_safe_pow2(X,R) reports inf for X>1023; for X=171 blocking_nr_iseq gives a result
 % which is greater than 2**1024 :
% X=171,custom_explicit_sets:blocking_nr_iseq(X,R),custom_explicit_sets:blocking_safe_pow2(1023,R2), R>2*R2.
% debug:time(custom_explicit_sets:nr_iseq(10000,_)) --> 250 ms
% debug:time(custom_explicit_sets:nr_iseq(1000,_)) --> 10 ms
% debug:time(custom_explicit_sets:nr_iseq(500,_)) --> 0 ms
blocking_nr_iseq(A,Res) :- nr_iseq(A,Res). % , print(nr_iseq(A,Res)),nl.
% number of injective sequences: f(N) = 1+N*(f(N-1))
nr_iseq(0,Res) :- !,Res=1.
nr_iseq(N,Res) :- N1 is N-1, nr_iseq(N1,N1Res),
                  safe_mul(N,N1Res,NAcc), safe_add(NAcc,1,Res).
:- public blocking_nr_iseq1/2. % used in card_for_member_closure above
:- block blocking_nr_iseq1(-,?).
blocking_nr_iseq1(inf,R) :- !, R=inf.
blocking_nr_iseq1(A,Res1) :- blocking_nr_iseq(A,Res) , safe_add(Res,-1,Res1). %, print(nr_iseq1(A,Res1)),nl.

  :- assert_must_succeed((custom_explicit_sets:card_for_specific_closure2(['_zzzz_binary'],[integer],
    b(member(b(identifier('_zzzz_binary'),integer,[generated]),
    b(interval(b(value(int(1)),integer,[]),b(value(int(10)),integer,[])),set(integer),[])),pred,[]),R,C),
     call(C),
  R=10)).

is_interval_closure_or_integerset(Var,_,_) :- var(Var),!,fail.
is_interval_closure_or_integerset(global_set(X),Low,Up) :- !, get_integer_set_interval(X,Low,Up).
is_interval_closure_or_integerset(Set,El,El) :- singleton_set(Set,ELX),
  nonvar(ELX), ELX=int(El),!. % new, useful??
is_interval_closure_or_integerset(closure(P,T,B),Low,Up) :-
    (is_geq_leq_interval_closure(P,T,B,Low,Up) -> true ; is_interval_closure(P,T,B,Low,Up)).


get_integer_set_interval('NAT',0,MAXINT) :- (preferences:preference(maxint,MAXINT)->true).
get_integer_set_interval('NAT1',1,MAXINT) :- (preferences:preference(maxint,MAXINT)->true).
get_integer_set_interval('INT',MININT,MAXINT) :-
   ((preferences:preference(maxint,MAXINT),preferences:preference(minint,MININT))->true).
get_integer_set_interval('NATURAL',0,inf).
get_integer_set_interval('NATURAL1',1,inf).
get_integer_set_interval('INTEGER',minus_inf,inf).
% TO DO: add minus_inf to kernel_objects !

:- block geq_inf(-,?), geq_inf(?,-).
geq_inf(inf,_) :- !.
geq_inf(minus_inf,B) :- !, B=minus_inf.
geq_inf(_,minus_inf) :- !.
geq_inf(A,inf) :- !, A=inf.
geq_inf(A,B) :- A >= B.

:- block minimum_with_inf(-,-,?).
% in the first three cases we can determine outcome without knowing both args
minimum_with_inf(A,B,R) :- (A==minus_inf ; B==minus_inf),!,R=minus_inf.
minimum_with_inf(A,B,R) :- A==inf,!,R=B.
minimum_with_inf(A,B,R) :- B==inf,!,R=A.
minimum_with_inf(A,B,R) :- minimum_with_inf1(A,B,R), geq_inf(A,R), geq_inf(B,R).
:- block minimum_with_inf1(-,?,?), minimum_with_inf1(?,-,?).
minimum_with_inf1(minus_inf,_,R) :- !, R=minus_inf.
minimum_with_inf1(_,minus_inf,R) :- !, R=minus_inf.
minimum_with_inf1(inf,B,R) :- !, R=B.
minimum_with_inf1(A,inf,R) :- !, R=A.
minimum_with_inf1(A,B,R) :- (A<B -> R=A ; R=B).

:- block maximum_with_inf(-,-,?).
% in the first three cases we can determine outcome without knowing both args
maximum_with_inf(A,B,R) :- (A==inf ; B==inf),!,R=inf.
maximum_with_inf(A,B,R) :- A==minus_inf,!,R=B.
maximum_with_inf(A,B,R) :- B==minus_inf,!,R=A.
maximum_with_inf(A,B,R) :- maximum_with_inf1(A,B,R), geq_inf(R,A), geq_inf(R,B).
:- block maximum_with_inf1(-,?,?), maximum_with_inf1(?,-,?).
maximum_with_inf1(inf,_,R) :- !, R=inf.
maximum_with_inf1(_,inf,R) :- !, R=inf.
maximum_with_inf1(minus_inf,B,R) :- !, R=B.
maximum_with_inf1(A,minus_inf,R) :- !, R=A.
maximum_with_inf1(A,B,R) :- (A>B -> R=A ; R=B).

/* utilities for detecting interval closures */
construct_interval_closure(Low,Up,Res) :- (Low==inf;Up==minus_inf),!,Res=[].
construct_interval_closure(Low,Up,Res) :- number(Low),number(Up), Low>Up,!,Res=[].
construct_interval_closure(Low,Up,Res) :- Up==inf,!,
   ( Low==0 -> Res = global_set('NATURAL')
   ; Low==1 -> Res = global_set('NATURAL1')
   ; Low==minus_inf -> Res = global_set('INTEGER')
   ; Low==inf -> Res = []
   ; construct_greater_equal_closure(Low,Res)
   ).
construct_interval_closure(Low,Up,Res) :- Low==minus_inf,!,
   construct_less_equal_closure(Up,Res).
construct_interval_closure(Low,Up,Res) :- Low==Up,!,
   (number(Low) -> construct_one_element_custom_set(int(Low),Res)
     ; Res = [Low]).
construct_interval_closure(Low,Up,Res) :-
   construct_interval_set(Low,Up,Set),
   construct_member_closure('_zzzz_unary',integer,Set,Res).

transform_global_sets_into_closure(closure(P,T,B),closure(P,T,B)).
transform_global_sets_into_closure(global_set(X),Res) :-
  transform_global_set_into_closure_aux(X,Res).
transform_global_set_into_closure_aux('NATURAL',Res) :-
   construct_greater_equal_closure(0,Res).
transform_global_set_into_closure_aux('NATURAL1',Res) :-
   construct_greater_equal_closure(1,Res).
% TO DO: add INTEGER

construct_greater_equal_closure(X,Res) :-
       construct_closure(['_zzzz_unary'],[integer],
         b(greater_equal(b(identifier('_zzzz_unary'),integer,[]),
                         b(value(int(X)),integer,[])),  pred,[]),Res).
construct_less_equal_closure(X,Res) :-
       construct_closure(['_zzzz_unary'],[integer],
         b(less_equal(b(identifier('_zzzz_unary'),integer,[]),
                         b(value(int(X)),integer,[])),  pred,[]),Res).



is_geq_leq_interval_closure([Par],[integer],b(Body,pred,_),Low,Up) :-
   get_geq_leq_bounds(Body,Par,Low,Up).

infinite_interval(Low,Up) :- (Low==minus_inf -> true ; Up==inf).

:- assert_must_succeed((card_of_interval_inf(1,10,10))).
:- assert_must_succeed((card_of_interval_inf(1,inf,R),R==inf)).
:- assert_must_succeed((card_of_interval_inf(minus_inf,0,R),R==inf)).
:- assert_must_succeed((card_of_interval_inf(2,2,R), R==1)).
:- assert_must_succeed((card_of_interval_inf(12,2,R), R==0)).
:- assert_must_succeed((card_of_interval_inf(2,B,10), B==11)).
:- assert_must_succeed((card_of_interval_inf(A,12,10), A==3)).
:- assert_must_succeed((card_of_interval_inf(A,12,0), A=222)).
:- assert_must_succeed((card_of_interval_inf(12,B,0), B=11)).
:- assert_must_fail((card_of_interval_inf(A,12,0), A=12)).
% compute cardinality of interval; allow bounds to be inf and minus_inf (but if so, they must be bound straightaway)
card_of_interval_inf(A,B,Card) :-
   at_least_two_vars(A,B,Card), % initially this will usually be true, if only one variable we can compute result
   preferences:preference(use_clpfd_solver,true),
   !,
   clpfd_interface:post_constraint(Card #= max(0,1+B-A),custom_explicit_sets:block_card_of_interval_inf(A,B,Card)).
card_of_interval_inf(A,B,Card) :- block_card_of_interval_inf(A,B,Card).

at_least_two_vars(A,B,C) :- var(A),!,(var(B) -> not_infinite_bound(C) ; number(B),var(C)).
at_least_two_vars(A,B,C) :- number(A), var(B),var(C).
not_infinite_bound(A) :- (var(A) ; number(A)). % inf can only appear immediately, not for variables

:- block block_card_of_interval_inf(-,?,-),block_card_of_interval_inf(?,-,-).
% if none of the values are inf: we can set up CLPFD constraint ? : inf values either are set straightaway or don't appear !
%block_card_of_interval_inf(A,B,C) :- print(card_int(A,B,C)),nl,fail.
block_card_of_interval_inf(A,_,Card) :- A==minus_inf,!, Card=inf.
block_card_of_interval_inf(_,B,Card) :- B==inf,!, Card=inf.
block_card_of_interval_inf(From,To,Card) :- number(From),number(To),!,
   (From>To -> Card=0 ; Card is (To-From)+1).
block_card_of_interval_inf(A,B,C) :- number(C),!, number_card_of_interval_inf_aux(C,A,B).
block_card_of_interval_inf(A,B,C) :- C==inf,!,
    % probably this should systematically fail; if A and B are not inf/minus_inf now they will never be
    print(infinite_interval_requested(A,B,C)),nl,
    when((nonvar(A),nonvar(B)), block_card_of_interval_inf(A,B,C)).
block_card_of_interval_inf(A,B,C) :- add_internal_error('Illegal call: ',card_of_interval_inf(A,B,C)).
:- use_module(inf_arith,[block_inf_greater/2]).
number_card_of_interval_inf_aux(0,A,B) :- !, % empty interval
     % if A and B are variables then they will not become inf later ??
     % inf can only be set directly for sets such as {x|x>4} or NATURAL1
     (((var(A);number(A)),(var(B);number(B)))
     % hence we can use ordinary comparison (with CLPFD) here
       -> kernel_objects:less_than_direct(B,A)
       % TO DO: we could do this even if both A and B are variables !! ex : {n,m|n..m = {} & m..100={} & 103..n={}}
       ;  block_inf_greater(A,B)).
%number_card_of_interval_inf_aux(Card,From,B) :- number(From),!, B is (From+Card)-1.
%number_card_of_interval_inf_aux(Card,A,To) :- number(To),!, A is 1+To-Card.
number_card_of_interval_inf_aux(Card,A,B) :- %print(card(Card,A,B)),nl,
      Card>0, C1 is Card-1,
      kernel_objects:int_minus(int(B),int(A),int(C1)).


get_geq_leq_bounds(conjunct(b(LEFT,pred,_),b(RIGHT,pred,_)), Par,Low,Up) :-
   % print(conjunct_left(LEFT)),nl,
   get_geq_leq_bounds(LEFT,Par,From1,To1),
   % print(conjunct_right(RIGHT)),nl,
   get_geq_leq_bounds(RIGHT,Par,From2,To2),
   % print(intersect_intervals_with_inf(From1,To1,From2,To2)),nl,
   intersect_intervals_with_inf(From1,To1,From2,To2,Low,Up).
get_geq_leq_bounds(member(b(identifier(Par),integer,_),
                  b(Value,set(integer),_)),Par,Low,Up) :-
    get_value_bounds(Value,Low,Up).
get_geq_leq_bounds(greater_equal(b(A,_,_),b(B,_,_)),Par,Low,Up) :- get_bounds2(greater_equal,A,B,Par,Low,Up).
get_geq_leq_bounds(   less_equal(b(A,_,_),b(B,_,_)),Par,Low,Up) :- get_bounds2(less_equal,A,B,Par,Low,Up).
get_geq_leq_bounds(      greater(b(A,_,_),b(B,_,_)),Par,Low,Up) :- get_bounds2(greater,A,B,Par,Low,Up).
get_geq_leq_bounds(         less(b(A,_,_),b(B,_,_)),Par,Low,Up) :- get_bounds2(less,A,B,Par,Low,Up).

get_value_bounds(value(GS),Low,Up) :- is_interval_closure_or_integerset(GS,Low,Up). % recursive call
%  nonvar(GS),   GS=global_set(ISET), get_integer_set_interval(ISET,Low,Up).
get_value_bounds(interval(TLow,TUp),Low,Up) :- integer_value(TLow,Low), integer_value(TUp,Up).

get_bounds2(greater_equal,identifier(Par),V,Par,X,inf) :- integer_value(V,X).
get_bounds2(greater_equal,V,identifier(Par),Par,minus_inf,X) :- integer_value(V,X).
get_bounds2(less_equal,identifier(Par),V,Par,minus_inf,X) :- integer_value(V,X).
get_bounds2(less_equal,V,identifier(Par),Par,X,inf) :- integer_value(V,X).
get_bounds2(greater,identifier(Par),V,Par,X1,inf) :- integer_value(V,X), kernel_objects:int_plus(int(X),int(1),int(X1)). %, X1 is X+1.
get_bounds2(greater,V,identifier(Par),Par,minus_inf,X1) :- integer_value(V,X), kernel_objects:int_minus(int(X),int(1),int(X1)). %X1 is X-1.
get_bounds2(less,V,identifier(Par),Par,X1,inf) :- integer_value(V,X), kernel_objects:int_plus(int(X),int(1),int(X1)). %X1 is X+1.
get_bounds2(less,identifier(Par),V,Par,minus_inf,X1) :- integer_value(V,X), kernel_objects:int_minus(int(X),int(1),int(X1)). %X1 is X-1.
% to do: add negation thereof ??

integer_value(V,_) :- var(V),!, print(var_integer_value(V)),nl,fail.
integer_value(integer(X),R) :- !, R=X.
integer_value(unary_minus(b(X,_,_)),R) :- !, integer_value(X,RM),
   number(RM),  % if RM is not a number we could setup CLPFD constraint ?!
   R is -(RM).
integer_value(value(int(X)),R) :- !, R=X.
%integer_value(X,_) :- print(not_integer_value(X)),nl,fail.

is_interval_closure(closure(Par,[integer],Pred),Low,Up) :-
   is_interval_closure_aux(Par,Pred,Low,Up).
is_interval_closure(Par,[integer],Pred,Low,Up) :-
    is_interval_closure_aux(Par,Pred,Low,Up).
is_interval_closure_aux(Par,Pred,Low,Up) :-
   is_member_closure(Par,[integer],Pred,integer,Set),
   is_interval_set(Set,Low,Up).
%is_interval_closure(closure_x(Par,[integer],Pred,_),Low,Up) :-
%   is_interval_closure(closure(Par,[integer],Pred),Low,Up).

is_interval_closure_body(Body,ID,Low,Up) :-
     is_member_closure([ID],[integer],Body,integer,Set),!,
     is_interval_set(Set,Low,Up).
is_interval_closure_body(Body,ID,Low,Up) :-
     is_geq_leq_interval_closure([ID],[integer],Body,Low,Up),
     number(Low), number(Up).

:- use_module(bsyntaxtree,[get_texpr_info/2,get_texpr_id/2]).
% do a single check if we have interval, member or not-member closure, avoiding redundant checking
% TO DO: move this and related predicates to closures module ?
is_special_closure(_Ids,_Types,Pred,Result) :-
    get_texpr_info(Pred,Info),memberchk(prob_annotation(recursive(RId)),Info),!,
    Result = recursive_special_closure(RId).
is_special_closure([ID],[TYPE],b(PRED,_,_), Result) :-
    ( closures:is_member_closure_aux(PRED, ID,TYPE,SET) ->
        ( (TYPE=integer, is_interval_set(SET,Low,Up)) ->
            Result = interval(Low,Up)
        ; Result = member_closure(ID,TYPE,SET))
    ; closures:is_not_member_closure_aux(PRED,ID,TYPE,SET) ->
        Result = not_member_closure(ID,TYPE,SET)
    ; (TYPE=integer,get_geq_leq_bounds(PRED,ID,Low,Up),number(Low), number(Up)) ->
        Result = interval(Low,Up)
     ).


construct_interval_set(Low,Up,Res) :-
   Res = interval(b(value(int(Low)),integer,[]),
                                         b(value(int(Up)), integer,[])).
is_interval_set(X,L,U) :- var(X),!, add_internal_error('var arg: ',is_interval_set(X,L,U)),fail.
is_interval_set(interval(b(LOW,integer,_),b(UP, integer,_)),Low,Up) :-
                integer_value(LOW,Low), integer_value(UP,Up).

:- use_module(kernel_objects,[safe_mul/3, safe_add/3, safe_pow2/2, safe_pown/3]).

is_a_relation(relations(Domain,Range),Domain,Range,DCard,RCard,Card,Code) :-  %% '<->'
           Code = (kernel_objects:safe_mul(DCard,RCard,Exp), kernel_objects:safe_pow2(Exp,Card)).
is_a_relation(partial_function(Domain,Range),Domain,Range,DCard,RCard,Card,Code) :-  %% '+->'
           Code = (kernel_objects:safe_add(RCard,1,R1),kernel_objects:safe_pown(R1,DCard,Card)).
is_a_relation(total_function(Domain,Range),Domain,Range,DCard,RCard,Card,Code) :-   %% '-->'
           Code = (kernel_objects:safe_pown(RCard,DCard,Card)).
is_a_relation(partial_bijection(Domain,Range),Domain,Range,DCard,RCard,Card,Code) :-   %% '>+>>'
           Code = (custom_explicit_sets:partial_bijection_card(DCard,RCard,Card)).
is_a_relation(total_bijection(Domain,Range),Domain,Range,DCard,RCard,Card,Code) :-   %% '>->>'
           Code = (custom_explicit_sets:total_bijection_card(DCard,RCard,Card)).
is_a_relation(total_injection(Domain,Range),Domain,Range,DCard,RCard,Card,Code) :-   %% '>->'
           Code = (custom_explicit_sets:blocking_factorial_k(RCard,DCard,Card)).
is_a_relation(partial_injection(Domain,Range),Domain,Range,DCard,RCard,Card,Code) :-   %% '>+>'
           Code = (custom_explicit_sets:partial_injection_card(DCard,RCard,Card)).
is_a_relation(total_surjection(Domain,Range),Domain,Range,DCard,RCard,Card,Code) :-   %% '-->>'
           Code = (custom_explicit_sets:total_surjection_card(DCard,RCard,Card)).
is_a_relation(partial_surjection(Domain,Range),Domain,Range,DCard,RCard,Card,Code) :-   %% '+->>'
           Code = (custom_explicit_sets:partial_surjection_card(DCard,RCard,Card)).
is_a_relation(total_relation(Domain,Range),Domain,Range,DCard,RCard,Card,Code) :-   %% '<<->'
           Code = (custom_explicit_sets:total_relation_card(DCard,RCard,Card)).
% TO DO: total_surjective_relation <<->> , surjective_relation <->>


:- assert_must_succeed((custom_explicit_sets:total_relation_card(0,inf,R),R==1)).
:- assert_must_succeed((custom_explicit_sets:total_relation_card(2,inf,R),R==inf)).
:- assert_must_succeed((custom_explicit_sets:total_relation_card(inf,0,R),R==0)).
:- assert_must_succeed((custom_explicit_sets:total_relation_card(inf,1,R),R==1)).
:- assert_must_succeed((custom_explicit_sets:total_relation_card(inf,2,R),R==inf)).
:- assert_must_succeed((custom_explicit_sets:total_relation_card(inf,inf,R),R==inf)).
:- assert_must_succeed((custom_explicit_sets:total_relation_card(2,2,R),R==9)).
:- assert_must_succeed((custom_explicit_sets:total_relation_card(2,3,R),R==49)).

:- block total_relation_card(-,?,?), total_relation_card(?,-,?).
total_relation_card(0,_RanC,Card) :- !, Card=1. % empty set is a solution
total_relation_card(_DomC,0,Card) :- !, Card=0. % no element to choose from in the range
total_relation_card(inf,RanC,Card) :- !, (RanC=1 -> Card=1 ; Card=inf).
total_relation_card(_,inf,Card) :- !, Card=inf.
total_relation_card(DomC,RanC,Card) :- safe_pow2(RanC,SubRan),
   safe_minus(SubRan,1,S1), % as we have a total relation we cannot choose empty set
   safe_pown(S1,DomC,Card).

:- assert_must_succeed((custom_explicit_sets:partial_bijection_card(2,inf,R),R==0)).
:- assert_must_succeed((custom_explicit_sets:partial_bijection_card(inf,2,R),R==inf)).
:- assert_must_succeed((custom_explicit_sets:partial_bijection_card(inf,inf,R),R==inf)).
:- assert_must_succeed((custom_explicit_sets:partial_bijection_card(3,2,R),R==6)).
:- assert_must_succeed((custom_explicit_sets:partial_bijection_card(2,2,R),R==2)).
:- assert_must_succeed((custom_explicit_sets:partial_bijection_card(1,2,R),R==0)).
:- assert_must_succeed((custom_explicit_sets:partial_bijection_card(2,1,R),R==2)).
:- assert_must_succeed((custom_explicit_sets:partial_bijection_card(5,3,R),R==60)).
:- assert_must_succeed((custom_explicit_sets:partial_bijection_card(6,4,R),R==360)).
:- assert_must_succeed((custom_explicit_sets:partial_bijection_card(10,1,R),R==10)).
:- assert_must_succeed((custom_explicit_sets:partial_bijection_card(10,2,R),R==90)).

:- block partial_bijection_card(-,?,?), partial_bijection_card(?,-,?).
partial_bijection_card(_X,0,R) :- !, R=1. % the empty set is a solution
partial_bijection_card(inf,X,R) :- !,
   print_inf_warning(X,'>+>>'), % we could have : INTEGER >+>> POW(INTEGER); TO DO: use omega(inf) for POW ?
   R=inf. % we know _X>0
partial_bijection_card(_X,inf,R) :- !, R=0. % _X<inf -> no way to cover all elements in range
partial_bijection_card(DomCard,RanCard,Res) :- DomCard<RanCard,!,Res=0.
partial_bijection_card(DomCard,RanCard,XCard) :-
    choose_nk(DomCard,RanCard,CNK), % ways to choose domain of size RanCard
    blocking_factorial(RanCard,Card), %print(pbij(DomCard,RanCard,CNK,Card)),nl,
    safe_mul(CNK,Card,XCard).

print_inf_warning(inf,FUN) :- print('### WARNING: Assuming '),
  print(FUN), print(' exists for two infinite sets'),nl.
print_inf_warning(_,_).

:- assert_must_succeed((custom_explicit_sets:partial_surjection_card(0,2,R),R==0)).
:- assert_must_succeed((custom_explicit_sets:partial_surjection_card(0,0,R),R==1)).
:- assert_must_succeed((custom_explicit_sets:partial_surjection_card(2,0,R),R==1)).
:- assert_must_succeed((custom_explicit_sets:partial_surjection_card(1,1,R),R==1)).
:- assert_must_succeed((custom_explicit_sets:partial_surjection_card(inf,2,R),R==inf)).
:- assert_must_succeed((custom_explicit_sets:partial_surjection_card(2,inf,R),R==0)).
:- assert_must_succeed((custom_explicit_sets:partial_surjection_card(inf,inf,R),R==inf)).
:- assert_must_succeed((custom_explicit_sets:partial_surjection_card(3,2,R),R==12)).
:- block partial_surjection_card(-,?,?), partial_surjection_card(?,-,?).
partial_surjection_card(_X,0,R) :- !, R=1. % the empty set is a solution
partial_surjection_card(inf,X,R) :- !,print_inf_warning(X,'+->>'),R=inf. % we know _X>0
partial_surjection_card(_X,inf,R) :- !, R=0. % _X<inf -> no way to cover all elements in range
partial_surjection_card(A,B,Res) :- tsurjcard(A,1,B,Res). % 1 because we can choose to leave the function undefined

:- assert_must_succeed((custom_explicit_sets:total_surjection_card(0,2,R),R==0)).
:- assert_must_succeed((custom_explicit_sets:total_surjection_card(0,0,R),R==1)).
:- assert_must_succeed((custom_explicit_sets:total_surjection_card(2,0,R),R==0)).
:- assert_must_succeed((custom_explicit_sets:total_surjection_card(inf,0,R),R==0)).
:- assert_must_succeed((custom_explicit_sets:total_surjection_card(inf,1,R),R==1)).
:- assert_must_succeed((custom_explicit_sets:total_surjection_card(inf,2,R),R==inf)).
:- assert_must_succeed((custom_explicit_sets:total_surjection_card(2,inf,R),R==0)).
:- assert_must_succeed((custom_explicit_sets:total_surjection_card(0,inf,R),R==0)).
:- assert_must_succeed((custom_explicit_sets:total_surjection_card(inf,inf,R),R==inf)).
:- assert_must_succeed((custom_explicit_sets:total_surjection_card(3,2,R),R==6)).
:- block total_surjection_card(-,?,?), total_surjection_card(?,-,?).
total_surjection_card(0,Range,R) :- !,(Range=0 -> R=1 % the empty set is a solution
                                                ; R=0). % no solution
total_surjection_card(_X,0,R) :- !, R=0. % as _X>0 there is no way to construct a total function
total_surjection_card(_X,1,R) :- !, R=1. % we only have one choice for every element of _X
total_surjection_card(inf,X,R) :- !,print_inf_warning(X,'-->>'),R=inf. % we know _X>0
total_surjection_card(_X,inf,R) :- !, R=0. % _X<inf -> no way to cover all elements in range
total_surjection_card(A,B,Res) :- tsurjcard(A,0,B,Res).

tsurjcard(Rem,_AlreadyUsed,StillToBeUsed,Res) :- Rem<StillToBeUsed,!,Res=0. % no solution
tsurjcard(0,_AlreadyUsed,_StillToBeUsed,Res) :- !, Res=1. % we have finished
tsurjcard(Rem,AlreadyUsed,StillToBeUsed,Res) :-
   R1 is Rem-1, A1 is AlreadyUsed+1, S1 is StillToBeUsed-1,
   (AlreadyUsed=0 -> ResA=0 ; tsurjcard(R1,AlreadyUsed,StillToBeUsed,ResA)),
   (StillToBeUsed=0 -> ResB =0 ; tsurjcard(R1,A1,S1,ResB)),
   Res is AlreadyUsed*ResA+StillToBeUsed*ResB.



:- assert_must_succeed((custom_explicit_sets:partial_injection_card(1,1,R),R==2)).
:- assert_must_succeed((custom_explicit_sets:partial_injection_card(1,2,R),R==3)).
:- assert_must_succeed((custom_explicit_sets:partial_injection_card(1,100,R),R==101)).
:- assert_must_succeed((custom_explicit_sets:partial_injection_card(0,100,R),R==1)).
:- assert_must_succeed((custom_explicit_sets:partial_injection_card(1,inf,R),R==inf)).
:- assert_must_succeed((custom_explicit_sets:partial_injection_card(0,inf,R),R==1)).
:- assert_must_succeed((custom_explicit_sets:partial_injection_card(5,0,R),R==1)).
:- assert_must_succeed((custom_explicit_sets:partial_injection_card(inf,0,R),R==1)).
:- assert_must_succeed((custom_explicit_sets:partial_injection_card(inf,1,R),R==inf)).
:- assert_must_succeed((custom_explicit_sets:partial_injection_card(5,1,R),R==6)).

:- block partial_injection_card(-,?,?), partial_injection_card(?,-,?).
partial_injection_card(Dom,Ran,R) :- (Dom=0;Ran=0),!, R=1.  % only one solution: empty function
partial_injection_card(Dom,1,R) :- !, (Dom=inf -> R=inf ; R is Dom+1).  % empty function + for every domain element one function
partial_injection_card(inf,inf,Card) :- !, print_inf_warning(inf,'>+>'), Card=inf.
partial_injection_card(Dom,Ran,R) :- (Dom=inf;Ran=inf),!, R=inf.
partial_injection_card(Dom,Ran,R) :- Dom>1000,Ran>1000,!, R=inf.  % TO DO: refine this
 % would give a result larger than blocking_factorial(1000)
partial_injection_card(DCard,RCard,Card) :-
  %print(partial_injection_card(DCard,RCard)),nl,
  pinj_card(1,DCard,RCard,1,Card). %, print(result(DCard,RCard,Card)),nl.

% TO DO: can we compute this directly rather than using recursion ?
pinj_card(I,M,N,Acc,Res) :- (I>M ; I>N ; Acc=inf),!, Res=Acc.
pinj_card(I,M,N,Acc,Res) :-
  %print(pinj_card(I,M,N,Acc,Res)),nl,
  choose_nk(M,I,MI), % ways to choose domain of size I
  blocking_factorial_k(N,I,NI), % ways to map the domain of size I to N
  safe_mul(MI,NI,MINI), safe_add(MINI,Acc,NewAcc),
  %print(pinj(I,M,N,MI,NI,MINI,NewAcc)),nl,
  I1 is I+1, pinj_card(I1,M,N,NewAcc,Res).

:- public total_bijection_card/3. % exported in is_a_relation above
:- block total_bijection_card(-,?,?), total_bijection_card(?,-,?).
total_bijection_card(inf,inf,Card) :- !, print_inf_warning(inf,'>->>'), Card=inf.
total_bijection_card(DCard,RCard,Card) :- DCard \= RCard,!,Card=0.
total_bijection_card(RCard,RCard,Card) :- blocking_factorial(RCard,Card).




:- block is_infinite_global_set(-).
is_infinite_global_set('NATURAL').
is_infinite_global_set('NATURAL1').
is_infinite_global_set('INTEGER').
is_infinite_global_set('STRING').

is_finite_integer_global_set('NAT').
is_finite_integer_global_set('NAT1').
is_finite_integer_global_set('INT').

% detects (certain) infinite explict sets
is_infinite_explicit_set(X) :- var(X),!, add_internal_error(is_infinite_explicit_set,var(X)),fail.
is_infinite_explicit_set(global_set(X)) :- is_infinite_global_set(X).
is_infinite_explicit_set(freetype(X)) :- is_infinite_freetype(X).
is_infinite_explicit_set(closure(Par,T,Body)) :- is_infinite_closure(Par,T,Body).

% detect some closure that we should definitely expand; even in SYMBOLIC mode or for ABSTRACT_CONSTANTS
definitely_expand_this_explicit_set(closure(P,_T,B)) :-
   B = b(Body,_,_), definitely_expand(Body,P).
   % some lambda functions have small domain, but are very complicated to compute (test 1078, 1376)
   % hence the following is not sufficient:
   % ;is_small_specific_custom_set(closure(P,T,B),100), print(exp(T)),nl,translate:print_bexpr(B),nl,fail).

definitely_expand(Body,_) :- avl_mem_construct(Body,_).
definitely_expand(exists(TEIDS,Body),P) :- P = [ID], TEIDS = [TEID], % TO DO: detect multiple ids
% detect {res|#y.(y:AVL & res=Expr(y))} % test 1101
   Body = b(conjunct(b(Mem,pred,_),Eq),pred,_),
   Eq = b(equal(EqA,EqB),pred,_),
   avl_mem_construct(Mem,LHS), get_texpr_id(LHS,EID), get_texpr_id(TEID,EID),
   (get_texpr_id(EqA,ID) -> true ; get_texpr_id(EqB,ID)).

avl_mem_construct(member(LHS,RHS),LHS) :- RHS = b(value(V),_,_), nonvar(V), V=avl_set(_).

dont_expand_this_explicit_set(closure(P,T,B)) :-  !, dont_expand_this_closure(P,T,B).
dont_expand_this_explicit_set(S) :- is_infinite_or_very_large_explicit_set(S).

% true if we have a closure / global_set that should not be expanded
dont_expand_symbolic_explicit_set(closure(P,T,B)) :-  !, dont_expand_this_closure(P,T,B).
dont_expand_symbolic_explicit_set(avl_set(_)) :- !, fail. % already expanded
dont_expand_symbolic_explicit_set(S) :- is_infinite_or_very_large_explicit_set(S).


dont_expand_this_explicit_set(closure(P,T,B),Limit) :-  !, dont_expand_this_closure(P,T,B,Limit).
dont_expand_this_explicit_set(S,_) :- is_infinite_or_very_large_explicit_set(S).

dont_expand_this_closure(P,T,B) :- dont_expand_this_closure(P,T,B,20000).

dont_expand_this_closure(P,T,B,_Limit) :- %print(check_expand(P,T,B)),nl,
   is_interval_closure_or_integerset(closure(P,T,B),Low,Up), !,
   % interval closures are quite efficient for certain manipulations
   (number(Low), number(Up)
     -> Size is Up+1-Low, Size>100 % another magic constant ; which value to choose ??
     ;  true % we have a closure with inf/minus_inf or variables as bounds; in both cases keep the closure
   ).
dont_expand_this_closure(_P,_T,b(_,_,INFO),_Limit) :- %print(check_info(INFO)),nl,
   member(prob_annotation('SYMBOLIC'),INFO). % not yet generated by parser or type checker
dont_expand_this_closure(P,T,B,Limit) :- is_infinite_or_very_large_closure(P,T,B,Limit).

is_recursive_closure(_P,_T,b(_,_,INFO)) :-
   member(prob_annotation('RECURSIVE'),INFO).
is_symbolic_closure(V) :- nonvar(V), V=closure(P,T,B),
   is_symbolic_closure(P,T,B).
is_symbolic_closure(_P,_T,b(_,_,INFO)) :-
   member(prob_annotation('SYMBOLIC'),INFO).
is_converted_lambda_closure(_P,_T,b(_,_,INFO)) :-
   member(prob_annotation('LAMBDA'),INFO).
is_symbolic_closure_or_symbolic_mode(P,T,B) :-
   (is_symbolic_closure(P,T,B) -> true
    ; preference(convert_comprehension_sets_into_closures,true) % by default suppose closures should be dealt with symbolically
   ).
/*
% check both LAMBDA + not RECURSIVE
is_converted_non_recursive_lambda_closure(_,_,b(_,_,INFO)) :- is_conv_lambda_nonrec(INFO).
is_conv_lambda_nonrec([prob_annotation(A)|T]) :- !,
   (A='LAMBDA' -> \+ memberchk(prob_annotation('RECURSIVE'),T)
    ; A\='RECURSIVE' -> is_conv_lambda_nonrec(T)).
is_conv_lambda_nonrec([_|T]) :- is_conv_lambda_nonrec(T). */

mark_closure_as_symbolic(C,R) :- mark_closure(C,['SYMBOLIC'],R).
mark_closure_as_recursive(C,R) :- mark_closure(C,['SYMBOLIC','RECURSIVE'],R).
:- block mark_closure(-,?,?).
mark_closure(closure(P,T,B),ANN,R) :- !, mark_aux(P,T,B,ANN,R).
mark_closure(A,_,A). % not a closure
:- block mark_aux(?,?,-,?,?).
mark_aux(P,T,b(Pred,pred,INFO),ANN,Res) :-
   (ground(INFO) -> mark_info(ANN,INFO,RINFO) %,print(marked_closure(P,RINFO)),nl
    ; add_error(mark_aux,'Info field not set: ',closure(P,T,b(Pred,pred,INFO))),
      RINFO=INFO),
   Res = closure(P,T,b(Pred,pred,RINFO)).

mark_info([],INFO,INFO).
mark_info([ANN|T],INFO,Res) :-
   (member(prob_annotation(ANN),INFO) -> Res=TRes ; Res = [prob_annotation(ANN)|TRes]),
   mark_info(T,INFO,TRes).


% a set that is so large that expanding it would probably cause problems
is_infinite_or_very_large_explicit_set(S) :- is_infinite_or_very_large_explicit_set(S,20000).

%:- use_module(library(terms),[term_hash/2]).
is_infinite_or_very_large_explicit_set(X,_) :- var(X),!,print(var_is_infinite_check(X)),nl,fail.
is_infinite_or_very_large_explicit_set(closure(P,T,B),Limit) :- !,
   % treat closure separately here; some special rules
  is_infinite_or_very_large_closure(P,T,B,Limit).
is_infinite_or_very_large_explicit_set(avl_set(A),Limit) :- !, % we could compute log and use avl_height_less_than
   quick_avl_approximate_size(A,Size), Size >= Limit.
is_infinite_or_very_large_explicit_set(X,Limit) :- % closures are checked above
   explicit_set_cardinality(X,Card),
   card_gt_limit(Card,Limit).

:- use_module(bsyntaxtree,[is_a_disjunct/3]).
is_infinite_or_very_large_closure(P,T,B,Limit) :-
   is_a_disjunct(B,D1,D2), % Assumption: there is no card_for_specific_closure code for disjuncts
   !,
   (is_infinite_or_very_large_closure(P,T,D1,Limit) -> true
     ; is_infinite_or_very_large_closure(P,T,D2,Limit)).
is_infinite_or_very_large_closure(Par,T,Body,Limit) :-
   is_closure1_value_closure(Par,T,Body,VAL),!,
   % print(check_infinite(VAL,Limit)),nl,
   nonvar(VAL), % it could still be large or infinite
   (Limit>1 -> NLimit is Limit/2 ; NLimit = Limit), % reduce limit as closure1 usually blows up
   is_infinite_or_very_large_explicit_set(VAL,NLimit).
is_infinite_or_very_large_closure(P,T,B,Limit) :-
     %print(check),nl,translate:print_bvalue(CS),nl,
   %hashing:super_hash(CS,H),print(hash(H)),nl, (H==245697886 -> trace ; true),
   card_for_specific_closure2(P,T,B,Card,Code), call(Code),!,
   %print(card_of_cs(Card,Limit)),nl,
   card_gt_limit(Card,Limit).

card_gt_limit(Card,Limit) :- (Card==inf -> true ; number(Card),Card>Limit).

is_infinite_or_symbolic_closure(P,T,B) :-
   (is_symbolic_closure(P,T,B) -> true ; is_infinite_closure(P,T,B)).
is_infinite_closure(P,T,B) :-
   is_a_disjunct(B,D1,D2), % Assumption: there is no card_for_specific_closure code for disjuncts
   !,
   (is_infinite_closure(P,T,D1) -> true ; is_infinite_closure(P,T,D2)).
is_infinite_closure(Par,T,Body) :-
   is_closure1_value_closure(Par,T,Body,VAL),!, % TO DO: also check if closure1 is large this way
   %print(check_infinite(VAL)),nl,
   nonvar(VAL), % if var: it could still be infinite !! TO DO fix
   is_infinite_explicit_set(VAL).
is_infinite_closure(Par,T,Body) :- % print(checking_inf_closure(Par,T,Body)),nl,
  card_for_specific_closure(closure(Par,T,Body),Card,Code),
  call(Code),ground(Card), Card == inf.



/* transitive closure */
closure1_for_explicit_set(avl_set(A),Res) :-
     preferences:preference(use_closure_expansion_memoization,true),!,
     term_hash(closure1_for_explicit_set(A),
               [range(smallint),algorithm(sdbm), depth(infinite),if_var(ignore)],Hash),
    (stored_expansion(Hash,closure1_for_explicit_set,[],A,StoredResult)
       -> Res = StoredResult
       ;  closure1_for_explicit_set_direct(avl_set(A),Result),
          assert(stored_expansion(Hash,closure1_for_explicit_set,[],A,Result)),
          Res = Result
    ).
closure1_for_explicit_set(avl_set(A),Res) :- closure1_for_explicit_set_direct(avl_set(A),Res).

% sometimes faster, but can also be considerably slower:
%:- use_module(probsrc(avl_ugraphs),[avl_transitive_closure/2]).
%closure1_for_explicit_set_direct(avl_set(A),Res) :-
%    avl_transitive_closure(A,TC),
%    construct_avl_set(TC,Res).
closure1_for_explicit_set_direct(avl_set(A),Res) :-
     avl_domain(A,AList),
     %debug:time(custom_explicit_sets:iterate_closure(AList,A,A,IterationRes)),
     iterate_closure(AList,A,A,IterationRes),
     construct_avl_set(IterationRes,Res).

/* transitive closure starting from some initial set */
/* not sure if we should do this:
 closure1_for_explicit_set_from(avl_set(A),StartFrom,Res) :-
     preferences:preference(use_closure_expansion_memoization,true),
     term_hash(closure1_for_explicit_set(A),
               [range(smallint),algorithm(sdbm), depth(infinite),if_var(ignore)],Hash),
     stored_expansion(Hash,closure1_for_explicit_set,[],A,StoredResult),!,
     domain_restriction_explicit_set(StartFrom,StoredResult,Res). */
closure1_for_explicit_set_from(avl_set(A),StartFrom,Res) :-
     avl_domain(A,AList),
     filter_start_relation(AList,StartFrom,FAList),
     (FAList = [] -> Res=[]
      ; convert_to_avl(FAList,avl_set(Start)),
        %debug:time(custom_explicit_sets:iterate_closure(FAList,A,Start,IterationRes)),
        iterate_closure(FAList,A,Start,IterationRes),
        construct_avl_set(IterationRes,Res)).
filter_start_relation([],_,[]).
filter_start_relation([(X,Y)|T],StartSet,Res) :-
    (element_of_custom_set(X,StartSet) -> Res = [(X,Y)|RT] ; Res=RT),
    filter_start_relation(T,StartSet,RT).

iterate_closure([],_,Res,Res).
iterate_closure([(X,Y)|T],InitialRelation,Relation,Res) :- %print(iterate(Key,InitialRelation,Relation,Res)),
    %(Key = (X,Y) -> true ; add_error_and_fail(iterate_closure,'Not a relation element: ',Key)),
    add_tuples(X,Y,InitialRelation,Relation,NewRelation,AddedTuples),
    % better: do added tuples straight away ?
    iterate_closure(T,InitialRelation,NewRelation,NewRelation2),
    iterate_closure(AddedTuples,InitialRelation,NewRelation2,Res).

add_tuples(X,Y,AVL,AVLClosureSoFar,Res,NewTuples) :-
   findall((X,Z), (avl_fetch_pair(Y,AVL,Z), %ok instead of safe_avl_member((Y,Z),AVL),; Y in AVL form, Z var
                   %Y \= Z,  % self-loops are already in initial AVLClosure, this will never add a new pair
                   % if we use AVLClosureSoFar instead of AVL: considerably slower
                   \+ avl_fetch((X,Z),AVLClosureSoFar)), NewTuples),
   add_to_avl(NewTuples,AVLClosureSoFar,Res).

% SUBSET_OF <:
% subset_of_explicit_set: returns code to be executed if this subset check can be done in an optimized way
% TO DO: add strict_subset <<: + more cases, e.g.,  interval & avl_set, ...
% interval & interval already handled in check_subset_of_global_sets
subset_of_explicit_set(AVL,Closure,Code,_WF) :- nonvar(AVL),AVL=avl_set(A),
   is_interval_closure_or_integerset(Closure,Low,Up),!,
   Code=custom_explicit_sets:check_avl_in_interval(A,Low,Up).
subset_of_explicit_set(AVL1,AVL2,Code,_WF) :- % print_term_summary(try_sub(AVL1,AVL2)), %
   nonvar(AVL1),AVL1=avl_set(A1), nonvar(AVL2),AVL2=avl_set(A2),!,
   %print_term_summary(subset_avl(AVL1,AVL2)),nl,
   Code = custom_explicit_sets:check_avl_subset(A1,A2).
subset_of_explicit_set(C1,C2,Code,WF) :- nonvar(C1), is_cartesian_product_closure(C1,S11,S12),!,
  %print(is_cartesian_product_closure(C1,S11,S12)),
 ((S11==[] ; S12==[]) -> Code=true  /* we always have a subset */
   ; is_definitely_not_empty(S11),
     is_definitely_not_empty(S12), % only use optimisation if we know S11, S12 to be non-empty
     nonvar(C2), is_cartesian_product_closure(C2,S21,S22),
     %print(subset_of_cartesian_products(S11,S12,S21,S22)),nl,
     Code = (kernel_objects:check_subset_of_wf(S11,S21,WF),
             kernel_objects:check_subset_of_wf(S12,S22,WF) )
 ).
subset_of_explicit_set(Set1,Set2,Code,WF) :-
   nonvar(Set2),is_cartesian_product_closure(Set2,S21,S22),!,
   % TO DO: maybe don't do this if Set1 is avl_set ??
   debug_println(9,'Applying C <: S21*S22 <=> C : S21 <-> S22'),
   Code = bsets_clp:relation_over_wf(Set1,S21,S22,WF).
subset_of_explicit_set(C1,C2,Code,WF) :- nonvar(C1), nonvar(C2),
  is_powerset_closure(C1,Constructor1,Set1),
  is_powerset_closure(C2,Constructor2,Set2),
  %print(subset(Constructor1,Set1,Constructor2,Set2)),nl,
  subset_constructor(Constructor1,Constructor2,R), %print(comparison(R)),nl,
  !,
  Code = (R=pred_true, kernel_objects:check_subset_of_wf(Set1,Set2,WF)).

subset_constructor(X,X,R) :- !,R=pred_true.
subset_constructor(fin1,_,R) :- !,R=pred_true.
subset_constructor(fin,pow,R) :- !,R=pred_true.
subset_constructor(X,Y,R) :- strict_subset_constructor(X,Y),!,R=pred_true.
subset_constructor(X,Y,R) :- strict_subset_constructor(Y,X),!,R=pred_false.
% pow1,fin1 ;  pow,fin ; and  pow1,fin only ok if type infinite
strict_subset_constructor(pow1,pow).
strict_subset_constructor(fin1,fin).

% more rules for <->, +->, ...
% what if same closure: then we also know it is a subset

% to be completed:
% code that instantiates R to subset or not_subset, may have to delay
test_subset_of_explicit_set(AVL,Closure,R,_WF,Code) :- nonvar(AVL),AVL=avl_set(A),
   is_interval_closure_or_integerset(Closure,Low,Up),!,
   Code=custom_explicit_sets:test_avl_in_interval(A,Low,Up,R).
test_subset_of_explicit_set(AVL1,AVL2,R,_WF,Code) :- %print_term_summary(try_sub(AVL1,AVL2)),
   nonvar(AVL1),AVL1=avl_set(A1), nonvar(AVL2),AVL2=avl_set(A2),
   Code = (custom_explicit_sets:check_avl_subset(A1,A2) -> R=pred_true ; R=pred_false).
% TO DO: add is_cartesian_product_closure case

:- public test_avl_in_interval/4. % used in test_subset_of_explicit_set
test_avl_in_interval(A,Low,Up,R) :-
   (check_avl_in_interval(A,Low,Up) -> R=pred_true ; R=pred_false).

is_definitely_not_empty(X) :- nonvar(X),
  (X=[_|_] -> true
    ; is_custom_explicit_set(X), is_non_empty_explicit_set(X)).

% check if defnitely not empty and provide a witness
is_definitely_not_empty_with_witness(X,El) :- nonvar(X),
    get_witness_element(X,El).
get_witness_element([H|_],H).
get_witness_element(avl_set(node(H,_True,_,_,_)),H).
% TO DO: add global_set(GS),...

check_avl_subset(A1,A2) :- avl_max(A1,Max1), avl_max(A2,Max2),
   Max1@>Max2,!,
   %nl,print(prune_check_avl_subset(Max1,Max2)),nl,nl,
   fail.
check_avl_subset(A1,A2) :-
   avl_min(A1,Cur1), avl_min(A2,Cur2),
   check_avl_subset_loop(Cur1,A1,Cur2,A2).
check_avl_subset_loop(Cur1,AVL1,Cur2,AVL2) :-
   (Cur1 @> Cur2 -> avl_next(Cur2,AVL2,NC2), check_avl_subset_loop(Cur1,AVL1,NC2,AVL2)
     ; Cur1=Cur2 -> (avl_next(Cur1,AVL1,NC1)
                      -> avl_next(Cur2,AVL2,NC2),
                         check_avl_subset_loop(NC1,AVL1,NC2,AVL2)
                      ;  true /* all objects of AVL1 inspected */)
   ).

check_avl_in_interval(A,Low,Up) :-  % does not have to delay: if we have minus_inf & inf they will be known straightaway
   (Low==minus_inf -> true
    ; avl_min(A,Min), kernel_objects:less_than_equal(int(Low),Min)),
   (Up==inf -> true
    ; avl_max(A,Max), kernel_objects:less_than_equal(Max,int(Up))).

:- public not_check_avl_subset/2. % used in not_subset_of_explicit_set_aux
not_check_avl_subset(A1,A2) :- \+ check_avl_subset(A1,A2).

not_subset_of_explicit_set(S1,S2,Code,WF) :- nonvar(S1),
   not_subset_of_explicit_set_aux(S1,S2,Code,WF).
not_subset_of_explicit_set_aux(avl_set(A),Closure,Code,_WF) :-
   is_interval_closure_or_integerset(Closure,Low,Up),!,
   Code=custom_explicit_sets:check_avl_not_in_interval(A,Low,Up).
not_subset_of_explicit_set_aux(avl_set(A1),AVL2,Code,_WF) :-
   nonvar(AVL2),AVL2=avl_set(A2),
   %print(not_subset_avl(Cur1,Cur2)),nl,
   Code = custom_explicit_sets:not_check_avl_subset(A1,A2).
not_subset_of_explicit_set_aux(global_set(G),AVL,Code,_WF) :-
   \+ is_finite_integer_global_set(G), % TO DO: provide code for interval/NAT/INT /<: AVL
   nonvar(AVL), AVL=avl_set(A2),
   !,
   (is_infinite_global_set(G) -> Code = true % G cannot be subset of finite set
     ; % G must be maximal
       b_global_set_cardinality(G,Card1), avl_size(A2,Card2),
       %print(c(Card1,Card2)),nl,
       Code = dif(Card1,Card2) % if same size they must be equal; otherwise AVL must be strictly contained in G
    ).
not_subset_of_explicit_set_aux(C1,C2,Code,WF) :- is_cartesian_product_closure(C1,S11,S12),
  %print(is_cartesian_product_closure(C1,S11,S12)),
 ((S11==[] ; S12==[]) -> Code=fail  /* we always have a subset */
   ; is_definitely_not_empty(S11),
     is_definitely_not_empty(S12), % only use optimisation if we know S11, S12 to be non-empty
     nonvar(C2), is_cartesian_product_closure(C2,S21,S22),
     % print(not_subset_of_cartesian_products(S11,S12,S21,S22)),nl, %
     Code = (kernel_objects:not_both_subset_of(S11,S12, S21,S22, WF))).
not_subset_of_explicit_set_aux(C1,C2,Code,WF) :- nonvar(C2),
  is_powerset_closure(C1,Constructor1,Set1),
  is_powerset_closure(C2,Constructor2,Set2),
  %print(not_subset(Constructor1,Set1,Constructor2,Set2)),nl,
  subset_constructor(Constructor1,Constructor2,R), %print(comparison(R)),nl,
  Code = (R=pred_false -> true ; kernel_objects:not_subset_of_wf(Set1,Set2,WF)).

:- public check_avl_not_in_interval/3. % used in not_subset_of_explicit_set_aux
:- block check_avl_not_in_interval(?,-,?).
check_avl_not_in_interval(A,Low,Up) :- avl_min(A,Min),
  % print(avl_not_in_interval(Min,Max,Low,Up)),nl,
   ((Low \== minus_inf, kernel_objects:less_than(Min,int(Low)))
    ;
    (Low==minus_inf -> true ; kernel_objects:less_than_equal(int(Low),Min)),
     Up \== inf, avl_max(A,Max),
     kernel_objects:less_than(int(Up),Max)).


% IMAGE [.]
image_for_id_closure(closure(Par,Types,Body),Set,Res) :-
   is_full_id_closure(Par,Types,Body),!,
    % print(image_of_full_id_closure(Set,Res)),nl, %%
   Res=Set.

image_for_explicit_set(closure(Par,Types,Body),Set,Res,WF) :-
    image_for_closure(Par,Types,Body,Set,Res,WF).
image_for_explicit_set(avl_set(A),Set,Res,WF) :-   nonvar(Set),
    image_for_explicit_avl_set(A,Set,Res,WF).


image_for_closure([X,Y],[_TX,TY],Pred,Set,Res,WF) :-
   singleton_set(Set,SX),
   nonvar(SX), % otherwise it may be better to use standard image propagation
                       % e.g., testcase 1536 sqr = %x.(x>=0|x*x) & (sqr)[{xx,vv}] = {2500}
                       % TO DO: improve equal_explicit_sets so that 1536 also works without nonvar(SX) test above; do we need this rule for singleton_sets anyway ?
   !,
   b_compiler:b_compile(Pred,[Y],[],[bind(X,SX)],NewPred,WF),
       % compilation avoids introduction of let_predicate
       %   Res = closure([Y],[TY],NewPred).
   construct_closure_if_necessary([Y],[TY],NewPred,Res).
      % we could provide optimized code for is_lambda_value_domain_closure([X,Y],[_TX,TY],Pred, DomainValue,Expr)
      % if SX in Dom (membership_test_wf(SX,DomainValue,WF,MemRes)) then Res = [Expr/RY]; else Res=[]   b_interpreter:b_test_boolean_expression(Pred,[bind(X,SX),bind(Y,RY)],[],WF)
  % Res = closure([Y],[TY],b(let_predicate([b(identifier(X),TX,[])],[b(value(SX),TX,[])],Pred),pred,[])).
  % ,print(image_for_closure),nl,translate:print_bvalue(Res),nl,print(done),nl.
image_for_closure(Par,Types,Body,Set,Res,_WF) :-
   is_id_closure_over(Par,Types,Body,ID_Domain,Full),!,
   %print(image_of_id_closure_over(ID_Domain,Full,Set,Res)),nl, %%
   (Full=true -> Res=Set ; kernel_objects:intersection(ID_Domain,Set,Res)).
% infinite function case dealt with in image1 in bsets_clp
% TO DO: other closure(); Maybe special case if Set is an interval ?
image_for_closure(Par,Types,Body,Set,Res,WF) :-
    is_closure1_value_closure(Par,Types,Body,VAL),
    %print(image_for_closure_closure1(VAL)),nl,
    % compute closure1(VAL)[Set]
    bsets_clp:image_for_closure1_wf(VAL,Set,Res,WF).

is_closure1_value_closure(Par,Types,Body,VAL) :-
    is_member_closure(Par,Types,Body,couple(A,A),MemSET), nonvar(MemSET),
    MemSET = closure(V), % this is the closure1 B operator !
    nonvar(V), V=b(value(VAL),_,_).

image_for_explicit_avl_set(A,Set,Res,_WF) :- % Set is nonvar
    is_interval_closure_or_integerset(Set,From1,To1),!,
    % Note: if From1, To1 not yet known we will block and not revert to other image calculation code
    % Important e.g. for performance of San Juan (AdaptedBModelPropCheck/acs_as_env_cfg_ipart.mch)
    %we used to check for: ground(From1),ground(To1),
    interval_image_for_explicit_avl_set(From1,To1,A,Set,Res).
image_for_explicit_avl_set(A,Set,Res,WF) :-
    %%(bsets_clp:keep_symbolic(Set) -> print_term_summary(keep_symbolic(Set,A)),nl, fail ; true),
    \+ bsets_clp:keep_symbolic(Set), % in this case we fall back to treatment in bsets_clp (image1)
    expand_custom_set_to_list_gg(Set,ESet,GG,image_for_explicit_avl_set),
    empty_avl(Empty),
    %  print_term_summary(image_explicit(GG,Set,ESet,A,Empty,Res)),nl,
    (GG=guaranteed_ground -> image_explicit_ground(ESet,A,Empty,Res,WF)
      ; image_explicit(ESet,A,Empty,Res,WF)).
   % print_term_summary(image_explicit_res(ESet,A,Empty,Res)).

:- block interval_image_for_explicit_avl_set(-,?,?,?,?),
         interval_image_for_explicit_avl_set(?,-,?,?,?).
interval_image_for_explicit_avl_set(From1,To1,_A,_Set,Res) :-
    number(From1), number(To1), From1>To1,!,
    kernel_objects:empty_set(Res).
interval_image_for_explicit_avl_set(From1,To1,A,_Set,Res) :-
    % print(image_avl_interval(From1,To1)),nl,
    findall(Image-true, avl_image_interval(From1,To1, A,Image),ImageList),
    %print(image_list(ImageList)),nl,
    normalised_list_to_avl(ImageList,ImageAvl),
    equal_object(ImageAvl,Res).


singleton_set(X,_) :- var(X),!,fail.
singleton_set([H|T],H) :- !, T==[].
singleton_set(avl_set(node(Y,_,_,empty,empty)),Y). % same as is_one_element_custom_set

is_one_element_custom_set(avl_set(node(Y,_,_,empty,empty)),Y).
is_one_element_avl(node(Y,_,_,empty,empty),Y).

construct_one_element_custom_set(El,avl_set(AVL)) :-
   empty_avl(E),avl_store(El,E,true,AVL).

construct_avl_set(Avl,Res) :- empty_avl(Avl) -> Res = [] ; Res = avl_set(Avl).

:- block image_explicit(-,?,?,?,?).
image_explicit([],_,Acc,Res,WF) :- !,
   construct_avl_set(Acc,AVLS),
   kernel_objects:equal_object_wf(Res,AVLS,image_explicit,WF).
image_explicit([D1|T],AVLRelation,In,Out,WF) :- !, %print_term_summary(image(D1,T,AVLRelation,In,Out)),nl,
   ground_value_check(D1,G1),
   ((var(T);T==[]) % TO DO: see below, make propagation also interesting in other circumstances
    -> must_be_in_domain_check(G1,D1,T,AVLRelation,In,Out,WF)
     ; true),
   image_explicit_aux(G1,D1,AVLRelation,T,In,Out,WF).
image_explicit(Set,_,_,_,_) :- add_error_and_fail(image_explicit,'Unknown set: ',Set).

% a version of image_explicit where the list is guaranteed to be ground
image_explicit_ground([],_,Acc,Res,WF) :- !,
   construct_avl_set(Acc,AVLS),
   kernel_objects:equal_object_wf(Res,AVLS,image_explicit,WF).
image_explicit_ground([D1|T],AVLRelation,In,Out,WF) :- !, %print_term_summary(image(D1,T,AVLRelation,In,Out)),nl,
   image_explicit_aux_ground(D1,AVLRelation,T,In,Out,WF).
image_explicit_ground(Set,_,_,_,_) :- add_error_and_fail(image_explicit_ground,'Unknown set: ',Set).

:- block must_be_in_domain_check(-,?,?,?,?,-,?),
         must_be_in_domain_check(-,?,-,?,?,?,?).
% if result requires at least one more element, then D must be in domain of Relation
% ensures that we get a domain for j in x = {1|->2,2|->4, 4|->8} & x[{j}]={8}
% we could even propagate using inverse of AVLRelation ?!
must_be_in_domain_check(GroundD,D,T,AVLRelation,In,Out,WF) :-
   T==[], % apart from D, there are no more elements to be added
   var(GroundD), % otherwise we already have a value for D
   delta_witness(In,Out,Witness), % obtain at least one value that D must map to
   !,
   % print(in_domain(D,AVLRelation)),nl,
   quick_propagation_element_information(avl_set(AVLRelation),(D,Witness),WF,_). % Witness avoids pending co-routines
   % TO DO: we could check that *all* elements of Out have this value
   % TO DO: below we could check that In is a subset of Out; e.g., for x = %i.(i:1..10|i+i) & x[{5,j,k}]={16,11}; we could also check that Out is subset of range of relation
must_be_in_domain_check(_,_D,_T,_,_In,_Out,_). % :- print(must_be(D,T,In,Out)),nl.

% provide, if possible, a witness element in Out not in In
delta_witness(In,Out,_Witness) :- (var(In) ; var(Out)),!,fail.
%delta_witness(empty,Out,Witness) :- is_definitely_not_empty_with_witness(Out,Witness).
delta_witness(In,Out,Witness) :-
    is_custom_explicit_set(Out,delta_witness),
    difference_of_explicit_set(Out,avl_set(In),Diff), % could be expensive to compute !? delay ? print(delta(Diff)),nl,
    is_definitely_not_empty_with_witness(Diff,Witness). %, print(witness(Witness)),nl.


:- block image_explicit_aux(-,?,?, ?,?,?,?). % we know that D1 is ground
image_explicit_aux(_,D1,AVLRelation,T,In,Out,WF) :-
        all_images(D1,AVLRelation,NewImages), % compute AVLRelation[{D1}]
        add_to_avl(NewImages,In,In2),
        image_explicit(T,AVLRelation,In2,Out,WF).
image_explicit_aux_ground(D1,AVLRelation,T,In,Out,WF) :-
        all_images(D1,AVLRelation,NewImages), % compute AVLRelation[{D1}]
        add_to_avl(NewImages,In,In2),
        image_explicit_ground(T,AVLRelation,In2,Out,WF).

all_images(From,AVLRelation,Images) :-
  findall(AY,avl_member_pair_arg1_ground(From,AY,AVLRelation),Images).  % we know From ground and AY free variable
  % findall(AY,safe_avl_member_pair(From,AY,AVLRelation),Images).  %

% compute relational composition ( ; ) if second arg is an AVL set
% TO DO: add support for infinite closures; avoid expanding them [currently handled by symbolic composition in bsets_clp]
rel_composition_for_explicit_set(Rel1,Rel2,Comp) :- nonvar(Rel2),
    Rel2=avl_set(A2),  % TO DO: see if we can maybe convert Rel2 to AVL ?
    % \+ bsets_clp:keep_symbolic(Rel1), check already done in bsets
    expand_custom_set_to_list_gg(Rel1,Relation1,GG,rel_composition_for_explicit_set),
    % print_term_summary(computing_rel_comp(GG,Rel1,Rel2,Comp)),nl,
    empty_avl(In),
    (GG=guaranteed_ground -> rel_avl_compose2_ground(Relation1,A2,In,Comp)
      ; rel_avl_compose2(Relation1,A2,In,Comp)).

:- block rel_avl_compose2(-,?,?,?).
rel_avl_compose2([],_,In,Res) :- construct_avl_set(In,A),
   equal_object(Res,A,rel_avl_compose2).  % as we delay; we need to use equal_object at the end
rel_avl_compose2([(X,Y)|T],A2,In,Out) :-
  when((ground(X),ground(Y)),
   (all_image_pairs(X,Y,A2,ImagePairs), % print(adding_pairs(X,Y,ImagePairs)),nl,
    add_to_avl(ImagePairs,In,In2),
    rel_avl_compose2(T,A2,In2,Out))).

% a version where argument is guaranteed to be ground:
rel_avl_compose2_ground([],_,In,Res) :- construct_avl_set(In,A),
    equal_object(Res,A,rel_avl_compose2).  % as we delay; we need to use equal_object at the end
rel_avl_compose2_ground([(X,Y)|T],A2,In,Out) :-
    all_image_pairs_ground(X,Y,A2,ImagePairs), % print(adding_pairs(X,Y,ImagePairs)),nl,
    add_to_avl(ImagePairs,In,In2),
    rel_avl_compose2_ground(T,A2,In2,Out).

all_image_pairs(From,To,AVLRelation,ImagePairs) :-
  findall((From,AY),safe_avl_member_pair(To,AY,AVLRelation),ImagePairs).
all_image_pairs_ground(From,To,AVLRelation,ImagePairs) :-
  findall((From,AY),avl_member_pair_arg1_ground(To,AY,AVLRelation),ImagePairs).
  % To: already in AVL format; AY is variable -> we could use avl_fetch_pair directly : findall((From,AY),avl_fetch_pair(To,AVLRelation,AY),ImagePairs).

/* succeeds if it can compute domain by some clever way */
domain_of_explicit_set(global_set(GS),_R) :- !,
    add_error_and_fail(domain_of_explicit_set,'Cannot compute domain of global set: ',GS).
domain_of_explicit_set(freetype(GS),_R) :- !,
    add_error_and_fail(domain_of_explicit_set,'Cannot compute domain of freetype: ',GS).
domain_of_explicit_set(avl_set(A),Res) :- !,
    avl_domain(A,EC), % -> expand_custom_set(avl_set(A),EC),
  % print_term_summary(computing_domain_of_avl(EC,Res)),nl,
   domain(EC,R),ord_list_to_avlset(R,Res,domain).
domain_of_explicit_set(C,R) :- dom_for_specific_closure(C,Dom,_),!,
   %print(dom_for_specific_closure(C,Dom)),nl,
   Dom=R.
domain_of_explicit_set(C,R) :- % print(try_symbolic(C)),nl,
   dom_symbolic(C,CC),!,  % print_term_summary(dom_symbolic(C,CC)),nl,
   R=CC.
domain_of_explicit_set(closure(P,T,B),Res) :-
   % print_term_summary(domain_of_closure(P,T,B,Res)),nl,
   expand_custom_set(closure(P,T,B),EC,domain_of_explicit_set),
   domain(EC,R),
   normalised_list_to_avl_when_ground(R,Res).

:- use_module(bsyntaxtree,[create_exists/3, create_typed_id/3]).
dom_symbolic(closure(Paras,Types,Pred), Res) :-
   expand_pair_closure(Paras,Types,Pred,[X,Y],[TX,TY],NewPred),!,
   % simply call code for range ; inverting arguments
   ran_symbolic_closure(Y,[X],TY,[TX],NewPred,Res).
dom_symbolic(closure(Paras,Types,Pred), Res) :-
   append(Xs,[Y],Paras), Xs \= [], % single argument which is a pair
   append(TXs,[TY],Types),
   % simply call code for range ; inverting arguments
   ran_symbolic_closure(Y,Xs,TY,TXs,Pred,Res).
% TO DO: allow computation if Paras is a single argument ?

% just computes domain: it can also be successful for lambda closures
dom_for_specific_closure(closure(P,T,Pred),Domain,Functionality) :-
   (is_lambda_value_domain_closure(P,T,Pred, DomainValue,_Expr)
    -> % print(lambda_closure_dom(DomainValue)),nl,
       % WARNING: what if _Expr is potentially not well-defined ?
       % we could miss well-definedness problems
       Domain=DomainValue, Functionality=function(total)
    ; dom_range_for_specific_closure2(P,T,Pred, Domain,_Range,Functionality)).
%dom_for_specific_closure(closure_x(P,T,Pred,_Exp),Card) :- dom_for_specific_closure2(P,T,Pred,Card).

dom_for_lambda_closure(closure(P,T,Pred),Domain) :-
    is_lambda_value_domain_closure(P,T,Pred, DomainValue,_Expr),
    Domain=DomainValue.

  % TO DO: add total functions
%dom_for_specific_closure2([F],[T],
%  b(member(b(identifier(F),T,_), b(total_function(value(A),B),set(couple(DOM,RAN)),_)), pred,_) ,
%   A).

:- block domain(-,?).
% the list will be sorted according to the term ordering for (_,_); hence it will
% already be sorted for the projection onto the first element
% maybe the speed difference is not worth it ??
domain([],[]).
domain([(A,_B)|T],[A-true|DT]) :- domain(T,A,DT).
:- block domain(-,?,?).
domain([],_,[]).
domain([(A,_B)|T],Prev,Res) :-
    (Prev==A
       -> domain(T,Prev,Res)
       ;  Res = [A-true|DT],
         (A @< Prev -> add_error_fail(custom_explicit_sets,'Domain list not_sorted: ',(A,Prev)) ; true),
          domain(T,A,DT) ).

/* succeeds if it can compute domain by some clever way */
range_of_explicit_set(global_set(GS),_R) :- !,
    add_error_and_fail(range_of_explicit_set,'Cannot compute domain of global set: ',GS).
range_of_explicit_set(freetype(GS),_R) :- !,
    add_error_and_fail(range_of_explicit_set,'Cannot compute domain of freetype: ',GS).
range_of_explicit_set(avl_set(A),Res) :- !,
   avl_domain(A,EC), % -> expand_custom_set(avl_set(A),EC),
   range(EC,R), normalised_list_to_avl(R,Res).
range_of_explicit_set(C,R) :- % print(try_ran(C)),nl,
   ran_for_specific_closure(C,Ran),!,
   %print_term_summary(ran_for_specific_closure(C,Ran)),nl,
   Ran=R.
range_of_explicit_set(C,R) :- % print(try_symbolic(C)),nl,
   ran_symbolic(C,CC),!, %print(ran_symbolic(C,CC)),nl,
   R=CC.
range_of_explicit_set(closure(P,T,B),Res) :-
   expand_custom_set(closure(P,T,B),EC,range_of_explicit_set),
   % TO DO: it would be more useful here to directly just expand the projection onto the last component of P
   range(EC,R), normalised_list_to_avl_when_ground(R,Res).

% TO DO: in future it is maybe better to add an in_range_wf kernel predicate
ran_symbolic(closure(Paras,Types,Pred), Res) :-
   expand_pair_closure(Paras,Types,Pred,[Y,X],[TY,TX],NewPred),!,
   % following test (1541) works with this: 2 : ran({y|#(x).(y = x |-> x + 2 & x  : NATURAL)})
   %print('range for pair transformation: '), print(cl(YX,Y,X)),nl,translate:print_bexpr(Pred1),nl,
   ran_symbolic_closure(Y,[X],TY,[TX],NewPred,Res). %, print('res: '),translate:print_bvalue(Res),nl.
ran_symbolic(closure([Y,X],[TY,TX],Pred), Res) :-
   ran_symbolic_closure(Y,[X],TY,[TX],Pred,Res).
% TO DO: treat closures with more arguments: we need to quantify Y1,...Yn [Y1,...,Yn,X]

   % Replace single Identifier YX of type pair by pair (Y,X) where Y,X are (fresh) variables not occuring in Pred
   % example: {y| #(x).(y = x |-> x + 2 & x  : NATURAL)}  --> {y__1,y__2|#(x).(y__1 |-> y__2 = x |-> x + 2 & x : NATURAL)}
expand_pair_closure([YX],[TYX],Pred,[Y,X],[TY,TX],NewPred) :- TYX = couple(TY,TX),
   % Replace single ID YX of type pair by pair (Y,X) where Y,X are (fresh) variables not occuring in Pred
   % example: {y| #(x).(y = x |-> x + 2 & x  : NATURAL)}  --> {y__1,y__2|#(x).(y__1 |-> y__2 = x |-> x + 2 & x : NATURAL)}
   % following test (1541) works with this: 2 : ran({y|#(x).(y = x |-> x + 2 & x  : NATURAL)})
   gensym:gensym(YX,Y),gensym:gensym(YX,X),
   create_typed_id(Y,TY,YTID), create_typed_id(X,TX,XTID),
   Pair = b(couple(YTID,XTID),TYX,[]),
   bsyntaxtree:replace_id_by_expr(Pred,YX,Pair,NewPred).

ran_symbolic_closure(Y,Xs,TY,TXs,Pred,Res) :-
   rename_ran_ids(Xs,Pred,[],XIDs,Pred2),
   create_typed_id(Y,TY,YTID),
   create_exists([YTID],Pred2,Exists),  % use create_and_simplify_exists(Paras,Pred,ResultingPred) ??
    %print(ran(Y,XID,TY,TX)),nl,translate:print_bexpr(Exists),nl,
   % removed_used_id(Exists,Y,Exists2), % create_exists now properly stes used_ids info !
   Res = closure(XIDs,TXs,Exists).

:- use_module(library(lists),[last/2]).
% for a closure get the identifier or proj expression that represents range values
get_range_id_expression([PairID],[Type],Res) :- !, Type = couple(_,TX),
    TP = b(identifier(PairID),Type,[]),
    safe_create_expression(second_of_pair(TP),TX,Res). % prj2(PairID) , TO DO: test this
get_range_id_expression(P,T,b(identifier(ID),Type,[])) :- last(P,ID), last(T,Type).

:- use_module(library(lists),[select/3]).
%removed_used_id(b(E,T,Info),ID_to_remove,b(E,T,Info2)) :-
%   (select(used_ids(IDS),Info,Info1) ->
%      (select(ID_to_remove,IDS,NewIDS) -> Info2 = [used_ids(NewIDS)|Info1]
%        ; print(projecting_away_unknown_range_id(ID_to_remove,IDS)),nl, translate:print_bexpr(b(E,T,Info)),nl, bsyntaxtree:check_ast(b(E,T,Info)),nl,
%          Info2 = Info)
%    ; add_internal_error('No used_ids Info: ', Info),
%      Info2 = Info).

% rename lambda_results :
rename_ran_ids([],Pred,_,[],Pred).
rename_ran_ids([X|TX],Pred,Acc,[XID|TTX],Pred2) :-
   % in case X is _lambda_result_ we need to rename it as it then would not get enumerated !
    (X == '_lambda_result_' -> get_fresh_id('_was_lambda_result_',TX,Acc,XID), % TO DO: also remove lambda_result info field!
                               rename_bt(Pred,[rename(X,XID)],Pred2),
                               TTX=TX
                               % maybe we should also remove the lambda_result info information inside Pred for the ids and equality !?
                              % TO DO: also store information about this in info field ?
    ; XID = X, rename_ran_ids(TX,Pred,[X|Acc],TTX,Pred2)
    ).

:- use_module(b_ast_cleanup,[get_unique_id/2]).
get_fresh_id(ID,List1,List2,Res) :- nonmember(ID,List1), nonmember(ID,List2),!, Res=ID.
get_fresh_id(ID,_,_,FRESHID) :- nl,print('*** VARIABLE_CLASH PREVENTED: '), print(ID),nl,
   get_unique_id(ID,FRESHID).

:- block range(-,?).
range([],[]).
range([(_A,B)|T],[B-true|DT]) :- range(T,DT).

ran_for_specific_closure(closure(P,T,Pred),Range) :- dom_range_for_specific_closure2(P,T,Pred, _Domain,Range,_Functionality).
%ran_for_specific_closure(closure_x(P,T,Pred,_Exp),Card) :- ran_for_specific_closure2(P,T,Pred,Card).

:- use_module(bsyntaxtree,[conjunct_predicates/2, disjunct_predicates/2, create_typed_id/3, get_texpr_type/2]).
override_custom_explicit_set(R,S,Res) :- /* R <+ S */
  nonvar(R),override_custom_explicit_set_aux(R,S,Res).
override_custom_explicit_set_aux(CL,Rel2,Res) :-
   CL=closure(P0,T,B0), %print(override_custom_explicit_set_aux(CL,Rel2,Res)),nl,
  % TO DO: maybe call keep_symbolic in bsets_clp ??
  ((preferences:get_preference(convert_comprehension_sets_into_closures,true),
    (var(Rel2) -> true ; Rel2 \= avl_set(_))) % if Rel2 is avl_set then maybe better to compute explicitly; unless infinite
    ; quick_size_check_larger_than(Rel2,Size2,133) ->
       % if we have a large AVL set anyway; then allow expansion up to a larger limit; cf machine 670_002.mch
       % a lot of machines use A*B*C <+ {....} to more compactly define large explicit sets
        (Size2=inf -> Limit = 200000
         ; Limit is min(200000,Size2*150)), dont_expand_this_closure(P0,T,B0,Limit)
    ; dont_expand_this_closure(P0,T,B0) % use default limit
  ),
  !,
  rename_ran_ids(P0,B0,[],P,B), % any '_lambda_result_' id is no longer guaranteed to be assigned a value in all cases
  % print_term_summary(override_infinite_closure(P,T,B,Rel2,Res) ),nl,
  NewClosure=closure(P,T,NewBody),
  % NewBody =  P:Rel2 or (prj1(P) /: dom(Rel2) & B)
  generate_typed_id_pairs(P,T,NestedPairs),
  get_texpr_type(NestedPairs,PairsType),
  RelPairsType = set(PairsType),
  ValS = b(value(Rel2),RelPairsType,[]),
  MemS = b(member(NestedPairs,ValS),pred,[]),  % P:Rel2
  %print(mems(MemS)),nl,
  get_prj1(NestedPairs,DomExpr),
  %% (NestedPairs=b(couple(DomExpr,_),_,_) -> true ; print('SYMBOLIC <+ : '), translate:print_bvalue(CL),nl, print_term_summary(override_custom_explicit_set_aux(CL,Rel2,Res)),nl),
  get_texpr_type(DomExpr,DomType),
  Domain = b(domain(ValS),DomType,[]),
  NotMemDomS = b(not_member(DomExpr,Domain),pred,[]),  % prj1(P) /: dom(Rel2)
  conjunct_predicates([NotMemDomS,B],RHS),
  %print('RHS: '),translate:print_bexpr(RHS),nl,
  disjunct_predicates([MemS,RHS],NewBody),
  %print('Body: '),translate:print_bexpr(NewBody),nl,
  mark_closure_as_symbolic(NewClosure,Res).
% TO DO: add a case where for second set we have: dont_expand_this_closure
override_custom_explicit_set_aux(R,S,Res) :-
  is_custom_explicit_set(R,override_custom_explicit_set),
  nonvar(S), is_custom_explicit_set(S,override_custom_explicit_set),
  %% hit_profiler:add_profile_hit(override(R,S),3), %%
  override_custom_explicit_set2(R,S,Res).
override_custom_explicit_set2(R,S,Res) :- is_one_element_custom_set(S,(X,Y)),
   %print(override_pair(X,Y)),nl,
   override_pair_explicit_set(R,X,Y,NewR),!,
   Res=NewR.
% TO DO: if R is very large and S relatively small : iterate by calling override_pair_explicit_set
override_custom_explicit_set2(R,S,Res) :-
  expand_custom_set(R,ER,override_custom_explicit_set_aux1),
  expand_custom_set(S,ES,override_custom_explicit_set_aux2),
  override_list(ER,ES,LRes,Done),
  finish_restriction(Done,LRes,Res).

quick_size_check_larger_than(Set,Size,Limit) :-
   quick_custom_explicit_set_approximate_size(Set,Size),
   (Size = inf -> true ; Size>Limit).
get_prj1(b(couple(DomExpr,_),_,_),Prj1) :- !, Prj1 = DomExpr.
get_prj1(BE,b(first_of_pair(BE),DT,[])) :- % some closures have a single identifier; we need to apply prj1
   BE = b(_E,couple(DT,_RT),_I).

generate_typed_id_pairs([ID|IT],[Type|TT],Res) :- create_typed_id(ID,Type,TypedID),
   conv2(IT,TT,TypedID,Res).
conv2([],[],X,X).
conv2([ID|IT],[Type|TT],Acc,Res) :- create_typed_id(ID,Type,TypedID),
    get_texpr_type(Acc,AccType),
    Couple = b(couple(Acc,TypedID),couple(AccType,Type),[]),
    conv2(IT,TT,Couple,Res).

:- block override_list(-,?,?,?), override_list(?,-,?,?).
override_list([],S,Res,Done) :- !, copy_to_true_list(S,Res,Done).
override_list(R,[],Res,Done) :- !, copy_to_true_list(R,Res,Done).
override_list([(From1,To1)|T1],[(From2,To2)|T2],Res,Done) :-
   (From1 @< From2
     -> Res = [(From1,To1)-true|TR], override_list(T1,[(From2,To2)|T2],TR,Done)
    ; From2 @< From1
     -> Res = [(From2,To2)-true|TR], override_list([(From1,To1)|T1],T2,TR,Done)
    ; override_list(T1,[(From2,To2)|T2],Res,Done)).

:- block copy_to_true_list(-,?,?).
% add -true to get lists that can be converted to avl
copy_to_true_list([],[],true).
copy_to_true_list([H|T],[H-true|CT],Done) :- copy_to_true_list(T,CT,Done).

avl_min_pair(AVLFun,FFrom,FTo) :-
    (avl_min(AVLFun,(FFrom,FTo)) -> true
       ; add_error_fail(avl_min_pair,'Could not extract minimum pair of AVL set',AVLFun)).
avl_max_pair(AVLFun,FFrom,FTo) :-
    (avl_max(AVLFun,(FFrom,FTo)) -> true
       ; add_error_fail(avl_max_pair,'Could not extract maximum pair of AVL set',AVLFun)).

% check whether we have a partial function
is_avl_partial_function(empty) :- !.
is_avl_partial_function(node((KeyFrom,_KeyTo),_True,_,L,R)) :- !,
   is_avl_partial_function2(L,'$$MIN$$',KeyFrom),
   is_avl_partial_function2(R,KeyFrom,'$$MAX$$').
is_avl_partial_function(X) :- add_error_and_fail(is_avl_partial_function,'Not avl_set or relation: ',X).

  % we traverse the tree from top to bottom, keeping track of possible upper- and lower-bounds
  % if any value matches the upper or lower bound, the we do not have a partial function
is_avl_partial_function2(empty,_,_).
is_avl_partial_function2(node((KeyFrom,_KeyTo),_True,_,L,R),ParentFrom,ParentTo) :-
   KeyFrom \= ParentFrom, KeyFrom \= ParentTo,
   is_avl_partial_function2(L,ParentFrom,KeyFrom),
   is_avl_partial_function2(R,KeyFrom,ParentTo).



% check whether we have a function which is total over a given domain; both as AVL sets
is_avl_total_function_over_domain(empty,empty) :- !.
is_avl_total_function_over_domain(AVLFun,AVLDom) :-
   avl_domain(AVLFun,FunList),
   avl_domain(AVLDom,DomList),
   is_avl_total_fun2(FunList,DomList).

is_avl_total_fun2([],[]).
is_avl_total_fun2([(From,_To)|FT],[From|DomT]) :- is_avl_total_fun2(FT,DomT).


%not_is_avl_partial_function(AVLF) :-  \+ is_avl_partial_function(AVLF).

:- use_module(kernel_equality,[membership_test/3,membership_test_wf/4]).
% check whether an AVL Relation is not over a specific domain & range
is_not_avl_relation_over_domain_range(AVLRel,Domain,Range,WF) :- AVLRel \= empty,
    avl_min_pair(AVLRel,RFrom,RTo),
    kernel_equality:membership_test_wf(Domain,RFrom,MemRes,WF),
    is_not_avl_rel_dom1(MemRes,RFrom,RTo,AVLRel,Domain,Range,WF).

:- block is_not_avl_rel_dom1(-, ?,?,?,?,?,?).
is_not_avl_rel_dom1(pred_false,_,_,_,_,_,_WF).
is_not_avl_rel_dom1(pred_true,RFrom,RTo,AVLRel,Domain,Range,WF) :-
    kernel_equality:membership_test_wf(Range,RTo,MemRes,WF),
    is_not_avl_rel_dom2(MemRes,RFrom,RTo,AVLRel,Domain,Range,WF).

:- block is_not_avl_rel_dom2(-, ?,?,?,?,?,?).
is_not_avl_rel_dom2(pred_false,_,_,_,_,_,_WF).
is_not_avl_rel_dom2(pred_true,RFrom,RTo,AVLRel,Domain,Range,WF) :-
    avl_next((RFrom,RTo),AVLRel,(RFrom2,RTo2)),
    kernel_equality:membership_test_wf(Domain,RFrom2,MemRes,WF),
    is_not_avl_rel_dom1(MemRes,RFrom2,RTo2,AVLRel,Domain,Range,WF).

% check whether an AVL Relation is not over a specific range
is_not_avl_relation_over_range(AVLRel,Range,WF) :- AVLRel \= empty,
    avl_min_pair(AVLRel,RFrom,RTo),
    kernel_equality:membership_test_wf(Range,RTo,MemRes,WF),
    is_not_avl_rel_ran2(MemRes,RFrom,RTo,AVLRel,Range,WF).

:- block is_not_avl_rel_ran2(-, ?,?,?,?,?).
is_not_avl_rel_ran2(pred_false,_,_,_,_,_WF).
is_not_avl_rel_ran2(pred_true,RFrom,RTo,AVLRel,Range,WF) :-
    avl_next((RFrom,RTo),AVLRel,(RFrom2,RTo2)),
    kernel_equality:membership_test_wf(Range,RTo2,MemRes,WF),
    is_not_avl_rel_ran2(MemRes,RFrom2,RTo2,AVLRel,Range,WF).

% check whether we have a relation
is_avl_relation(node((_KeyFrom,_KeyTo),_True,_,_,_)).

% check whether a Relation has all its range elments in a certain Range (not necessarily AVL)
% TO DO: fif Domain is an interval: we could take avl_min and avl_max and rely on lexicographic ordering
is_avl_relation_over_domain(AVL,IntervalClosure,_WF) :-
   is_interval_closure_or_integerset(IntervalClosure,Low,Up),!,
   ((avl_min(AVL,(int(ALow),_)), avl_max(AVL,(int(AUp),_)))
    ->  %print(check_avl_over_domain(ALow,AUp,Low,Up)),nl,
        cs_greater_than_equal(ALow,Low), cs_greater_than_equal(Up,AUp) %,print(ok),nl
    ; (AVL=empty -> true ; add_error_and_fail(is_avl_relation_over_domain,'Not a relation with integer domain: ',AVL))).
is_avl_relation_over_domain(_,Domain,_) :-
    quick_is_definitely_maximal_set(Domain),!.
    %is_definitely_maximal_set(Domain),!.
is_avl_relation_over_domain(AVL,Domain,WF) :- is_avl_relation_over_domain2(AVL,Domain,WF).
is_avl_relation_over_domain2(empty,_,_).
is_avl_relation_over_domain2(node((KeyFrom,_KeyTo),_,_,L,R), Domain,WF) :-
	is_avl_relation_over_domain2(L, Domain,WF),
	is_avl_relation_over_domain2(R, Domain,WF),
	kernel_objects:check_element_of_wf(KeyFrom,Domain,WF).

% : faster to check than is_definitely_maximal_set
quick_is_definitely_maximal_set(X) :- nonvar(X),
    quick_is_definitely_maximal_set_aux(X).
quick_is_definitely_maximal_set_aux(global_set(GS)) :-
    nonvar(GS),is_maximal_global_set(GS).
quick_is_definitely_maximal_set_aux(avl_set(AVL)) :-
    quick_definitely_maximal_set_avl(AVL).

% check whether a Relation has all its range elments in a certain Range (not necessarily AVL)



is_avl_relation_over_range(empty,_,_) :- !.
is_avl_relation_over_range(_,Range,_) :- % print(chk(Range)),nl,trace,
   %quick_is_definitely_maximal_set(Range),
   is_definitely_maximal_set(Range), % print(maximal),nl,
   !.
is_avl_relation_over_range(AVL,Range,WF) :- is_avl_relation_over_range2(AVL,Range,WF).

is_avl_relation_over_range2(empty,_,_).
is_avl_relation_over_range2(node((_KeyFrom,KeyTo),_,_,L,R), Range,WF) :-
	is_avl_relation_over_range(L, Range,WF),
	%print_term_summary(check_el(KeyTo,Range)),
	kernel_objects:check_element_of_wf(KeyTo,Range,WF),
	is_avl_relation_over_range2(R, Range,WF).


is_avl_sequence(empty) :- !.
is_avl_sequence(node((int(KeyFrom),_KeyTo),_True,_,L,R)) :- !,
   is_avl_sequence2(L,0,KeyFrom),
   is_avl_sequence2(R,KeyFrom,'$$MAX$$').
is_avl_sequence(X) :- add_error_and_fail(is_avl_sequence,'Not avl_set or sequence: ',X).

  % we traverse the tree from top to bottom, keeping track of possible upper- and lower-bounds
  % if any value matches the upper or lower bound, the we do not have a partial function
is_avl_sequence2(empty,X,Y) :- %print(empty(X,Y)),nl,
  (Y=='$$MAX$$' -> true ; Y is X+1). % otherwise there is a gap in the sequence
is_avl_sequence2(node((int(KeyFrom),_KeyTo),_,_,L,R),ParentFrom,ParentTo) :-
   %print(node(KeyFrom, ParentFrom,ParentTo)),nl,
   KeyFrom > ParentFrom, KeyFrom \= ParentTo,
   is_avl_sequence2(L,ParentFrom,KeyFrom),
   is_avl_sequence2(R,KeyFrom,ParentTo).

% for performance: it is not worthwhile to make a version that checks that
% we have a sequence over a range using a single traversal


% ---------------------------
prefix_of_custom_explicit_set(avl_set(A),MinIndex,Result,WF) :-
   size_of_avl_sequence(A,Size),
   (MinIndex > Size
     -> add_wd_error('index larger than size of sequence in prefix_sequence (/|\\)! ', '>'(MinIndex,Size),WF)
  %   ;  MinIndex = 0 -> Result = [] % case already treated in bsets_clp
     ;  MinIndex = Size -> Result=avl_set(A)
     ;  prefix_of_custom_explicit_set2(A,MinIndex,OrdList,[]),
         %print(suffix(A,MinIndex,OrdList)),nl,
        ord_list_to_avlset(OrdList,Result,prefix_of_custom_explicit_set)
    ).
prefix_of_custom_explicit_set2(empty,_MaxIndex) --> {true}.
prefix_of_custom_explicit_set2(node((int(KeyFrom),KeyTo),_True,_,L,R),MaxIndex) -->
   ({KeyFrom = MaxIndex}
     -> prefix_of_custom_explicit_set2(L,MaxIndex), [((int(KeyFrom),KeyTo)-true)]
    ; {KeyFrom > MaxIndex} -> prefix_of_custom_explicit_set2(L,MaxIndex)
    ;  prefix_of_custom_explicit_set2(L,MaxIndex), [((int(KeyFrom),KeyTo)-true)],
       prefix_of_custom_explicit_set2(R,MaxIndex)
    ).

% size is only well-defined for sequences:
size_of_custom_explicit_set(avl_set(AVL),int(Size),_WF) :- size_of_avl_sequence(AVL,Size).
size_of_custom_explicit_set(closure(P,T,B),Res,WF) :-
   is_lambda_value_domain_closure(P,T,B, DomainValue,_Expr),
   kernel_objects:finite_cardinality_as_int(DomainValue,Res,WF).
size_of_avl_sequence(AVL,Size) :- avl_max_pair(AVL,int(Sz),_), Size=Sz.

suffix_of_custom_explicit_set(avl_set(A),MinIndex,Result,WF) :-
   size_of_avl_sequence(A,Size),
   (MinIndex > Size
     -> add_wd_error('index larger than size of sequence in suffix_sequence (\\|/)! ', '>'(MinIndex,Size),WF)
  %   ;  MinIndex = 0 -> Result = avl_set(A) % case already treated in bsets_clp
     ;  MinIndex = Size -> Result=[]
     ;  suffix_of_custom_explicit_set2(A,MinIndex,OrdList,[]),
         %print(suffix(A,MinIndex,OrdList)),nl,
        ord_list_to_avlset(OrdList,Result,suffix_of_custom_explicit_set)
    ).
suffix_of_custom_explicit_set2(empty,_MinIndex) --> {true}.
suffix_of_custom_explicit_set2(node((int(KeyFrom),KeyTo),_True,_,L,R),MinIndex) -->
   ({KeyFrom =< MinIndex} -> suffix_of_custom_explicit_set2(R,MinIndex)
    ; {ShiftedKeyFrom is KeyFrom-MinIndex},
      ({KeyFrom =:= MinIndex+1}
       ->  {true} ; suffix_of_custom_explicit_set2(L,MinIndex)),
      [((int(ShiftedKeyFrom),KeyTo)-true)],
      suffix_of_custom_explicit_set2(R,MinIndex)
    ).

shift_avl_sequence_to_ord_list(AVL,Offset,ShiftedOrdList) :-
  avl_to_list(AVL,List),shift_seq(List,Offset,ShiftedOrdList).
% it does not seem to be worth to use avl_to_list_dcg_offset or a variation thereof
% it is not really slower to do two traversals (avl_to_list and shift_seq)

shift_seq([],_,[]).
shift_seq([(int(I),Val)-true|T],Offset,[(int(NI),Val)-true|ST]) :- NI is I+Offset,
  shift_seq(T,Offset,ST).

:- use_module(debug).
concat_custom_explicit_set(avl_set(S1),Seq2,Res) :- nonvar(Seq2), Seq2=avl_set(S2),% print_term_summary(concat(avl_set(S1),avl_set(S2),Res)),
   size_of_avl_sequence(S1,Size1),
   shift_avl_sequence_to_ord_list(S2,Size1,OL2),
   %avl_to_list(S1,OL1),
   avl_to_list_dcg(S1,NewOrdList,OL2), % use OL2 rather than [] as tail
   %append(OL1,OL2,NewOrdList), % we could avoid traversing OL1 again by doing a custom avl_to_list/3 which specifies tail
   ord_list_to_avlset(NewOrdList,Res,concat). % , print_term_summary(res_concat(Res)).

% a DCG version of avl_to_list; allows to call it with something else than [] as tail
avl_to_list_dcg(empty) --> [].
avl_to_list_dcg(node(Key,Val,_,L,R)) -->
   avl_to_list_dcg(L), [(Key-Val)],
   avl_to_list_dcg(R).

/* conc: concatenation of sequence of sequences */
conc_custom_explicit_set(avl_set(AVL),Res) :-
   avl_min_pair(AVL,int(ONE),First),
   conc2_cs(First,ONE,AVL,0,NewOrdList),
   ord_list_to_avlset(NewOrdList,Res,conc).

conc2_cs(Seq,NrSeq,AVL,Offset,OrdList) :-
   %print_term_summary(conc2_cs(Seq,NrSeq,AVL,Offset,OrdList)),
   add_seq(Seq,Offset,OrdList,NewOffset,TailOrd),
   %print(res(OrdList,NewOffset,TailOrd)),nl,
   (avl_next((int(NrSeq),Seq),AVL,(int(N2),Seq2))
    -> conc2_cs(Seq2,N2,AVL,NewOffset,TailOrd)
     ; TailOrd=[]).

add_seq([],Offset,OrdRes,NewOffset,TailOrdRes) :- NewOffset=Offset, TailOrdRes=OrdRes.
add_seq(avl_set(ASeq),Offset,OrdRes,NewOffset,TailOrd) :-
   avl_to_list_dcg_offset(ASeq,Offset,NrEls,OrdRes,TailOrd), NewOffset is Offset+NrEls.

% a version of avl_to_list for sequences which autmatically adds an offset
avl_to_list_dcg_offset(empty,_,0) --> [].
avl_to_list_dcg_offset(node((int(Idx),El),Val,_,L,R),Offset,NrEls) -->
   {NIdx is Idx+Offset},
   avl_to_list_dcg_offset(L,Offset,N1),
   [((int(NIdx),El)-Val)],
   avl_to_list_dcg_offset(R,Offset,N2), {NrEls is N1+N2+1}.

prepend_custom_explicit_set(avl_set(S1),ObjectToPrepend,Res) :-
   %hit_profiler:add_profile_hit(prepend_custom_explicit_set(avl_set(S1),ObjectToPrepend,Res)),
   element_can_be_added_or_removed_to_avl(ObjectToPrepend),
   shift_avl_sequence_to_ord_list(S1,1,OL1),
   ord_list_to_avlset([(int(1),ObjectToPrepend)-true|OL1],Res).

append_custom_explicit_set(avl_set(S1),ObjectToAppend,Res) :-
   element_can_be_added_or_removed_to_avl(ObjectToAppend), % implies that ObjectToAppend is ground
   size_of_avl_sequence(S1,Size1), NewSize is Size1+1,
   add_ground_element_to_explicit_set(avl_set(S1),(int(NewSize),ObjectToAppend),Res).

tail_sequence_custom_explicit_set(avl_set(S1),Res,Span,WF) :-
   shift_avl_sequence_to_ord_list(S1,-1,NewOrdList),
   (NewOrdList = [(int(0),_First)-true|TailOL] -> ord_list_to_avlset(TailOL,Res)
    ; add_wd_error_span('tail argument is not a sequence!', avl_set(S1),Span,WF)
     % add_error_fail(tail_sequence,'tail applied to ', NewOrdList))
   ).
last_sequence_explicit_set(avl_set(AVL),Last) :-
  avl_max_pair(AVL,int(_Sz),Last).
  % TO DO: we could compute height of the path to max H, then check that Sz is in 2**(H-1)+1 .. 2**(H+1)-1 ?
%first_sequence_explicit_set(avl_set(AVL),First) :-  % not used anymore; apply_to used instead
%  avl_min_pair(AVL,int(_One),First).

front_sequence_custom_explicit_set(avl_set(AVL),Res) :-
   avl_max_pair(AVL,int(Size),Last),
   direct_remove_element_from_avl(AVL, (int(Size),Last), Res). % we know Last is already in AVL-converted format
%is_avl_sequence_old(AVLSeq) :-
%   avl_min_pair(AVLSeq,FFrom,FTo), is_avl_seq(AVLSeq,FFrom,FTo,1).
%is_avl_seq(AVLSeq,int(NextNr),FTo,NextNr) :-
%   (avl_next((int(NextNr),FTo),AVLSeq,(FFrom2,FTo2))
%      -> N1 is NextNr+1, is_avl_seq(AVLSeq,FFrom2,FTo2,N1)
%      ; true).

reverse_custom_explicit_set(avl_set(AVL),Res) :-
   avl_to_list_dcg_offset(AVL,0,Size,List,[]),
   S1 is Size+1,
   reverse_list(List,S1,[],RevList),
   ord_list_to_avl(RevList,RevAVL),
   Res=avl_set(RevAVL).

reverse_list([],_,Acc,Acc).
reverse_list([(int(Idx),El)-V|T],S1,Acc,Res) :-
   NewIdx is S1 - Idx,
   reverse_list(T,S1,[(int(NewIdx),El)-V|Acc],Res).

% check if a relation is injective ; compute range at the same time; note AVL can be empty
is_injective_avl_relation(AVL,RangeRes) :-
  avl_domain(AVL,ElList),
  empty_avl(EmptyAcc),
  is_avl_inj_list(ElList,EmptyAcc,Range),
  construct_avl_set(Range,RangeRes).

is_avl_inj_list([],Range,Range).
is_avl_inj_list([(_From,To)|T],InRange,OutRange) :-
   (avl_fetch(To,InRange) -> fail /* this is not an injection; a range element is repeated */
     ; avl_store(To,InRange,true,InRange1),
       is_avl_inj_list(T,InRange1,OutRange)
    ).

% Example predicates that work with code below:
% card(id((1..1000)*(1..1000))~)=1000*1000
% card(((1..1000)*(1..1000))~)=1000*1000
invert_explicit_set(global_set(GS),_R) :- !,
    add_error_and_fail(invert_explicit_set,'Cannot compute inverse of global set: ',GS).
invert_explicit_set(freetype(GS),_R) :- !,
    add_error_and_fail(invert_explicit_set,'Cannot compute inverse of freetype: ',GS).
invert_explicit_set(closure([P1,P2],[T1,T2],Clo),R) :- !,
    R = closure([P2,P1],[T2,T1],Clo).
invert_explicit_set(closure([P1],[T1],Clo),R) :- is_member_closure([P1],[T1],Clo,_Type,MEM),
   %print(try_invert_clo(MEM,T1)),nl,
   invert_member_predicate(MEM,T1,InvMEM,InvT1),!,
   construct_member_closure(P1,InvT1,InvMEM,R). %, print(result(R)),nl.
%invert_explicit_set(closure_x([P1,P2],[T1,T2],Clo,Exp),R) :- !, inv(Exp,IExp,_),
%    R = closure_x([P2,P1],[T2,T1],Clo,IExp).
invert_explicit_set(C,AVL) :- expand_custom_set(C,EC,invert_explicit_set), %% convert to AVL ?
    inv_and_norm(EC,AVL).

invert_member_predicate(cartesian_product(A,B),couple(TA,TB),
                 cartesian_product(B,A),couple(TB,TA)).
invert_member_predicate(identity(A),TA,identity(A),TA).


:- block inv_and_norm(-,?).
inv_and_norm(EC,AVL) :- inv(EC,R,Done), norm(Done,R,AVL).

:- block norm(-,?,?).
norm(_,R,AVL) :- normalised_list_to_avl(R,AVL).

:- block inv(-,?,?).
inv([],[],done).
inv([(A,B)|T],[(B,A)-true|DT],Done) :- inv(T,DT,Done).

/* TO DO: complete
in_domain_of_explicit_set(X,avl_set(A),WF) :-
   ground(X),!, in_domain2(X,A).
in_domain_of_explicit_set(X,avl_set(A),WF) :-
   avl_size(A,Size),
   get_wait_flag(Size,in_domain_of_explicit_set(X),WF,WF1),
    when((ground(X); nonvar(WF1)), in_domain2(X,A) ).
in_domain_of_explicit_set(X,closure(P,T,B),WF) :-   to avoid expanding closure *

in_domain2(X,AVL) :- ground(X),!, ..convert_to_avl...
   avl_fetch_pair_0(X,A,'=',_).
 ... -> write avl_domain_member
 */

% checks whether a ground value is in the domain of an AVL relation
check_in_domain_of_avlset(X,AVL) :- convert_to_avl_inside_set(X,AX),!,
  (avl_fetch_pair(AX,AVL,_) -> true ; fail).
check_in_domain_of_avlset(X,AVL) :-
  print('### could not convert arg for check_in_domain_of_avlset'),nl,
  print(X),nl,
  safe_avl_member_pair(X,_,AVL).



% compute size of range   ; currently not used
%avl_range_size_and_propagate_element_info(A,XDomElement,YRangeElement,Size) :-
%   avl_domain(A,EC), % -> expand_custom_set(avl_set(A),EC),
%   range(EC,R), sort(R,SortedList), %normalised_list_to_avl(R,SortedList,Res),
%   length(SortedList,Size).

/*
  causes problem for:
  probsli examples/EventBPrologPackages/SET_Game/SET_GAM_Sym_NoSet20_mch.eventb -mc 1000 -p SYMMETRY_MODE hash -p TIME_OUT 7000 -p CLPFD TRUE -df -goal n=18 -p MAX_OPERATIONS 20 -strict -expcterr goal_found -p CLPFD TRUE

   print(avl_range_size(Size,YRangeElement,SortedList)),nl,
   % now propagate the information that YRangeElement must appear in SortedList
   propagate_list_element_information(SortedList,Size,XDomElement,YRangeElement).

propagate_list_element_information([H-_|T],_,_,Y) :- T==[],!, equal_object(Y,H).
propagate_list_element_information([int(H)-_|T],_,_,Y) :- preferences:preference(use_clpfd_solver,true),!,
    project_avl_domain_ordlist_on_fd(T,FDList), Y = int(YY),
    clpfd_interface:clpfd_inlist(YY,[H|FDList]).
propagate_list_element_information([fd(H,Type)-_|T],Size,_,Y) :- preferences:preference(use_clpfd_solver,true),!,
   b_global_sets:b_fd_card(Type,Card),
   (Size >= Card -> true  % range is the full type
     ; project_avl_domain_ordlist_on_fd(T,FDList), Y = fd(YY,Type),
      clpfd_interface:clpfd_inlist(YY,[H|FDList])).
propagate_list_element_information(_List,_,_X,_Y). % :- when(ground(Y),(ground(X) -> true ; member(YY-_,List),equal_object(Y,YY))). % enable this again when we use WF2 below rather than GroundY

project_avl_domain_ordlist_on_fd([],[]).
project_avl_domain_ordlist_on_fd([H-_|T],[PH|PT]) :-
    project_avl_domain(H,PH), project_avl_domain_ordlist_on_fd(T,PT).

*/

% not yet finished:
%apply_to_explicit_set(closure(Parameters,PT,Cond),X,Y,WF) :-
%    closure_member(X,Parameters,PT,Cond,WF).

apply_to_avl_set(A,X,Y,Span,WF) :- %print(apply(A,X,Y)),nl, %%
   ground_value_check(X,GroundX),
   apply_to_avl_set_aux(A,X,Y,GroundX,Span,WF).

apply_to_avl_set_aux(A,X,Y,GroundX,Span,WF) :- nonvar(GroundX),!,
    apply_check_tuple(X,Y,A,Span,WF).  % we could call apply_check_tuple_ground to avoid one ground test
% We know  that A is a function: we can deterministically apply if X is ground;
%    if Y is ground this is only the cases for injective functions
apply_to_avl_set_aux(A,X,Y,GroundX,Span,WF) :-
   ground_value_check(Y,GroundY),
   avl_approximate_size(A,3,ApproxSizeA), % exact size for height <= 3; approximate size above
   (ApproxSizeA < 4 -> SPrio=ApproxSizeA ; SPrio is ApproxSizeA * 10), % magic number; ideally we want X or Y to be known beforehand; if none are known we may miss WD errors and may enumerate useless intermediate variables
   get_bounded_wait_flag(SPrio,apply_to_explicit(X,Y),WF,WF1), % this only makes sense if X is a domain variable to be enumerated
        %propagate_avl_element_information((X,Y),A,ApproxSizeA,WF), % could be done; but would prevent WD problems from being detected
       % this waitflag is used when neither X nor Y are ground;
       % quite often not much is gained by enumerating possible values; unless X or Y are constrained or trigger other computations
         % WSz is 10*ApproxSizeA, % magic value
   %(ApproxSizeA > 100 -> InversePrioSize = 4
   %   ; avl_range_size_and_propagate_element_info(A,X,Y,RSize), InversePrioSize is ApproxSizeA // RSize), % we could probably compute the exact worst case with the same complexity
   % delay_get_wait_flag(GroundY,GroundX,WF1,InversePrioSize,apply_to_explicit_inverse(X,Y),WF,WF2),
   %(ApproxSizeA<4000 -> propagate_apply(X,Y,A,ApproxSizeA,WF,GroundX,GroundY) ; true),
   apply_check_tuple_delay(X,Y,A,ApproxSizeA,Span,WF,GroundX,WF1,GroundY),
   (preference(use_clpfd_solver,false) -> true
    % should we also check: preference(find_abort_values,true)?
     ; get_wait_flag0(WF,WF0),
       propagate_apply(X,Y,A,ApproxSizeA,WF,WF0,GroundX,WF1,GroundY)).

:- block propagate_apply(?,?,?,?,?,-,?,?,?).
propagate_apply(X,Y,AVL,ApproxSizeA,WF,_,GroundX,WF1,GroundY) :-
   var(GroundX), var(WF1), var(GroundY),
   (preference(disprover_mode,true) -> XX=X  % this will also instantiate X and prevent finding WD errors
     ; (ApproxSizeA<128 -> true
         ; preference(solver_strength,SS), ApproxSizeA < 128+SS*100), % up until 4000 it may make sense to constrain Y
       preference(data_validation_mode,false), % note: this can slow down ProB, e.g., test 1105; hence allow disabling it
       preference(find_abort_values,false), % TO DO: v = %x.(x:1..20|x+x) & {y,z|y<4 & z=v(y) & (y:{-1,2})} =res: no WD ERROR found
       propagate_value(X,XX) % only instantiate X, propagation only makes sense for propagate_avl_element_information_small, as otherwise only X will be bounded
   ),
   !,
   %print_term_summary(propagate_apply2(X,XX,Y,ApproxSizeA)),nl,
   propagate_avl_element_information((XX,Y),AVL,ApproxSizeA,WF).
propagate_apply(_,_,_,_,_,_,_,_,_).

:- use_module(library(clpfd),[fd_set/2, in_set/2]).
% only propagate in one direction to allow to find WD errors but also prevent pending co-routines/constraints

:- block propagate_value(-,?).
propagate_value(int(X),R) :- !,  fd_set(X,Dom),in_set(RX,Dom), R=int(RX),propagate_atomic_value(X,RX).
propagate_value(fd(X,T),R) :- !, fd_set(X,Dom),in_set(RX,Dom), R=fd(RX,T),propagate_atomic_value(X,RX).
propagate_value((X1,X2),R) :- !, R=(RX1,RX2), propagate_value(X1,RX1), propagate_value(X2,RX2).
propagate_value(pred_true,R) :- !, if(R=pred_true,true,debug_println(9,function_arg_outside_domain(pred_true))).
propagate_value(pred_false,R) :- !, if(R=pred_false,true,debug_println(9,function_arg_outside_domain(pred_false))).
propagate_value(string(X),R) :- !,  R=string(RX),propagate_atomic_value(X,RX).
propagate_value(X,RX) :- equal_object(X,RX). % TO DO: get rid of this: this propagates and prevents finding WD errors
:- block propagate_atomic_value(-,?).
propagate_atomic_value(X,Y) :- if(X=Y,true,debug_println(9,function_arg_outside_domain(X))).

/*
:- block propagate_apply(-,?,?,?,?,-,-).
% call propagate as soon as we know something about the function argument and we do not propgagate completely using GroundX/Y anyway
propagate_apply(X,Y,AVL,Size,WF,GroundX,GroundY) :- print(prop_apply(Size,GroundX,GroundY,X,Y)),nl,
  (nonvar(GroundX) -> true ; nonvar(GroundY) -> true
   ; propagate_avl_element_information((X,Y),AVL,Size,WF)).

% get the waitflag when first WF set and other two not
:- block delay_get_wait_flag(-,-,-,?,?,?,?).
delay_get_wait_flag(_,WF1,WF2, _,_,_,_) :- (nonvar(WF1);nonvar(WF2)),!. % DO NOTHING
delay_get_wait_flag(_,_,_,Prio,Info,WF,WF2) :- get_wait_flag(Prio,Info,WF,WF2).
*/

:- block apply_check_tuple_delay(?,?,?, ?,?,?, -,-,-).
apply_check_tuple_delay(X,Y,AVL,_ApproxSizeA,Span,WF,GroundX,WF1,_) :-
     (nonvar(GroundX);nonvar(WF1)),!,
     %(nonvar(WF1) -> print_term_summary(apply_check_tuple_delay(X,Y,AVL,Span,WF,GroundX,WF1,_)) ; true),
     apply_check_tuple(X,Y,AVL,Span,WF).
apply_check_tuple_delay(X,Y,AVL,ApproxSizeA,_Span,WF,_,_,_GroundY) :- % Y is ground; do an inverse function lookup
      inverse_apply_ok(Y,X,AVL,ApproxSizeA),!,
      inverse_get_possible_values(X,Y,AVL,Res),
      Res=avl_set(InvAVL), % if empty set : we fail
      element_of_avl_set_wf(InvAVL,X,WF).
apply_check_tuple_delay(X,Y,AVL,ApproxSizeA,Span,WF,GroundX,WF1,_GroundY) :-
      apply_check_tuple_delay(X,Y,AVL,ApproxSizeA,Span,WF,GroundX,WF1,_). % now wait on WF1 or GroundX


inverse_get_possible_values(X,Y,AVL,Res) :-
      get_template(X,XX,_), copy_term(XX,XX_Copy), % avoid that findall instantiates X
      findall(XX_Copy, safe_avl_member_default((XX_Copy,Y),AVL), PossibleValues),
      PossibleValues \= [], % fail straightaway
      sort(PossibleValues,SPV),
      % length(SPV,Len),print(inverse_image(Y,Len)),nl, print_term_summary(apply_check_tuple_delay(X,Y,AVL)),nl,
      convert_to_avl(SPV,Res).

% is it ok to compute inverse ? only makes sense if AVL tree not too big and quite functional
inverse_apply_ok(pred_true,_,_AVL,ApproxSizeA) :- !, % only two values possible, probably half of AVL will be returned
    ApproxSizeA < 1023. % corresponds to avl_height < 10
inverse_apply_ok(pred_false,_,_AVL,ApproxSizeA) :- !,ApproxSizeA < 1023.
% TO DO: other small types, such as fd(_,_)
inverse_apply_ok(_,_,_AVL,ApproxSizeA) :- ApproxSizeA < 65535. % corresponds Height < 16
%inverse_apply_ok(_,_,_,_).


/*
apply_check_tuple_ground(X,Y,A,Span,WF) :-
     convert_to_avl_inside_set(X,AX),!, % we can do optimized lookup + checking in one go
     avl_apply(AX,A,XY,Span,WF), kernel_objects:equal_object(XY,Y).
apply_check_tuple_ground(X,Y,A,_Span,_WF) :- preferences:preference(find_abort_values,false), !, safe_avl_member_default((X,Y),A).
apply_check_tuple_ground(X,Y,A,Span,WF) :- !,
    if(safe_avl_member_default((X,XY),A),  % does not detect abort errors if X unbound
        kernel_objects:equal_object(XY,Y),
        add_wd_error_span('function applied outside of domain (#4): ','@fun'(X,avl_set(A)),Span,WF)).
*/

% apply_check_tuple is allowed to enumerate: either X is ground or Y is ground
%apply_check_tuple(X,Y,A,_Span,_WF) :- preferences:preference(find_abort_values,false),!,safe_avl_member((X,Y),A).
apply_check_tuple(X,Y,A,Span,WF) :-
     ground_value(X),
     convert_to_avl_inside_set(X,AX),!, % we can do optimized lookup + checking in one go
     avl_apply(AX,A,XY,Span,WF),
     kernel_objects:equal_object_wf(XY,Y,apply_check_tuple,WF).
:- if(environ(no_wd_checking, true)).
apply_check_tuple(X,Y,A,_Span,_WF) :- safe_avl_member_default((X,Y),A).
:- else.
apply_check_tuple(X,Y,A,_Span,_WF) :- preferences:preference(find_abort_values,false), !, safe_avl_member_default((X,Y),A).
apply_check_tuple(X,Y,A,Span,WF) :- !,
    if(safe_avl_member_default((X,XY),A),  % does not detect abort errors if X unbound
        kernel_objects:equal_object_wf(XY,Y,apply_check_tuple_avl,WF),
        add_wd_error_span('function applied outside of domain (#4): ','@fun'(X,avl_set(A)),Span,WF)).
%apply_check_tuple(X,Y,A,Span,WF) :- % var(Y),!, % we can do the domain checking without penalty, as Y does not help us anyway
%    if(safe_avl_member_default((X,XY),A), kernel_objects:equal_object(XY,Y),
%       add_wd_error_span('function applied outside of domain (#4): ','@fun'(X,avl_set(A)),Span,WF)).
:- endif.


% ------------------------------------------


:- use_module(b_global_sets,[b_type2_set/2]).
:- use_module(bsyntaxtree,[rename_bt/3]).
union_of_explicit_set(global_set(GS),_,R) :- is_maximal_global_set(GS), !,
    R= global_set(GS).  /* global_set is already maximal */
union_of_explicit_set(freetype(GS),_,R) :- !, R= freetype(GS).  /* freetype is already maximal */
union_of_explicit_set(closure(P,T,B),_,R) :- is_definitely_maximal_closure(P,T,B), !,
    R= closure(P,T,B).  /* global_set is already maximal */
union_of_explicit_set(_,S2,R) :- is_definitely_maximal_set(S2),!,  % will also look at AVL set
    R=S2.
union_of_explicit_set(S1,S2,R) :- nonvar(S2), S2 = [], !, R=S1.
union_of_explicit_set(S1,S2,_) :- (var(S1);var(S2)),!,fail. % then we cannot compute it here
union_of_explicit_set(S2,S1,R) :-  % print_term_summary(union(S1,S2,R)),nl,
    is_not_member_value_closure(S1,TYPE,MS1), nonvar(MS1), is_efficient_custom_set(MS1),
    % also works if S2 is complement closure
    difference_of_explicit_set(MS1,S2,Diff),!, % print(diff(Diff)),nl,
    construct_complement_closure_if_necessary(Diff,TYPE,R).
union_of_explicit_set(avl_set(A1),S2,R) :-  !, union_of_avl_set(S2,A1,R).
union_of_explicit_set(S1,S2,R) :-
    is_not_member_value_closure(S1,TYPE,MS1), nonvar(MS1), is_efficient_custom_set(MS1),
    difference_of_explicit_set(MS1,S2,Diff),!,
    construct_complement_closure_if_necessary(Diff,TYPE,R).
union_of_explicit_set(S1,avl_set(A2),R) :-  !, union_of_avl_set(S1,A2,R).
union_of_explicit_set(I1,I2,R) :- is_interval_closure_or_integerset(I1,From1,To1), ground(From1), ground(To1),
    is_interval_closure_or_integerset(I2,From2,To2), ground(From2), ground(To2),
    %print(union(From1,To1,From2,To2)),nl,
    !,
    (union_of_interval(From1,To1,From2,To2,FromRes,ToRes)
       -> construct_interval_closure(FromRes,ToRes,R)
    %print(interval_union(From1,To1,From2,To2,FromRes,ToRes)),nl,
     ; small_enough_for_expansion(From1,To1),small_enough_for_expansion(From2,To2) ->
        % do not attempt union_of_closure below
       expand_interval_closure_to_avl(From1,To1,R1), R1=avl_set(A1), % empty interval already dealt with above !?
       expand_interval_closure_to_avl(From2,To2,R2), R2=avl_set(A2), % Note: unification after call as expand_interval calls equal_object (which gets confused by partially instantiated avl_set(_))
       union_of_avl(A1,A2,ARes),R=avl_set(ARes)  /* AVL not normalised */
     ; transform_global_sets_into_closure(I1,closure(Par,T,Body)),
       union_of_closure(I2,Par,T,Body,R)
    ).
union_of_explicit_set(closure(P,T,B),C2,Res) :-
   union_of_closure(C2,P,T,B,Res).

small_enough_for_expansion(From1,To1) :- number(To1), number(From1), To1-From1<250.

:- use_module(bsyntaxtree,[extract_info/2,extract_info/3]).
%union_of_closure(X,P,T,B,_Res) :- print(union_with_closure(X,P,T,B)),nl,trace,fail.

union_of_closure(global_set(X),P,T,B,Res) :- !, transform_global_sets_into_closure(global_set(X),C),
   union_of_closure(C,P,T,B,Res).
union_of_closure(closure(P2,T2,B2),P,T,B,Res) :- !,
   % T2 should be equal to T, module seq(_) <-> set(couple(integer,_))
   unify_closure_predicates(P,T,B, P2,T2,B2   , NewP,NewT, NewB1,NewB2),
  debug:debug_println(9,union_of_two_closures(P,P2,NewP,NewT)),
   extract_info(B,B2,NewInfo),
   construct_disjunct(NewB1,NewB2,Disj),
    % print('union: '),translate:print_bexpr(Disj),nl,
   Res = closure(NewP,NewT,b(Disj,pred,NewInfo)).

% rename predicates of two closures so that they work on common closure parameter ids
% and can then be either joined by conjunction or disjunction
unify_closure_predicates(P,T,B, P2,T2,B2   , NewP,NewT, NewB1,NewB2) :-
   length(P,Len1), length(P2,Len2),
   (Len1=Len2
     -> generate_renaming_list(P,P2,RL),
        bsyntaxtree:rename_bt(B2,RL,NewB2),
        %translate:print_bexpr(NewB2),nl,
        NewP=P, NewT=T, NewB1 = B
    ; Len1 < Len2 -> unify_clos_lt(P,T,B, P2,T2,B2   , NewP,NewT, NewB1,NewB2)
    ; otherwise ->   unify_clos_lt(P2,T2,B2, P,T,B   , NewP,NewT, NewB1,NewB2)
    ).

% TO DO: generalize: currently only works for single identifier on left
% but works for id(NATURAL) \/ %x.(x<0|-x) or abs = id(NATURAL) \/ %x.(x<0|-x) & abs(2)=a2 & abs(-2)=am2
unify_clos_lt([ID1],[couple(_,_)],B, P2,T2,B2   , NewP,NewT, NewB1,NewB2) :-
   rename_lambda_result_id(P2,B2,P3,B3),
   create_couple_term(P3,T2,Pair),
   % print(replacing_by_pair(ID1,Pair)),nl,
   bsyntaxtree:replace_id_by_expr(B,ID1,Pair,NewB1),
   NewP=P3, NewT=T2, NewB2=B3.

% _lambda_result_ id is not enumerated, hence we have to avoid inserting such ids into NewB1 as part of the pPair
rename_lambda_result_id(['_lambda_result_',ID2],B2,[FRESHID,ID2],B3) :- !,get_unique_id('_RANGE_',FRESHID),
   bsyntaxtree:rename_bt(B2,[rename('_lambda_result_',FRESHID)],B3).
rename_lambda_result_id([ID1,'_lambda_result_'],B2,[ID1,FRESHID],B3) :- !,get_unique_id('_RANGE_',FRESHID),
   bsyntaxtree:rename_bt(B2,[rename('_lambda_result_',FRESHID)],B3).
rename_lambda_result_id(P2,B2,P2,B2).

create_couple_term([ID1,ID2],[T1,T2],Res) :-
   bsyntaxtree:create_couple(b(identifier(ID1),T1,[]),b(identifier(ID2),T2,[]),Res).

generate_renaming_list([],[],[]).
generate_renaming_list([ID|T],[ID2|T2],RL) :-
  (ID==ID2 -> generate_renaming_list(T,T2,RL)
    ; RL = [rename(ID2,ID)|RL2],
      generate_renaming_list(T,T2,RL2)).


% a more clever way of constructing a disjunct; factor out common prefixes
% (A & B1) or (A1 & B2)  <=>  A1 & (B1 or B2)
% TO DO: we should try and get the leftmost basic conjunct !
/* construct_disjunct(b(conjunct(A1,A2),pred,IA), b(conjunct(B1,B2),pred,_IB), Res) :-

   print('TRY DISJUNCT FACTOR: '), translate:print_bexpr(A1),nl,
   translate:print_bexpr(B1),nl,
   same_texpr_body(A1,B1),!,
   print('DISJUNCT FACTOR: '), translate:print_bexpr(A1),nl,
   Res = conjunct(A1,b(Disj,pred,IA)),
   construct_disjunct(A2,B2,Disj).
*/
construct_disjunct(A,B,disjunct(A,B)).

:- use_module(btypechecker,[couplise_list/2]).
%union_of_avl_set(R,A1,Res) :- print(union_of_avl_set(R,A1,Res)),nl,fail.
% TO DO: quick_check if AVL A1 is maximal ?
union_of_avl_set(avl_set(A2),A1,R) :- !, union_of_avl(A1,A2,ARes), R=avl_set(ARes).  /* AVL not normalised */
union_of_avl_set(I2,A1,R) :- is_interval_closure_or_integerset(I2,From2,To2), !,
   ground(From2), ground(To2), % we can only compute it if bounds known
   (avl_min(A1,int(Min)), low_border(From2,Min,FromRes), avl_max(A1,int(Max)), up_border(To2,Max,ToRes)
      -> /* AVL contained (almost) in Interval */  % print(union_interval_avl(From2,To2,Min,Max)),nl,
         construct_interval_closure(FromRes,ToRes,R)
      ; \+ small_interval(From2,To2) ->
            transform_global_sets_into_closure(I2,closure(Par,T,Body)), % we may have something like NATURAL1,...
            union_of_avl_set_with_closure(Par,T,Body,A1,R)
      ; expand_and_convert_to_avl_set(I2,A2),  % can generate ARel=empty; will fail if not possible to convert
        union_of_avl(A1,A2,ARes), R=avl_set(ARes)
    ).
union_of_avl_set(closure(Par,T,Body),A1,Res) :- is_infinite_or_symbolic_closure(Par,T,Body),!,
   % TO DO: what if we are in SYMBOLIC mode and the type of T is infinite; maybe we should also keep the union symbolic ?? (cf Ticket/Georghe1)
   union_of_avl_set_with_closure(Par,T,Body,A1,Res).
union_of_avl_set(S2,A1,Res) :-
   S2 \= freetype(_),
   ground_value(S2), % could be a closure
   !,
   (try_expand_and_convert_to_avl_set(S2,A2)
     -> union_of_avl(A1,A2,ARes), Res=avl_set(ARes)  /* AVL not normalised */
     ;  S2=closure(Par,T,Body),
        union_of_avl_set_with_closure(Par,T,Body,A1,Res)).

try_expand_and_convert_to_avl_set(S2,A2) :-
  catch_enumeration_warning_exceptions(expand_and_convert_to_avl_set(S2,A2),fail).

% try expanding to list, but catch enumeration warnings and fail if they do occur
try_expand_custom_set_to_list(CS,_,_,_) :- nonvar(CS),CS=global_set(GS),is_infinite_global_set(GS),
  !,
  fail.
try_expand_custom_set_to_list(CS,List,Done,Source) :-
  catch_enumeration_warning_exceptions(expand_custom_set_to_list(CS,List,Done,Source),fail).


small_interval(From,To) :- number(From), number(To), To-From < 10000.

union_of_avl_set_with_closure(Par,T,Body,A1,Res) :-
   Body = b(_,BodyT,_),
   %print(union_of_avl_and_infinite_closure(Par,T,BodyT)),nl,
   setup_typed_ids(Par,T,TypedPar), %print(typ(TypedPar)),nl,
   btypechecker:couplise_list(TypedPar,TypedCPar),
   generate_couple_types(TypedCPar,ParExpr,ParType), %print(partype(ParType)),nl,
   debug:debug_println(9,union_of_avl_and_infinite_closure(Par,T,BodyT)),
   %translate:print_bexpr(Body),nl,
   BodyAvl = b(member(ParExpr,b(value(avl_set(A1)),ParType,[])),pred,[]),
   %print('AVL: '),translate:print_bexpr(BodyAvl),nl,
   extract_info(Body,NewInfo),
   Res = closure(Par,T,b(disjunct(BodyAvl,Body),pred,NewInfo)).
%   mark_closure_as_symbolic(closure(Par,T,b(disjunct(BodyAvl,Body),pred,NewInfo)),Res).

low_border(Low,AVLMin,R) :- geq_inf(AVLMin,Low),!,R=Low.
low_border(Low,AVLMin,R) :- number(Low),AVLMin is Low-1,R=AVLMin. % extend lower border by one
up_border(Up,AVLMax,R) :- geq_inf(Up,AVLMax),!,R=Up.
up_border(Up,AVLMax,R) :- number(Up),AVLMax is Up+1,R=AVLMax. % extend upper border by one


setup_typed_ids([],[],[]).
setup_typed_ids([ID|TI],[Type|TT],[b(identifier(ID),Type,[])|BT]) :- setup_typed_ids(TI,TT,BT).

generate_couple_types(couple(A,B),b(couple(TA,TB),Type,[]),Type) :- !, Type = couple(TTA,TTB),
  generate_couple_types(A,TA,TTA),
  generate_couple_types(B,TB,TTB).
generate_couple_types(b(X,T,I),b(X,T,I),T).


% try to see if two intervals can be unioned into a new interval
union_of_interval(F1,T1,F2,T2,FR,TR) :- %print(union(F1,T1,F2,T2,FR,TR)),nl,trace,
    geq_inf(F2,F1), geq_inf(T1,T2),!,FR=F1,TR=T1. % interval [F2,T2] contained in [F1,T1]
union_of_interval(F2,T2,F1,T1,FR,TR) :- geq_inf(F2,F1), geq_inf(T1,T2),!,FR=F1,TR=T1. % see above
union_of_interval(F1,T1,F2,T2,FR,TR) :- number(F2),
  geq_inf(F2,F1), number(T1),T11 is T1+1,geq_inf(T11,F2), geq_inf(T2,F2),!,FR=F1,TR=T2. % intervals can be joined
union_of_interval(F2,T2,F1,T1,FR,TR) :- number(F2),
  geq_inf(F2,F1), number(T1),T11 is T1+1,geq_inf(T11,F2), geq_inf(T2,F2),!,FR=F1,TR=T2. % see above

:- use_module(library(ordsets),[ord_union/3]).
union_of_avl(A1,A2,ARes) :- avl_height(A1,Sz1), avl_height(A2,Sz2), %print(u(Sz1,Sz2)),nl,
   (Sz1<Sz2 -> union_of_avl1(A2,Sz2,A1,Sz1,ARes) ; union_of_avl1(A1,Sz1,A2,Sz2,ARes)).
union_of_avl1(A1,Sz1,A2,Sz2,ARes) :- Sz2>2, Sz1 =< Sz2+3, % difference not too big; Sz2 at least a certain size
     !,
     %print(union(Sz1,Sz2)),nl,
     avl_to_list(A2,List2), % get all members
     avl_to_list(A1,List1),
     ord_union(List1,List2,L12),
     ord_list_to_avl(L12,ARes).
union_of_avl1(A1,_Sz1,A2,_Sz2,ARes) :-  % this version is better when A2 is small compared to A1
     avl_domain(A2,List2), % get all members
     add_to_avl(List2,A1,ARes).

:- use_module(library(lists),[reverse/2]).
% a custom version for union(A) where A is AVL set; avoid converting/expanding accumulators and computing avl_height
% runtime of e.g., UNION(x).(x:1000..1514|0..x) 0.65 sec or UNION(n).(n:10000..10010|UNION(x).(x:n..n+1000|n..x)) 4.8 sec is considerably smaller with this version
union_generalized_explicit_set(avl_set(SetsOfSets),Res,_WF) :-
      expand_custom_set_to_list(avl_set(SetsOfSets),ESetsOfSets,_,union_generalized_wf),
      % length(ESetsOfSets,Len),print(union_gen(Len)),nl,
      (ESetsOfSets=[OneSet]
       -> Res=OneSet % avoid converting to list and back to Avl
        ; reverse(ESetsOfSets,RESetsOfSets), % be sure to insert larger values first, so that ord_union has less work to do below; useful if you have many small singleton sets, for example  union(ran(%x.(x : 1 .. 10000|{x * x}))) 2.37 secs --> 0.15 secs
          % note: dom({r,x|x:1..50000 & r:{x*x}}) is still 3 times faster
          union_of_avls(RESetsOfSets,[],Res)).

% take the union of a list of avl_sets
union_of_avls([],Acc,Res) :- ord_list_to_avl(Acc,ARes), construct_avl_set(ARes,Res).
union_of_avls([H|T],Acc,Res) :-
   union_of_avl_with_acc(H,Acc,NewAcc),
   union_of_avls(T,NewAcc,Res).

union_of_avl_with_acc(avl_set(H),Acc,NewAcc) :- !,
     avl_to_list(H,HList),
     ord_union(Acc,HList,NewAcc).
union_of_avl_with_acc([],Acc,Res) :- !,Res=Acc.
% other custom sets should normally not appear, we obtain the list as elements stored in an avl_set
union_of_avl_with_acc(G,_,_) :- add_internal_error('Uncovered element: ',union_of_avl_with_acc(G,_,_)),fail.



% TO DO: there are no rules for is_not_member_value_closure for intersection below
intersection_of_explicit_set_wf(global_set(GS),S2,R,_WF) :- is_maximal_global_set(GS), !, R=S2.
intersection_of_explicit_set_wf(freetype(_GS),S2,R,_WF) :- !, R=S2.
intersection_of_explicit_set_wf(_,S2,_,_WF) :- var(S2),!,fail. % code below may instantiate S2
intersection_of_explicit_set_wf(S1,S2,R,_WF) :- is_definitely_maximal_set(S2), !, R=S1.
intersection_of_explicit_set_wf(_S1,[],R,_WF) :-!, R=[].
intersection_of_explicit_set_wf(I1,I2,R,_WF) :- intersection_with_interval_closure(I1,I2,R),!.
intersection_of_explicit_set_wf(avl_set(A1),S2,R,_WF) :-
     (S2=avl_set(A2) ;
      ground_value(S2), expand_and_convert_to_avl_set_unless_very_large(S2,A2)),!, % if too large: better to apply normal intersection code
      avl_domain(A2,ES), % -> expand_custom_set(avl_set(A2),ES),
      inter2(ES,A1,IRes),
      ord_list_to_avlset(IRes,R,intersection). % we have generated the elements in the right order already
intersection_of_explicit_set_wf(closure(P1,T1,B1),closure(P2,T2,B2),R,WF) :-
   % this clause seems no longer used a lot? intersection can be dealt with symbolically
      % print(intersect(P1,P2,T1,T2)),nl,
      unify_closure_predicates(P1,T1,B1, P2,T2,B2   , NewP,NewT, NewB1,NewB2),
      debug:debug_println(9,intersection_of_two_closures(P1,P2,NewP,NewT)),
      bsyntaxtree:conjunct_predicates([NewB1,NewB2],BI),
      % create a conjunction: can be much more efficient than seperately expanding;
      % also works well if one of the closures is infinite
      C = closure(NewP,NewT,BI),
      expand_custom_set_wf(C,R,intersection_of_explicit_set_wf,WF). % we could also keep it symbolic; maybe use SYMBOLIC pref
% to do: also use above for closure and AVL set with member(P,value(avl_set(A)))
% we could also apply the same principle to difference_of_explicit_set
% currently we enable intersection to be treated symbolically (not_symbolic_binary(intersection) commented out)
% This means the above clause for intersection_of_explicit_set_wf is probably useless !! TO DO INVESTIGATE
% a special case; just for interval closures
intersection_with_interval_closure(I1,I2,R) :-
    is_interval_closure_or_integerset(I1,From1,To1), nonvar(I2),
    intersection_with_interval_closure_aux(I2,From1,To1,R).

%intersection_with_interval_closure_aux(avl_set(A),...
intersection_with_interval_closure_aux(I2,From1,To1,R) :-
    is_interval_closure_or_integerset(I2,From2,To2),!,
    intersect_intervals_with_inf(From1,To1,From2,To2,FromRes,ToRes),
  %%  print(intersect_intervals(From1,To1,From2,To2,FromRes,ToRes)),nl, %%
    construct_interval_closure(FromRes,ToRes,R).
%    (is_interval_closure_or_integerset(R,F,T) -> print(ok(F,T)),nl ; print(ko),nl).
% TO DO: add Interval /\ avl_set = Res

intersect_intervals_with_inf(From1,To1,From2,To2,FromRes,ToRes) :-
    minimum_with_inf(To1,To2,ToRes),
    maximum_with_inf(From1,From2,FromRes).

inter2([],_, []).
inter2([H|T],A1, Res) :-
   (avl_fetch(H,A1) -> Res = [H-true|Res2] ;  Res = Res2), inter2(T,A1,Res2).

ord_list_to_avlset(OL,R) :- ord_list_to_avlset(OL,R,unknown).
ord_list_to_avlset(OrdList,Res,Origin) :-
 % assumes that we have generated the elements in the right order already
  (OrdList=[] -> Res=[]
    ; check_sorted(OrdList,Origin),
      ord_list_to_avl(OrdList,ARes), Res=avl_set(ARes)).

% a version which accepts a list of values without -true
% values have to be ground and already converted for use in avl_set
sorted_ground_normalised_list_to_avlset(List,Res,PP) :-
   add_true_to_list(List,LT),
   ord_list_to_avlset_direct(LT,Res,PP).

add_true_to_list([],[]).
add_true_to_list([H|T],[H-true|TT]) :- add_true_to_list(T,TT).

% the same, but without checking sorted (only use if you are really sure the list is sorted)
ord_list_to_avlset_direct([],[],_).
ord_list_to_avlset_direct([H|T],Res,_):-
   (T==[] -> H=Key-Val, Res = avl_set(node(Key,Val,0,empty,empty)) % slightly faster than calling ord_list_to_avl
     ; ord_list_to_avl([H|T],ARes), Res = avl_set(ARes)).

check_sorted([],_) :- !.
check_sorted([H-_|T],Origin) :- !, check_sorted2(T,H,Origin).
check_sorted(X,Origin) :- add_error_and_fail(ord_list_to_avlset,'Not a list of -/2 pairs: ',Origin:X).

check_sorted2([],_,_) :- !.
check_sorted2([H-_|T],PH,Origin) :- PH @< H,!, check_sorted2(T,H,Origin).
check_sorted2(X,Prev,Origin) :-
 add_error_and_fail(ord_list_to_avlset,'Not a sorted list of -/2 pairs: ',Origin:(X,Prev)).

% ------------------

:- use_module(kernel_freetypes,[is_maximal_freetype/1]).
is_definitely_maximal_set(S) :- nonvar(S), %print(c(S)),nl,
                                is_definitely_maximal_set2(S).
is_definitely_maximal_set2(freetype(ID)) :- is_maximal_freetype(ID).
is_definitely_maximal_set2(global_set(GS)) :- is_maximal_global_set(GS).
is_definitely_maximal_set2(closure(P,T,B)) :- is_definitely_maximal_closure(P,T,B).
is_definitely_maximal_set2(avl_set(S)) :- quick_definitely_maximal_set_avl(S).
is_definitely_maximal_set2([H|T]) :- nonvar(H), is_definitely_maximal_list(H,T). %, nl,print(maximal(H,T)),nl,nl.
  %H==pred_true, T == [pred_false]. % for some reason BOOL is sometimes presented this way
is_definitely_maximal_set2(empty) :- % detect unwrapped AVL sets
   add_internal_error('Not a set: ',is_definitely_maximal_set2(empty)),fail.
is_definitely_maximal_set2(node(A,B,C,D,E)) :-
   add_internal_error('Not a set: ',is_definitely_maximal_set2(node(A,B,C,D,E))),fail.

is_definitely_maximal_list(pred_true,T) :- nonvar(T), T=[_|_]. %
is_definitely_maximal_list(pred_false,T) :- nonvar(T), T=[_|_].%
is_definitely_maximal_list(fd(_,Type),T) :- nonvar(T),b_global_set_cardinality(Type,Card),
  % check if we have the same number of elements as the type: then the set must me maximal
   length_at_least(T,Card).
% We could try and and also treat pairs

length_at_least(1,_) :- !. % we have already removed 1 element; T can be nil
length_at_least(N,T) :- nonvar(T), T=[_|TT], N1 is N-1, length_at_least(N1,TT).

is_definitely_maximal_closure(_,_,b(truth,_Pred,_)) :- !.
is_definitely_maximal_closure(P,T,B) :- is_cartesian_product_closure_aux(P,T,B,S1,S2),!,
  % print(cart(S1,S2)),nl,trace,
   is_definitely_maximal_set(S1),is_definitely_maximal_set(S2).
is_definitely_maximal_closure(P,T,B) :-
   is_full_powerset_or_relations_or_struct_closure(closure(P,T,B),Sets),% print(pow(S1)),nl,
   l_is_definitely_maximal_set(Sets).

l_is_definitely_maximal_set([]).
l_is_definitely_maximal_set([H|T]) :- is_definitely_maximal_set(H), l_is_definitely_maximal_set(T).

% check if we have an AVL tree covering all elements of the underlying type
quick_definitely_maximal_set_avl(AVL) :-
      AVL=node(El,_True,_,_Left,_Right),
      quick_definitely_maximal_set_avl_aux(El,AVL).
quick_definitely_maximal_set_avl_aux(El,AVL) :-
      try_get_finite_max_card_from_value(El,Card), % this could fail if El contains empty sets !
      (Card < 1000 -> true
       ; preferences:preference(solver_strength,SS), Card < 1000+SS*100
       ), % otherwise too expensive a check avl_size
      quick_avl_approximate_size(AVL,MaxSize),
      MaxSize >= Card, % otherwise no sense in computing avl_size, which is linear in size of AVL
      avl_size(AVL,Size),
      %print(check2(Card,Size,El,MaxSize)),nl,
      %(MaxSize>=Size -> print(ok(Size,all(Card))),nl ; print('**** ERROR: '), print(Size),nl,trace),
      Size=Card.

% check if we have an AVL function with domain covering all elements of the underlying type
quick_definitely_maximal_total_function_avl(AVL) :-
      AVL=node(El,_True,_,_Left,_Right),
      El=(DomEl,_),
      quick_definitely_maximal_set_avl_aux(DomEl,AVL), % the size is exactly the size of the domain
      is_avl_partial_function(AVL).

% ----------------------
difference_of_explicit_set(S1,S2,R) :- difference_of_explicit_set_wf(S1,S2,R,no_wf_available).
% this is called with first argument nonvar (for set_subtraction operator):
difference_of_explicit_set_wf(_S1,S2,R,_) :- % print(diff_expl_set(_S1,S2,R)),nl,
     is_definitely_maximal_set(S2), !, R=[].
difference_of_explicit_set_wf(S1,S2,R,_) :- nonvar(S2), S2=[],!, R=S1.
difference_of_explicit_set_wf(S1,S2,R,_) :-
     %nonvar(S1),
     is_very_large_maximal_global_set(S1,Type), !, % TO DO: also for freetype ? cartesian products,...
     /* we have a complement-set */
     complement_set(S2,Type,R).
difference_of_explicit_set_wf(S1,S2,Result,_) :-
     is_not_member_value_closure(S1,Type,MS1),
     nonvar(MS1), is_custom_explicit_set(MS1,difference_of_explicit_set_wf),!,
     union_complement_set(MS1,S2,Type,Result).
difference_of_explicit_set_wf(_,S2,_,_) :- var(S2), !, fail. % then we cannot do anything below
difference_of_explicit_set_wf(S1,S2,R,WF) :-
    is_not_member_value_closure(S2,_Type,MS2), nonvar(MS2),
    intersection_of_explicit_set_wf(MS2,S1,R,WF),!.
difference_of_explicit_set_wf(I1,I2,R,_) :-
    is_interval_closure_or_integerset(I1,From1,To1),
    is_interval_closure_or_integerset(I2,From2,To2),  %print(try_diff_interval(From1,To1,From2,To2,FromRes,ToRes)),nl,
    difference_interval(From1,To1,From2,To2,FromRes,ToRes),!,
    %% print(construct_diff_interval(From1,To1,From2,To2,FromRes,ToRes)),nl, %%
    % TO DO: also treat case when difference yields two disjoint intervals
    construct_interval_closure(FromRes,ToRes,R).
difference_of_explicit_set_wf(avl_set(A1),S2,R,_) :-
     (S2=avl_set(A2) ;
      ground_value(S2), expand_and_convert_to_avl_set_unless_very_large(S2,A2)),!,
      avl_height(A2,H2),
      %avl_min(A1,Min1),avl_max(A1,Max1), avl_min(A2,Min2),avl_max(A2,Max2), avl_height(A1,H1),nl,print(diff(avl(H1,Min1,Max1),avl(H2,Min2,Max2))),nl,
      ((H2<2 -> true ; avl_height(A1,H1),H1 > H2+1) % then it is more efficient to expand A2 and remove the A2 elements from A1;
      % exact threshold when it is beneficial: difference_of_explicit_set2/3
      % for {x|x:1..200000 & x mod 2 = 0} - {y|y:2500..29010 & y mod 2 = 0} -> 150 ms vs 80 ms avl(17,int(2),int(200000)),avl(14,int(2500),int(29010)
      % {x|x:1..200000 & x mod 2 = 0} - {y|y:2500..59010 & y mod 2 = 0} -> 180 ms vs 80 ms avl(17,int(2),int(200000)),avl(15,int(2500),int(59010))
      % {x|x:1..200000 & x mod 2 = 0} - {y|y:500..159010 & y mod 2 = 0} -> 180 ms vs 250 ms avl(17,int(2),int(200000)),avl(17,int(500),int(159010))
        -> expand_custom_set_to_sorted_list(S2,ES,_,difference_of_explicit_set1),
           difference_of_explicit_set3(ES,A1,R)
        ;  expand_custom_set_to_sorted_list(avl_set(A1),ES,Done,difference_of_explicit_set2),
           difference_of_explicit_set2(ES,A2,R,Done)).
difference_of_explicit_set_wf(S1,S2,R,_) :- %print_term_summary(difference_of_explicit_set(S1,S2,R)), statistics,
     (S2=avl_set(A2) ;
      ground_value(S2), expand_and_convert_to_avl_set_unless_very_large(S2,A2)),!,
      difference_with_avl(S1,A2,R).

:- use_module(bsyntaxtree,[create_texpr/4, conjunct_predicates/2, mark_bexpr_as_symbolic/2]).
difference_with_avl(closure([ID],[T],B),A2,R) :-
    % check if the first argument is infinite; then do the difference set symbolically
    % this could supersed the complement set construction and be generalised to other sets apart from avl_sets as A2
    is_infinite_or_symbolic_closure([ID],[T],B), !, % TO DO: also allow multiple identifiers
	create_texpr(identifier(ID),T,[],TID),
	create_texpr(value(avl_set(A2)),set(T),[],A2Value),
    create_texpr(not_member(TID,A2Value),pred,[],NotMemA2),
    conjunct_predicates([B,NotMemA2],NewBody),
    % print(infinite(ID)),nl, translate:print_bexpr(NewBody),nl,
    mark_bexpr_as_symbolic(NewBody,NewBodyS),
    R = closure([ID],[T],NewBodyS).
difference_with_avl(S1,A2,R) :-
      % avl_min(A2,Min2),avl_max(A2,Max2),print(diff2(Min2,Max2)),nl,
      expand_custom_set_to_sorted_list(S1,ES,Done,difference_of_explicit_set3),
      difference_of_explicit_set2(ES,A2,R,Done).

% construct complement of a set
union_complement_set(S1,S2,Type,Result) :-
     ground_value_check(S2,G2),
     when(nonvar(G2),union_complement_set2(S1,S2,Type,Result)).
union_complement_set2(S1,S2,Type,Result) :-
     union_of_explicit_set(S1,S2,S12),
     construct_complement_closure_if_necessary(S12,Type,R),
     kernel_objects:equal_object(R,Result,union_complement_set2).

% construct complement of a set
complement_set(S2,Type,Result) :-
     ground_value_check(S2,G2),
     when(nonvar(G2),complement_set2(S2,Type,Result)).
complement_set2(S2,Type,Result) :-
     is_not_member_value_closure(S2,Type,MS2),!, % complement of complement
     kernel_objects:equal_object(MS2,Result,complement_set2).
complement_set2(S2,Type,Result) :-
     try_expand_and_convert_to_avl_with_check(S2,ExpandedS2,difference_complement_set),
     construct_complement_closure_if_necessary(ExpandedS2,Type,R),
     kernel_objects:equal_object(R,Result,complement_set2).

:- block construct_complement_closure_if_necessary(-,?,?).
construct_complement_closure_if_necessary(Set,TYPE,R) :-
    (Set=[] -> b_type2_set(TYPE,R)
     ; is_not_member_value_closure(Set,TYPE,MS) -> R=MS % complement of complement
     ; construct_complement_closure(Set,TYPE,R)).

% succeeds if difference of two intervals is also a interval
difference_interval(SourceLow,SourceUp,DiffLow,DiffUp,ResLow,ResUp) :-
   (ground(SourceLow),ground(DiffLow),geq_inf(SourceLow,DiffLow)
     -> inc(DiffUp,D1),maximum_with_inf(D1,SourceLow,ResLow), ResUp=SourceUp
    ; ground(DiffUp),ground(SourceUp),geq_inf(DiffUp,SourceUp)
     -> ResLow=SourceLow, dec(DiffLow,D1),minimum_with_inf(SourceUp,D1,ResUp)).

inc(N,R) :- N==inf,!,R=inf.
inc(N,N1) :- N1 is N+1.
dec(N,R) :- N==inf,!,R=inf.
dec(N,N1) :- N1 is N-1.

:- block difference_of_explicit_set2(?,?,?,-).
difference_of_explicit_set2(ES,A2,R,_) :-  %print_term_summary(diff2(ES,A2,R)),statistics,
      avl_min(A2,Min),
      diff1(ES,Min,A2,IRes), %print_term_summary(ord_list_to_avl(IRes)),
      ord_list_to_avlset(IRes,AVL,difference), % we have generated the elements in the right order already
      equal_object(AVL,R). % due to delays in expansion the result could be instantiated

diff1([],_, _,[]).
diff1([H|T],Min,A1, Res) :-
   (H @< Min -> Res = [H-true|Res2],diff1(T,Min,A1,Res2)
     ; diff2([H|T],A1,Res)).% TO DO: compute avl_max

diff2([],_, []).
diff2([H|T],A1, Res) :-
   (avl_fetch(H,A1)  ->  Res = Res2 ;  Res = [H-true|Res2]), diff2(T,A1,Res2).

% another version to be used when second set small in comparison to first set
difference_of_explicit_set3([],A1,Res) :- construct_avl_set(A1,AVL),
   equal_object(AVL,Res). % due to delay in expansion, Res could now be instantiated
difference_of_explicit_set3([H|T],A1,ARes) :-
   (avl_delete(H,A1,_True,A2) -> true ; A2=A1),
   difference_of_explicit_set3(T,A2,ARes).

% -------------------------

% a version of add_element_to_explicit_set where we have already done the groundness check
add_ground_element_to_explicit_set(avl_set(A),Element,R) :- !,
    convert_to_avl_inside_set(Element,AEl),
    avl_store(AEl,A,true,A2),!,R=avl_set(A2).
add_ground_element_to_explicit_set(Set,Element,R) :- add_element_to_explicit_set(Set,Element,R).

add_element_to_explicit_set(global_set(GS),_,R) :- is_maximal_global_set(GS), !, R=global_set(GS).
add_element_to_explicit_set(freetype(ID),_,R) :-  is_maximal_freetype(ID),!, R=freetype(ID).
add_element_to_explicit_set(avl_set(A),Element,R) :-
    ground_value(Element), %% was element_can_be_added_or_removed_to_avl(Element),
    convert_to_avl_inside_set(Element,AEl),
    avl_store(AEl,A,true,A2),!,R=avl_set(A2).  /* AVL not normalised */
    /* do we need to add support for (special) closures ??
add_element_to_explicit_set(Clos,Element,R) :- nonvar(Element),Element=int(X), nonvar(X),
    is_interval_closure_or_integerset(Clos,Low,Up), ground(Low), ground(Up),
    union_of_interval(X,X,Low,Up,FromRes,ToRes),
    !,
    construct_interval_closure(FromRes,ToRes,R).
% not-member closure not dealt with here
*/

element_can_be_added_or_removed_to_avl(Element) :-
    ground_value(Element),
    does_not_contain_closure(Element).
ground_element_can_be_added_or_removed_to_avl(Element) :- /* use if you know the element to be ground */
    does_not_contain_closure(Element).

% does not contain closure or infinite other sets
does_not_contain_closure([]).
does_not_contain_closure([H|T]) :-
  (simple_value(H) -> true  /* TO DO: check if we could have a closure at the end ?? */
    ; does_not_contain_closure(H),list_does_not_contain_closure(T)).
does_not_contain_closure(fd(_,_)).
does_not_contain_closure(pred_true /* bool_true */).
does_not_contain_closure(pred_false /* bool_false */).
does_not_contain_closure(int(_)).
does_not_contain_closure(string(_)).
does_not_contain_closure((X,Y)) :- does_not_contain_closure(X), does_not_contain_closure(Y).
does_not_contain_closure(avl_set(_)).
does_not_contain_closure(global_set(G)) :- \+ is_infinite_global_set(G).
%does_not_contain_closure(freetype(_)).
does_not_contain_closure(freeval(_,_,Value)) :- does_not_contain_closure(Value).
does_not_contain_closure(rec(Fields)) :- does_not_contain_closure_fields(Fields).

does_not_contain_closure_fields([]).
does_not_contain_closure_fields([field(_,Val)|T]) :- does_not_contain_closure(Val),
  does_not_contain_closure_fields(T).

list_does_not_contain_closure([]).
list_does_not_contain_closure([H|T]) :-
   does_not_contain_closure(H),list_does_not_contain_closure(T).
list_does_not_contain_closure(avl_set(_)).
list_does_not_contain_closure(global_set(G)) :- \+ is_infinite_global_set(G).

simple_value(fd(_,_)).
simple_value(pred_true /* bool_true */).
simple_value(pred_false /* bool_false */).
simple_value(int(_)).
simple_value((A,B)) :- simple_value(A), simple_value(B).
simple_value(string(_)).

remove_element_from_explicit_set(avl_set(A),Element,R) :-
    element_can_be_added_or_removed_to_avl(Element),
    convert_to_avl_inside_set(Element,AEl), !,
    direct_remove_element_from_avl(A,AEl,R).

direct_remove_element_from_avl(A,AEl,R) :-
    avl_delete(AEl,A,_True,A2),
    construct_avl_set(A2,R). /* AVL not normalised */

    /* same as remove but element can be absent */
delete_element_from_explicit_set(avl_set(A),Element,R) :-
    element_can_be_added_or_removed_to_avl(Element),
    convert_to_avl_inside_set(Element,AEl), !,
    (avl_delete(AEl,A,_True,A2)
      -> construct_avl_set(A2,R)
      ;  R = avl_set(A)
    ). /* AVL not normalised */

is_maximal_global_set(GS) :- is_maximal_global_set(GS,_Type).
is_maximal_global_set(GS,Type) :- nonvar(GS),
   (GS = 'INTEGER', Type=integer ;
    \+ kernel_objects:integer_global_set(GS), Type=global(GS)).

% To do: maybe get rid of all complement set code; add in_difference_set as symbolic binary operator
%is_very_large_maximal_global_set(X,_) :- print(very(X)),nl,fail.
is_very_large_maximal_global_set(closure(P,T,B),Type) :- is_definitely_maximal_closure(P,T,B),
   couplise_list(T,Type). %, print(max(P,T,Type)),nl.
is_very_large_maximal_global_set(global_set('INTEGER'),integer).
is_very_large_maximal_global_set(global_set('STRING'),string).
is_very_large_maximal_global_set(freetype(ID),freetype(ID)) :- is_infinite_freetype(ID).



remove_minimum_element_custom_set(avl_set(S),X,RES) :- !,
  avl_del_min(S,X,_True,Res),
  (empty_avl(Res) -> RES=[] ; RES = avl_set(Res)).
%remove_minimum_element_custom_set(closure(P,T,B),X,RES) :-
%     is_interval_closure_or_integerset(Clos,Low,Up),!,
%     X = Low,  TO DO: construct new interval closure
remove_minimum_element_custom_set(CS,X,RES) :-
    expand_custom_set_to_list(CS,ECS,Done,remove_minimum_element_custom_set),
    remove_minimum_element_custom_set2(ECS,X,RES,Done).

:- block remove_minimum_element_custom_set2(?,?,?,-).
% wait until Done: otherwise the Tail of the list could be instantiated by somebody else; interfering with expand_custom_set_to_list
remove_minimum_element_custom_set2([H|T],X,RES,_) :- equal_object((H,T),(X,RES)).


min_of_explicit_set(avl_set(S),Min) :- !, avl_min(S,Min).
min_of_explicit_set(Clos,Min) :-
   is_interval_closure_or_integerset(Clos,Low,Up),
   (Low == minus_inf -> add_error_and_fail(min_of_explicit_set,'min of INTEGER undefined !',Clos)
    ; cs_greater_than_equal(Up,Low),
      Min=int(Low)).

cs_greater_than_equal(X,Y) :-
  ((X==inf;Y==minus_inf) -> true ; kernel_objects:less_than_equal_direct(Y,X)).


max_of_explicit_set(avl_set(S),Max) :- !,avl_max(S,Max).
max_of_explicit_set(Clos,Max) :-
   is_interval_closure_or_integerset(Clos,Low,Up),
   (Up==inf -> add_error_and_fail(max_of_explicit_set,'max of NATURAL, NATURAL1 not defined !',Clos)
    ; cs_greater_than_equal(Up,Low),
      Max=int(Up)).

% ------------- SIGMA/PI --------------

% compute sum or product of an integer set:
sum_or_mul_of_explicit_set(avl_set(S),SUMorMUL,Result) :-
   avl_domain(S,Dom),
   (SUMorMUL=sum -> simple_sum_list(Dom,0,R) ; simple_mul_list(Dom,1,R)),
   Result = int(R).
sum_or_mul_of_explicit_set(CS,SUMorMUL,Result) :- SUMorMUL == sum,
   is_interval_closure(CS,Low,Up),
   sum_interval(Low,Up,Result),
   sum_interval_clpfd_prop(Low,Up,Result).

:- block sum_interval(-,?,?), sum_interval(?,-,?).
sum_interval(Low,Up,_) :- (\+ number(Low) ; \+ number(Up)),!,
  add_error(sum_interval,'Cannot compute sum of interval: ',Low:Up),fail.
sum_interval(Low,Up,Result) :- Low>Up,!, Result=int(0).
sum_interval(Low,Up,Result) :-
   R is ((1+Up-Low)*(Low+Up)) // 2,  % generalisation of Gauss formula k*(k+1)//2
   Result = int(R).

sum_interval_clpfd_prop(Low,Up,Result) :-
   preferences:preference(use_clpfd_solver,true), Result=int(R),
   var(R), % we haven't computed the result yet; the bounds are not known; set up constraint propagation rules
   !,
   post_constraint( (Low #>= 0) #=> (R #> 0)), % we could provide better bounds here for negative numbers
   post_constraint( ((Low #=< Up) #\/ (R #\= 0)) #=> (R #= ((1+Up-Low)*(Low+Up))//2)),
   post_constraint( (Low #> Up) #=> (R #= 0) ) ,print(done(prop)),nl.
   % not working yet: x = SIGMA(i).(i:-3..n|i) & x=0 & n< -1
sum_interval_clpfd_prop(_,_,_).

simple_sum_list([],A,A).
simple_sum_list([int(H)|T],Acc,R) :- NA is Acc+H, simple_sum_list(T,NA,R).
simple_mul_list([],A,A).
simple_mul_list([int(H)|T],Acc,R) :- NA is Acc*H, simple_mul_list(T,NA,R).

%compute the sum of the range elements; was used for SIGMA
%sum_of_range_custom_explicit_set(avl_set(A),R) :- %print(sum_avl(A)),nl, %
%  avl_domain(A,Dom), simple_range_sum_list(Dom,0,Sum), %print(avl_sum(Sum)),nl,
%  R=int(Sum).
%
%simple_range_sum_list([],A,A).
%simple_range_sum_list([(_,int(H))|T],Acc,R) :- NA is Acc+H, simple_range_sum_list(T,NA,R).
%
%compute the product of the range elements; was used for PI
%mul_of_range_custom_explicit_set(avl_set(A),R) :- %print(sum_avl(A)),nl, %
%  avl_domain(A,Dom),
%  simple_range_mul_list(Dom,1,Sum), %print(avl_mul(Sum)),nl,
%  R=int(Sum).
%
%simple_range_mul_list([],A,A).
%simple_range_mul_list([(_,int(H))|T],Acc,R) :- NA is Acc*H, simple_range_mul_list(T,NA,R).

/*
direct_product_symbolic(S,R,Res) :- % NOT YET FINISHED
   nonvar(S), S=closure(PS,[T1,TS2],RS),
   nonvar(R), R=closure(PR,[T1,TR1],RR),
   is_lambda_value_domain_closure(PS,TS,RS, SDomainValue,SExpr),
   is_lambda_value_domain_closure(PR,TR,RR, RDomainValue,RExpr),
   construct_closure(['zzz','_lambda_result_'],[T1,couple(TR1,TR2)],
      member(zzz,SDomainValue) , member(zzz,RDomainValue), eq(lambda,pair(SExpr,RExpr))).
      */

% we assume that try_expand_and_convert_to_avl_unless_very_large already called on arguments
direct_product_explicit_set(S,R,Res) :-   %print(direct_product),print_runtime,statistics,
   nonvar(R), %is_custom_explicit_set(R,direct_product),
   nonvar(S), %is_custom_explicit_set(S,direct_product),
   direct_product_explicit_set_aux(S,R,Res).
%direct_product_explicit_set_aux(S,R,Res) :- (S = closure(_,_,_) ; R = closure(_,_,_)),
%   print_term_summary(direct_product_explicit_set_aux(S,R,Res)),nl,
%   % TO DO: generate closure
%   fail.
direct_product_explicit_set_aux(avl_set(AS),avl_set(AR),Res) :-
   % the expansion guarantees that we have the lists ES and ER then in sorted order
   avl_domain(AS,ES), % -> expand_custom_set(avl_set(AS),ES),
   avl_domain(AR,ER), % -> expand_custom_set(avl_set(AR),ER),
   % print_term_summary(direct_product3(ES,ER)),print_runtime, %%
   direct_product3(ES,ER,DPList),
    % print(ord_list_to_avlset),print_runtime, %%
   ord_list_to_avlset(DPList,DPAVL,direct_product), % is it really ordered ? findall must also return things ordered!
    % statistics,% print(equal_object),print_runtime, %%
   equal_object(DPAVL,Res,direct_product_explicit_set).

direct_product3([],_Rel2,[]).
direct_product3([(From,To1)|T1],Rel2,Res) :-
   get_next_mapped_to_eq(T1,From,TTo,Tail1), ToList1 = [To1|TTo],
   get_next_mapped_to(Rel2,From,ToList2,Tail2),
   calc_direct_product(ToList1,From,ToList2,Res,Rest),
   (Tail2=[] -> Rest=[] ; direct_product3(Tail1,Tail2,Rest)).

% get all elements which map to From, supposing that the list is sorted & we have already had a match
get_next_mapped_to_eq([],_,[],[]).
get_next_mapped_to_eq([(From2,To2)|T],From,Result,Tail) :-
   (From=From2 -> Result = [To2|RR], get_next_mapped_to_eq(T,From,RR,Tail)
    ; Result = [], Tail = [(From2,To2)|T]
   ).

% get all elements which map to From, supposing the list is sorted
get_next_mapped_to([],_,[],[]).
get_next_mapped_to([(From2,To2)|T],From,Result,Tail) :-
   (From=From2 -> Result = [To2|RR], get_next_mapped_to_eq(T,From,RR,Tail)
    ; From2 @> From -> Result = [], Tail = [(From2,To2)|T]
    ; get_next_mapped_to(T,From,Result,Tail)
   ).

calc_direct_product([],_From,_,Tail,Tail).
calc_direct_product([To1|T1],From,To2List,Result,Tail) :-
    findall((From,(To1,To2))-true,member(To2,To2List),Result,ResResult),
    calc_direct_product(T1,From,To2List,ResResult,Tail).

% TO DO: maybe also add a special rule for infinite R such as event_b_identity ?
domain_restriction_explicit_set_wf(S,R,Res,WF) :-  /* S <| R */
   nonvar(R),
   ((nonvar(S),is_one_element_custom_set(S,El),R \= closure(_,_,_))  ->
      domain_restrict_singleton_element(El,R,Res)
      ; restriction_explicit_set_wf(S,R,Res,domain,pred_true,WF)).
domain_subtraction_explicit_set_wf(S,R,Res,WF) :-  /* S <<| R */
   (nonvar(S),is_one_element_custom_set(S,El), nonvar(R), R=avl_set(AVL) ->
      avl_domain_subtraction_singleton(AVL,El,ARes),
      construct_avl_set(ARes,Res) % TO DO: use this also when S is small and R large
    ; restriction_explicit_set_wf(S,R,Res,domain,pred_false,WF)).
range_restriction_explicit_set_wf(R,S,Res,WF) :-  /* R |>  S */
   restriction_explicit_set_wf(S,R,Res,range,pred_true,WF).
range_subtraction_explicit_set_wf(R,S,Res,WF) :-  /* R |>>  S */
   restriction_explicit_set_wf(S,R,Res,range,pred_false,WF).


domain_restrict_singleton_element(El,R,Res) :- /* {El} <| R ; TO DO maybe apply this technique for "small" sets as well */
  nonvar(R), is_custom_explicit_set(R,domain_restrict_singleton_element),
  expand_and_convert_to_avl_set(R,AR), % can generate ARel=empty; will fail if not possible to convert
  findall((El,Z)-true, avl_fetch_pair(El,AR,Z), RTuples),
  ord_list_to_avlset(RTuples,Res,domain_restrict_singleton_element).
 % print_term_summary(domain_restrict_singleton_element(El,R,Res)).

restriction_explicit_set_wf(_,Rel,_,_,_,_) :- var(Rel),!,fail.
restriction_explicit_set_wf(Set,closure([D,R],[TD,TR],Body),Res,RanOrDom,AddWhen,_WF) :-
   %print(symbolic_restrict_closure(D,R,Set)),nl,
   !,
   (RanOrDom=domain
    -> TID = b(identifier(D),TD,[]), TT=TD
     ; TID = b(identifier(R),TR,[]), TT=TR),
   (AddWhen = pred_true
    -> PRED =     member(TID,b(value(Set),TT,[]))
     ; PRED = not_member(TID,b(value(Set),TT,[]))),
   conjunct_predicates([b(PRED,pred,[]),Body],NewBody),
   try_expand_and_convert_to_avl_with_catch(closure([D,R],[TD,TR],NewBody),Res). % ,print(res(Res)),nl.
restriction_explicit_set_wf(Set,Rel,Res,RanOrDom,AddWhen,WF) :-
  % print_term_summary(try_restriction(Set,Rel,Res,RanOrDom,AddWhen)),
   is_custom_explicit_set(Rel,restriction_explicit_set_wf),
  % statistics(runtime,[Time1,_]), %%%
   expand_and_convert_to_avl_set(Rel,ARel), % can generate ARel=empty; will fail if not possible to convert
   avl_domain(ARel,ERel), % -> expand_custom_set(avl_set(ARel),ERel),
   %try_expand_and_convert_to_avl_unless_large(Set,ES),
   (nonvar(Set),Set=avl_set(AVLS)
    -> restrict2_avl(ERel,AVLS,DRes,RanOrDom,AddWhen,Done) %, print_term_summary(restrict2_avl(ERel,AVLS,DRes,RanOrDom,AddWhen))
     ; restrict2(ERel,Set,DRes,RanOrDom,AddWhen,Done,WF)
    ),
   finish_restriction(Done,DRes,Res).
  %  statistics(runtime,[Time2,_]), Time is Time2-Time1, %%%
  %  print_message(restriction(Time,RanOrDom,AddWhen)). %%%
:- block finish_restriction(-,?,?).
finish_restriction(_,DRes,Res) :-
   ord_list_to_avlset(DRes,Restriction,restriction),
   equal_object(Restriction,Res,finish_restriction). % as we may block below: we need to use equal_object

restrict2([],_,[],_,_,done,_WF).
restrict2([(From,To)|T],S,Res,RanOrDom,AddWhen,Done,WF) :-
   (RanOrDom==domain -> El=From ; El=To),
   kernel_equality:membership_test_wf(S,El,MemRes,WF), % TO DO: WF Version !!
   /* this only makes sense once we have the full result as argument:
    (nonvar(MemRes) -> true % it is already decided
     ; AddWhen=pred_true -> kernel_equality:membership_test(Res,(From,To),MemRes)
     ; kernel_equality:membership_test(Res,(From,To),InResult), bool_pred:negate(InResult,MemRes)
    ), */
   restrict3(MemRes,From,To,T,S,Res,RanOrDom,AddWhen,Done,WF).
:- block restrict3(-, ?,?, ?,?,?, ?,?,?,?).
restrict3(MemRes, From,To, T,S,Res, RanOrDom,AddWhen,Done,WF) :-
  (AddWhen=MemRes -> Res = [(From,To)-true|TRes]
     ; Res=TRes),
   restrict2(T,S,TRes,RanOrDom,AddWhen,Done,WF).

% optimised version when second set is also an AVL tree: less blocking,...
restrict2_avl([],_,[],_,_,done).
restrict2_avl([(From,To)|T],AVLS,Res,RanOrDom,AddWhen,Done) :-
   fetch(RanOrDom,From,To,AVLS,MemRes),
   (AddWhen=MemRes -> Res = [(From,To)-true|TRes]
     ; Res=TRes),
   restrict2_avl(T,AVLS,TRes,RanOrDom,AddWhen,Done).

fetch(domain,El,_,AVLS,MemRes) :- (avl_fetch(El,AVLS) -> MemRes=pred_true ; MemRes = pred_false).
fetch(range,_,El,AVLS,MemRes) :- (avl_fetch(El,AVLS) -> MemRes=pred_true ; MemRes = pred_false).

% override R(X) := Y
override_pair_explicit_set(avl_set(S),X,Y,avl_set(NewAVL)) :- element_can_be_added_or_removed_to_avl(X),
   element_can_be_added_or_removed_to_avl(Y),
   convert_to_avl_inside_set(X,AX),
   convert_to_avl_inside_set(Y,AY),
   % print(override_pair_explicit_set(AX,AY)),nl,
   avl_domain_subtraction_singleton(S,AX,AVL2),
   avl_store((AX,AY), AVL2, true, NewAVL).

avl_domain_subtraction_singleton(AVL,AX,NewAVL) :-
   avl_delete_pair(AX,AVL,_True,AVL2),
   !, % recurse, in case we have multiple entries
   % this recursion could be avoided if we know AVL to be a function
   avl_domain_subtraction_singleton(AVL2,AX,NewAVL).
avl_domain_subtraction_singleton(AVL,_,AVL).


/* --------- */
/* EXPANSION */
/* --------- */

:- use_module(b_global_sets,[all_elements_of_type/2, all_elements_of_type_rand/2]).

%expand_custom_set(CSet,E) :- print_term_summary(start_expanding(CSet,E)),nl,fail.
expand_custom_set(X,R) :- expand_custom_set_wf(X,R,expand_custom_set,no_wf_available).
expand_custom_set(X,R,Src) :- expand_custom_set_wf(X,R,Src,no_wf_available).
expand_custom_set_wf(X,R,Source,WF) :- var(X), !,
   add_error_and_fail(expand_custom_set_wf, 'Variable as argument: ',expand_custom_set_wf(X,R,Source,WF)).
expand_custom_set_wf(global_set(GS),ExpandedSet,_,_) :- !,all_elements_of_type(GS,ExpandedSet).
expand_custom_set_wf(freetype(GS),R,_,_) :- !,
    expand_freetype(GS,ValueList), convert_to_avl(ValueList,R).
expand_custom_set_wf(avl_set(AVL),ExpandedSet,_,_) :- !,
    avl_domain(AVL,ExpandedSet).
expand_custom_set_wf(closure(Parameters,PTypes,Cond),Res,Source,WF) :- !,
      expand_closure_to_list(Parameters,PTypes,Cond,Res,_Done,Source,WF).
      %wait_try_expand_custom_set(Res1,Res). % could be in AVL form; no longer the case !
expand_custom_set_wf(Set,_,Source,_) :-
   add_error_and_fail(expand_custom_set(Source),'Cannot expand custom set: ',Set).



%try_expand_only_custom_closure_global(X,Y) :-
%  (var(X) -> X=Y ; expand_only_custom_closure_global(X,Y,check)).

expand_only_custom_closure_global(X,R,C) :- var(X), !,
   add_error_and_fail(expand_only_custom_closure_global, 'Variable as argument: ',expand_only_custom_closure_global(X,R,C)).
expand_only_custom_closure_global(global_set(GS),ExpandedSet,_) :- !,all_elements_of_type(GS,ExpandedSet).
expand_only_custom_closure_global(freetype(GS),ExpandedSet,_) :- !,ExpandedSet=freetype(GS).
expand_only_custom_closure_global(avl_set(AVL),ExpandedSet,_) :- !, ExpandedSet=avl_set(AVL).
expand_only_custom_closure_global(closure(Parameters,PTypes,Cond),Res,CheckTimeOuts) :- !,
     (Res==[] -> is_empty_explicit_set(closure(Parameters,PTypes,Cond)) % TO DO: think about other special cases
       ; expand_closure_to_avl_or_list(Parameters,PTypes,Cond,Res,CheckTimeOuts)).
expand_only_custom_closure_global(Set,Set,_CheckTimeOuts).
%:-  add_error_and_fail(expand_only_custom_closure_global,'Cannot expand custom set: ',Set).


try_expand_custom_set(CS,Expansion) :-
  try_expand_custom_set_wf(CS,Expansion,try_expand_custom_set,no_wf_available).


try_expand_custom_set_wf(CS,Res,_,_) :- var(CS),!,Res=CS.
try_expand_custom_set_wf([],Res,_,_) :- !, Res=[].
try_expand_custom_set_wf([H|T],Res,_,_) :- !, Res=[H|T].
try_expand_custom_set_wf(CS,Res,Src,WF) :-
   expand_custom_set_wf(CS,Res,Src,WF). % will generate error message for illegal sets


:- assert_must_succeed((expand_custom_set_to_list(closure(['_zzzz_unit_tests'],
 [couple(integer,integer)],
 b(member(b(identifier('_zzzz_unit_tests'),couple(integer,integer),[generated]),
 b(value([(int(1),int(22))]),set(couple(integer,integer)),[])),pred,[])),R),R==[(int(1),int(22))])).

expand_custom_set_to_list(CS,List) :- expand_custom_set_to_list(CS,List,_Done,unknown).

% a version of expansion which returns guaranteed_ground if the List is guaranteed to be ground
expand_custom_set_to_list_gg(CS,List,GuaranteedGround,_PP) :-
   nonvar(CS), CS=avl_set(AVL), var(List),
   !,
   GuaranteedGround = guaranteed_ground,
   avl_domain(AVL,List).
expand_custom_set_to_list_gg(CS,List,not_guaranteed_ground,PP) :-
   expand_custom_set_to_list(CS,List,_Done,PP).

% a version where the expansion should happen straightaway and should not block:
expand_custom_set_to_list_now(CS,List) :- expand_custom_set_to_list(CS,List,Done,unknown),
  (Done==true -> true ; print_error(expand_custom_set_to_list_not_done(CS,List))).

:- block expand_custom_set_to_sorted_list(-,-,?,?).
% sorts the resulting list if needed
% due to random enumeration
expand_custom_set_to_sorted_list(From,To,Done,Source) :-
    expand_custom_set_to_list(From,UnsortedTo,Done,Source),
    (preferences:get_preference(randomise_enumeration_order,true)
     -> sort(UnsortedTo,To) ; UnsortedTo = To).

:- block expand_custom_set_to_list(-,-,?,?).
% ensures that the output is a pure list; the list skeleton should not be instantiated by anybody else
expand_custom_set_to_list(From,To,Done,Source) :-
  (var(From) -> expand_custom_set_to_list2(To,From,Done,Source) ;
                expand_custom_set_to_list2(From,To,Done,Source)).
expand_custom_set_to_list2([],ExpandedSet,Done,_Source) :- !,
    equal_object([],ExpandedSet,expand_custom_set_to_list2),Done=true.
expand_custom_set_to_list2([H|T],ExpandedSet,Done,Source) :- !,
    equal_object([H|ET],ExpandedSet,expand_custom_set_to_list2),
    expand_custom_set_to_list(T,ET,Done,Source).
expand_custom_set_to_list2(global_set(GS),ExpandedSet,Done,_Source) :- !,
    all_elements_of_type_rand(GS,R),
    check_list(R,expand_custom_set_to_list2),
    equal_object(R,ExpandedSet,expand_custom_set_to_list2),Done=true.
expand_custom_set_to_list2(avl_set(AVL),ExpandedSet,Done,_Source) :-  !,
    avl_domain(AVL,R), %print_term_summary(expanded(avl_set(AVL),R)),nl,
    equal_object(R,ExpandedSet,expand_custom_set_to_list2), Done=true.
expand_custom_set_to_list2(closure(Parameters,PTypes,Cond),ExpandedSet,Done,Source) :- !,
    expand_closure_to_list(Parameters,PTypes,Cond,ExpandedSet,Done,Source,no_wf_available).
    %assign_expand_result(CDone,Res,ExpandedSet,Done).
expand_custom_set_to_list2(freetype(ID),ExpandedSet,Done,_Source) :- !, %print(expand_freetype(ID)),nl,
     expand_freetype(ID,R),
     equal_object(R,ExpandedSet),
     Done=true.
% missing avl_set wrapper:
expand_custom_set_to_list2(node(A,B,C,D,E),ExpandedSet,Done,Source) :- !,
     add_internal_error('Illegal argument: ',expand_custom_set_to_list2(node(A,B,C,D,E),ExpandedSet,Done,Source)),
     expand_custom_set_to_list2(avl_set(node(A,B,C,D,E)),ExpandedSet,Done,Source).
expand_custom_set_to_list2(E,ES,Done,Source) :-
     add_internal_error('Illegal argument: ',expand_custom_set_to_list2(E,ES,Done,Source)),fail.

expand_freetype(ID,Elements) :- var(ID), !,
    add_internal_error('Uninstantiated freetype ID: ',expand_freetype(ID,Elements)), fail.
expand_freetype(ID,Elements) :-
    findall(FV, enumerate_freetype(basic,FV,freetype(ID)), Elements).


% true if it is more efficient to keep this, rather than expand into list
is_efficient_custom_set(avl_set(_)).
is_efficient_custom_set(closure(P,T,B)) :-
  (is_interval_closure(closure(P,T,B),_,_) -> true ; is_infinite_or_symbolic_closure(P,T,B)).
is_efficient_custom_set(global_set(X)) :- is_infinite_global_set(X).
is_efficient_custom_set(freetype(_)).

% tries to expand & convert to avl_set; fails if not possible: NOTE: also generates empty AVL
expand_and_convert_to_avl_set(R,AER) :-
   try_expand_and_convert_to_avl(R,ER),
   nonvar(ER),(ER==[] -> AER=empty ; ER=avl_set(AER)).


expand_and_convert_to_avl_set_unless_very_large(R,AER) :-
   try_expand_and_convert_to_avl_unless_very_large(R,ER),
   nonvar(ER),(ER==[] -> AER=empty ; ER=avl_set(AER)).

% similar to unless_large version, but will only expand if it is guaranteed to be small

try_expand_and_convert_to_avl_if_smaller_than(freetype(GS),Res,_) :- !, Res = freetype(GS).
try_expand_and_convert_to_avl_if_smaller_than([H|T],Res,_) :- !, try_expand_and_convert_to_avl([H|T],Res).
try_expand_and_convert_to_avl_if_smaller_than(avl_set(A),Res,_) :- !, Res=avl_set(A).
try_expand_and_convert_to_avl_if_smaller_than(CS,Res,Limit) :-
  (is_small_specific_custom_set(CS,Limit)
    -> % print(expand(Limit)),nl, translate:print_bvalue(CS),nl,
       try_expand_and_convert_to_avl(CS,Res)
    ;  Res = CS % TO DO: maybe look at cardinality of types and determine max. cardinality
  ).
is_small_specific_custom_set(CS,Limit) :- card_for_specific_custom_set(CS,Card,Code),
     call(Code), ground(Card),Card \= inf, number(Card),Card<Limit.
get_card_for_specific_custom_set(CS,Card) :-
     card_for_specific_custom_set(CS,Card,Code),
     call(Code), ground(Card).

try_expand_and_convert_to_avl_unless_large(CS,Res) :-
   try_expand_and_convert_to_avl_unless_large(CS,Res,2000).
try_expand_and_convert_to_avl_unless_very_large(CS,Res) :-
   try_expand_and_convert_to_avl_unless_large(CS,Res,10000).
%try_expand_and_convert_to_avl_unless_very_very_large(CS,Res) :-
%   try_expand_and_convert_to_avl_unless_large(CS,Res,100000).

try_expand_and_convert_to_avl_unless_large(CS,Res,_) :- var(CS), !, CS=Res.
try_expand_and_convert_to_avl_unless_large(global_set(GS),Res,_) :- !, Res = global_set(GS).
try_expand_and_convert_to_avl_unless_large(freetype(GS),Res,_) :- !, Res = freetype(GS).
%try_expand_and_convert_to_avl_unless_large(CS,Res) :- is_interval_closure(CS,Low,Up),!,
%  ((ground(Low),ground(Up),Size is 1+Up-Low, Size<2000)
%%    -> try_expand_and_convert_to_avl(CS,Res)
%    ;  Res = CS
%  ).
try_expand_and_convert_to_avl_unless_large(closure(P,T,B),Res,_Limit) :-
   is_symbolic_closure(P,T,B),!, % is explicitly marked as SYMBOLIC
   %print('NOT EXPANDING: '),translate:print_bvalue(closure(P,T,B)),nl,
   Res=closure(P,T,B).
try_expand_and_convert_to_avl_unless_large(CS,Res,Limit) :-
  card_for_specific_closure(CS,Card,Code),
  on_enumeration_warning(call(Code),
                        (debug_println(cannot_expand_specific_closure_for_card(Limit)), % see test 1519 for relevance
                         Card=inf)), % assume Card is infinite (could be finite; but we cannot expand it anyway)
  !,
  ((ground(Card),Card \= inf, number(Card),Card<Limit)
    -> try_expand_and_convert_to_avl(CS,Res)
    ;  Res = CS
  ).
try_expand_and_convert_to_avl_unless_large(CS,Res,_Limit) :-
  % TO DO: check if maybe we cannot determine card explicitly, but have a large lower-bound
  % print_term_summary(try_expand(CS)),
   try_expand_and_convert_to_avl(CS,Res). % ,print(expanded),nl.


expand_if_small(CS,Res,Limit) :-
  card_for_specific_closure(CS,Card,Code),
  call(Code), ground(Card),Card \= inf, number(Card),Card<Limit,
  try_expand_and_convert_to_avl(CS,Res), nonvar(Res), Res=avl_set(_).

/*
is_definitely_larger_than(closure(P,T,B),Limit) :-
  card_for_specific_closure(CS,Card,Code),
  call(Code),ground(Card),
  (Card == inf -> true ; number(Card),Card>Limit).
is_definitely_larger_than(global_set(GS),Limit) :-
  b_global_set_cardinality(GS,Card), Card>Limit.*/



% calls try_expand_and_convert_to_avl and returns original value if enumeration warning occured
try_expand_and_convert_to_avl_with_catch(CS,Res) :-
  on_enumeration_warning(try_expand_and_convert_to_avl(CS,Res),
                         Res=CS).

/* tries to generate an avl-structure, if possible */
try_expand_and_convert_to_avl(CS,Res) :- var(CS), !, CS=Res.
try_expand_and_convert_to_avl(avl_set(A),R) :- !, R=avl_set(A).
try_expand_and_convert_to_avl([],R) :- !, R=[].
try_expand_and_convert_to_avl([H|T],R) :- !, try_convert_to_avl([H|T],R).
try_expand_and_convert_to_avl(closure(P,T,B),Res) :- !,
     expand_only_custom_closure_global(closure(P,T,B),Expansion,check(try_expand_and_convert_to_avl1)),
     try_convert_to_avl(Expansion,Res).
try_expand_and_convert_to_avl(CS,Res) :-
   (\+ is_custom_explicit_set(CS,try_expand_and_convert_to_avl)
     -> Expansion = CS
     ;  expand_only_custom_closure_global(CS,Expansion,check(try_expand_and_convert_to_avl2))
   ),
   try_convert_to_avl(Expansion,Res).

try_convert_to_avl(Expansion,Res) :-
   (should_be_converted_to_avl_from_lists(Expansion) -> construct_avl_from_lists(Expansion,Res) ; Res=Expansion).

should_be_converted_to_avl_from_lists(Value) :- nonvar(Value),
   \+ is_custom_explicit_set(Value,should_be_converted_to_avl_from_lists), % already avl_set, global_set or closure
   ground_value(Value).

should_be_converted_to_avl(Value) :- %preference(use_avl_trees_for_sets,true),
   ground_value(Value).

try_expand_and_convert_to_avl_with_check(CS,Res,_Origin) :- var(CS),!, Res = CS.
try_expand_and_convert_to_avl_with_check([],Res,_Origin) :- !, Res=[].
try_expand_and_convert_to_avl_with_check(avl_set(A),Res,_Origin) :- !, Res=avl_set(A).
try_expand_and_convert_to_avl_with_check([H|T],Res,_) :- !, try_expand_and_convert_to_avl([H|T],Res).
%try_expand_and_convert_to_avl_with_check(CS,Res,_Origin) :-
% \+ is_custom_explicit_set(CS,try_expand_and_convert_to_avl),!, Res = CS.
try_expand_and_convert_to_avl_with_check(CS,Res,_Origin) :-
   is_interval_closure(CS,Low,Up), %print(int(Low,Up)),nl,
   (var(Low) ; var(Up)), % better keep this symbolic as we may be able to do constraint propagation
   !, % TO DO: see if we should do this check in try_expand_and_convert_to_avl above instead
   Res=CS.
try_expand_and_convert_to_avl_with_check(CS,Res,Origin) :-
   get_card_for_specific_custom_set(CS,Size), % TO DO: avoid checking for special closures twice (below in try_expand_and_convert_to_avl ?)
   !,
   try_expand_and_convert_to_avl_with_check_size(Size,CS,Res,Origin).
try_expand_and_convert_to_avl_with_check(CS,Res,_) :-
   try_expand_and_convert_to_avl(CS,Res).

try_expand_and_convert_to_avl_with_check_size(inf,CS,Res,Origin) :- !,
    debug_format(9,'### Not expanding infinite or very large set~n### ORIGIN: ~w~n',[Origin]),
    Res=CS.
try_expand_and_convert_to_avl_with_check_size(Size,CS,Res,Origin) :- Size>=10000000, !,
    /* will probably never terminate */
    debug_format(9,'### Not expanding very large set with cardinality ~w~n### ORIGIN: ~w~n',[Size,Origin]),
    Res=CS.
try_expand_and_convert_to_avl_with_check_size(Size,CS,Res,Origin) :- Size>=50000, !,
    print('### WARNING: expanding very large comprehension set, size = '), print(Size),nl,
    print('### ORIGIN:  '), print(Origin),nl,
    try_expand_and_convert_to_avl(CS,Res).
try_expand_and_convert_to_avl_with_check_size(_Size,CS,Res,_Origin) :-
    try_expand_and_convert_to_avl(CS,Res).

/* underlying assumption for var case: if G is a global set: we get back the
 global_set tag immediately: no need to use when to wait;
  better: ensure that b_compute_expression always returns a nonvar term */


:- assert_must_succeed((custom_explicit_sets:try_expand_custom_set(closure([xx],[integer],b(falsity,pred,[])),R),R = [])).
:- assert_must_succeed((custom_explicit_sets:test_closure(X),custom_explicit_sets:expand_custom_set(X,EX),
  EX = [(fd(1,'Name'),_),(fd(3,'Name'),_)])).

test_closure(X) :- X = closure(['_zzzz_binary'],[couple(global('Name'),set(global('Name')))],
      b(member(b(identifier('_zzzz_binary'),couple(global('Name'),set(global('Name'))),[generated]),
      b(cartesian_product(b(value([fd(1,'Name'),fd(3,'Name')]),set(global('Name')),[]),
      b(value([[fd(2,'Name'),fd(3,'Name')]]),set(set(global('Name'))),[])),
      set(couple(global('Name'),set(global('Name')))),[])),pred,[])).


/* --------- */
/* ELEMENT_OF */
/* --------- */


/* A function that instantiates last argument when membership test can be decided */

membership_custom_set(CS,X,R) :- print(warning_deprecated_non_wf_version(CS,X,R)),nl,
   membership_custom_set_wf(CS,X,R,_WF).

% membership_custom_set(CS,X,R) :- print(mem_cs(CS,X,R)),nl,fail.
membership_custom_set_wf(avl_set(A),X,R,WF) :- !,  membership_avl_set_wf(A,X,R,WF).
membership_custom_set_wf(freetype(_GS),_X,R,_WF) :- !, R=pred_true. % should be covered by clause above
membership_custom_set_wf(CS,X,R,WF) :- R==pred_true,!, element_of_custom_set_wf(X,CS,WF).
membership_custom_set_wf(CS,X,R,WF) :- R==pred_false,!, not_element_of_custom_set_wf(X,CS,WF).
membership_custom_set_wf(CS,_X,R,_WF) :-
   is_definitely_maximal_set(CS),!,  %print(mem_gs(GS,X)),nl,
   R=pred_true.
membership_custom_set_wf(closure(Par,Types,Body),X,R,WF) :- !,
   closure_membership_wf(X,Par,Types,Body,R,WF).
%membership_custom_set_wf(CS,X,R,_WF) :- is_one_element_custom_set(CS,Y),!, % only succeeds for AVL
%   kernel_equality:equality_objects(X,Y,R).
membership_custom_set_wf(global_set(GS),X,R,WF) :- !,
   membership_global_set(GS,X,R,WF).
membership_custom_set_wf(CS,X,R,WF) :-
   add_internal_error('Illegal custom set: ',membership_custom_set_wf(CS,X,R,WF)),fail.

membership_avl_set_wf(A,X,R,WF) :- R==pred_true,!, element_of_avl_set_wf(A,X,WF).
membership_avl_set_wf(A,X,R,WF) :- R==pred_false,!, not_element_of_custom_set_wf(X,avl_set(A),WF).
membership_avl_set_wf(A,X,R,_WF) :- is_one_element_avl(A,Y),!,
   kernel_equality:equality_objects(X,Y,R).
membership_avl_set_wf(A,_X,R,_WF) :-
   quick_definitely_maximal_set_avl(A),!,  %print(mem_gs(GS,X)),nl,
   R=pred_true.
membership_avl_set_wf(A,X,R,WF) :- reify_avl_membership(A,X,R,_FullReification),
   %print(reification(R,FullReification,X,CS)),nl,
   %(FullReification=true -> true ;   %% THIS Slows down e.g. Bosch Deadlock v9 !  TO DO: investigate why
     when((ground(X);nonvar(R)),membership_avl_set_wf2(A,X,R,WF)).

membership_avl_set_wf2(A,X,R,WF) :- R==pred_true,!, element_of_avl_set_wf(A,X,WF).
membership_avl_set_wf2(A,X,R,WF) :- R==pred_false,!, not_element_of_custom_set_wf(X,avl_set(A),WF).
membership_avl_set_wf2(AVL,X,R,_WF) :-
   ground_element_can_be_added_or_removed_to_avl(X), !,
   (safe_avl_member(X,AVL) %safe_avl_member_ground(X,AVL)
    -> R=pred_true ; R=pred_false).
membership_avl_set_wf2(AVL,X,Res,WF) :- % X is ground but cannot be added
    (Res \== pred_false, element_of_avl_set_wf(AVL,X,WF), Res=pred_true
     ;
     Res \== pred_true, not_element_of_custom_set_wf(X,avl_set(AVL),WF), Res=pred_false).

membership_global_set(GS,_X,R,_WF) :- is_maximal_global_set(GS),!,
   R=pred_true.
membership_global_set(GS,X,R,WF) :- ground(X),!,
   (element_of_global_set_wf(X,GS,WF) -> R=pred_true ; R=pred_false).
membership_global_set(GS,X,R,_WF) :- get_integer_set_interval(GS,Low,Up),!,
    membership_interval(X,Low,Up,R).
membership_global_set(GS,X,R,WF) :- % this case should probably never apply
  print(uncovered_membership(GS,X,R,WF)),nl,
  when(ground(X), (element_of_global_set_wf(X,GS,WF) -> R=pred_true ; R=pred_false)).

membership_interval(X,Low,Up,Res) :- nonvar(Up),Up=inf,!,X=int(IX),
   b_interpreter_check:check_arithmetic_operator('<=',Low,IX,Res).
membership_interval(X,Low,Up,Res) :- kernel_equality:in_nat_range_test(X,int(Low),int(Up),Res).

:- use_module(bool_pred).
closure_membership_wf(X,[ZZZZ],[integer],CondClosure,Res,_WF) :- %print(closmem(X,Res)),nl,trace,
   is_interval_closure_body(CondClosure,ZZZZ,LOW,UP),!, % print(in_interval_closure(X,LOW,UP)),nl,
   kernel_equality:in_nat_range_test(X,int(LOW),int(UP),Res). % , print(in_nat_range(X,LOW,UP,Res)),nl.
% TO DO: deal with open intervals 0..inf  ...
closure_membership_wf(X,Par,Types,Body,Res,WF) :-
   is_member_closure(Par,Types,Body,_Type,VAL),
   (VAL=value(_) ; VAL = cartesian_product(b(value(A),_,_),b(value(B),_,_))),!,
   (VAL=value(Set)
    -> kernel_objects:membership_test_wf(Set,X,Res,WF)
    ; kernel_equality:cartesian_pair_test_wf(X,A,B,Res,WF)).
closure_membership_wf(X,Par,Typ,Body,Res,WF) :-
   is_not_member_closure(Par,Typ,Body,_Type,value(Set)),!, %print(not_mem(Closure)),nl,
   bool_pred:negate(ResXSet,Res), % was kernel_equality:inv_mem_obj(ResXSet,Res),
   kernel_objects:membership_test_wf(Set,X,ResXSet,WF).
% TO DO: if closure = POW closure -> translate into subset_test pow_subset
% TO DO: support a few other closures related to symbolic unary/binary operators: closure1, POW(..), ... ?
% TO DO: expand if set is small
closure_membership_wf(X,Par,Types,Body,Res,WF) :- ground_value(X),!,
    closure_membership_ground_wf(X,closure(Par,Types,Body),Res,WF).
closure_membership_wf(X,Par,Types,Body,Res,WF) :-
    expand_if_small(closure(Par,Types,Body),Expanded,100),!,
    %print(expanded(Expanded)),nl,
    membership_custom_set_wf(Expanded,X,Res,WF).
closure_membership_wf(X,Par,Types,Body,Res,WF) :-
   Body \= b(member(_,_),_,_), % otherwise we may have an infinite loop; b_check_boolean_expression will generate a closure which will call closure_membership_wf again; TO DO: refine to allow certain memberships to go through
   get_texpr_info(Body,BodyInfo),
   \+ member(prob_annotation(recursive(_RID)),BodyInfo), % otherwise we can get errors as recursive identifier _RID needs to be added to local state ! (test 1151 fails otherwise)
    % TO DO: add recursive parameter below in set_up_typed_localstate2; + in which other circumstances do we need to set up recursion identifier !
   % Try reifiyng the body
   NegationContext=positive,
   copy_wf_start(WF,CWF),
   b_interpreter:set_up_typed_localstate2(Par,Types,ParValues,TypedVals,[],State,NegationContext),
   %couplise_list(Types,XType),
   convert_list_into_pairs(ParValues,SingleParValue),
    % print(try_reify(X,Par,ParValues,SingleParValue)),nl, translate:print_bexpr(Body),nl,
   kernel_objects:equal_object(X,SingleParValue,closure_membership_wf),
   b_interpreter_check:b_check_boolean_expression(Body,[],State,CWF,PredRes),
   !,
   (debug_mode(on) -> print('REIFICATION of closure: '), translate:print_bexpr(Body),nl, print(pred_res(X,PredRes)),nl ; true),
    b_enumerate:b_tighter_enumerate_values(TypedVals,WF), % not necessary ?? as X should get enumerated
   Res=PredRes,
   copy_wf_finish(WF,CWF).
closure_membership_wf(X,Par,Types,Body,Res,WF) :- %print(delay(X,Body,Res)),nl,
    when( (ground(X);nonvar(Res)), %%
          % used to be ground(X), % with (ground(X);nonvar(Res)), test 292 failed {x,t|t : BOOL & (x : POW(1024 .. 1025) & bool(x : POW(NATURAL1)) = t)} = {{} |-> TRUE,{1024} |-> TRUE,{1024,1025} |-> TRUE,{1025} |-> TRUE} and test 1088 failed
        closure_membership_ground_wf(X,closure(Par,Types,Body),Res,WF)).

closure_membership_ground_wf(X,CS,Res,WF) :- nonvar(Res),!,
   % this optimization is checked in test 1452
    (Res==pred_true -> element_of_custom_set_wf(X,CS,WF) ; not_element_of_custom_set_wf(X,CS,WF)).
closure_membership_ground_wf(X,CS,Res,WF) :-
    % print(uncovered_closure(CS,X,Res)),nl,
    % to ensure that we leave no choice point behind we have to force full evaluation of element/not_element calls:
    % hence we do not call element_of_custom_set_wf or not_element_of_custom_set_wf below !!
    kernel_waitflags:get_idle_wait_flag(closure_membership_ground_wf,WF,LWF), % enable other triggered co-routines to fire first; some maybe much more efficient to deal with than closure expansion; important for test 1146
    %term_variables(CS,Vars),print(closure_membership_ground_wf_aux(LWF,vars(Vars),CS)),nl,
    ground_value_check(CS,CSGr),
    %when((nonvar(LWF),(nonvar(CSGr);nonvar(Res))),closure_membership_ground_wf_aux(X,CS,Res)).
    block_closure_membership_ground_wf_aux(X,CS,Res,CSGr,LWF). % Note: wrong block in commit 332cb17487017d819e9140427b1017a3045b3685 caused problem for test 1162

:- block block_closure_membership_ground_wf_aux(?,?,?,?,-),
         block_closure_membership_ground_wf_aux(?,?,-,-,?).
block_closure_membership_ground_wf_aux(X,CS,Res, _,_) :-
    closure_membership_ground_wf_aux(X,CS,Res).

% X & CS are ground or Res is known
closure_membership_ground_wf_aux(X,CS,Res) :- Res==pred_true,!,
    element_of_custom_set(X,CS).
closure_membership_ground_wf_aux(X,CS,Res) :- Res==pred_false,!,
    not_element_of_custom_set(X,CS).
closure_membership_ground_wf_aux(X,CS,Res) :-
    % we know that X is a ground value and CS is ground: we can determine completely whether X is element of CS or not
    if(element_of_custom_set(X,CS),Res=pred_true, Res=pred_false).
/* used to be:
    (Res \== pred_false, element_of_custom_set(X,CS), Res=pred_true
     ;
     Res \== pred_true, not_element_of_custom_set(X,CS), Res=pred_false)).
*/

%member_closure_membership(value(Set),X,Res) :- !, kernel_objects:membership_test(Set,X,Res).
%member_closure_membership(cartesian_product(b(value(A),_,_),b(value(B),_,_)),X,Res) :- !,
%    kernel_equality:cartesian_pair_test_wf(X,A,B,Res,WF).
%member_closure_membership(pow_subset(b(value(VAL),_,_)),X,Res) :-
%     kernel_equality:subset_test(X,VAL,Res,WF). % WE NEED WF

%:- block in_interval_test(?,-,?,?), in_interval_test(?,?,-,?).
%in_interval_test(X,Low,Up,MemRes) :-
%   ((X >= Low, X=< Up)  /* inf should not appear */
%      -> MemRes=pred_true ; MemRes=pred_false).



 :- use_module(kernel_objects,[element_of_global_set/2,element_of_global_set_wf/3]).
element_of_custom_set_wf(X,CS,WF) :-   %print(element_of_custom_set_wf2(CS,X,WF)),nl,
    element_of_custom_set_wf2(CS,X,WF). %, print(check_ok(X)),nl.

element_of_custom_set_wf2(node(A,B,C,D,E),X,WF) :-
   add_internal_error('Unwrapped avl_set: ',element_of_custom_set_wf2(node(A,B,C,D,E),X,WF)),fail.
element_of_custom_set_wf2(global_set(GS),X,WF) :- element_of_global_set_wf(X,GS,WF).
element_of_custom_set_wf2(freetype(ID),X,WF) :-
 (is_maximal_freetype(ID) -> true
   ;  add_internal_error('Uncovered case: ',element_of_custom_set_wf2(freetype(ID),X,WF))
 ). % we assume freetypes to be maximal !
element_of_custom_set_wf2(avl_set(AVL),X,WF) :- element_of_avl_set_wf(AVL,X,WF).
element_of_custom_set_wf2(closure(Parameters,PT,Cond),X,WF) :-
    element_of_closure(X,Parameters,PT,Cond,WF).

element_of_avl_set_wf(node(Y,_,_,empty,empty),X,WF) :- !,
   kernel_objects:equal_object_wf(X,Y,element_of_custom_set_wf2,WF).
element_of_avl_set_wf(AVL,X,_WF) :- ground_value(X),!, safe_avl_member(X,AVL). %safe_avl_member_ground(X,AVL).
element_of_avl_set_wf(AVL,X,WF) :-
   avl_approximate_size(AVL,10,ApproxSize),
   element_of_avl_set_wf(AVL,ApproxSize,X,WF).

:- use_module(clpfd_tables).

element_of_avl_set_wf(AVL,ApproxSize,X,WF) :- ApproxSize < 100,
   preferences:preference(use_clpfd_solver,true),
   (var(X) -> true ; X = (X1,_X2) -> (ground_value(X1) -> ApproxSize < 10 ; true) ; X=rec(_)),% check if worthwhile to attempt table treatment
   can_translate_avl_to_table(AVL,SkeletonType),
   %print(skel_for_table(ApproxSize,SkeletonType)),nl,
   !,
   check_element_of_avl_with_table(X,SkeletonType,AVL,WF).
element_of_avl_set_wf(AVL,ApproxSize,X,WF) :-
   propagate_avl_element_information(X,AVL,ApproxSize,WF), %translate:translate_bvalue(avl_set(AVL),SS),
   get_bounded_wait_flag(ApproxSize,element_of_avl(X),WF,WF1),
   %print(el_avl(X,Size)),nl,
   element_of_avl_set_wf3(X,AVL,ApproxSize,WF1,WF).


% compute an approximate size (small sets are computed exactly)
avl_approximate_size(AVL,Size) :- avl_approximate_size(AVL,10,Size).

avl_approximate_size(AVL,HeightBound,Size) :- var(AVL),!,
   add_internal_error('AVL Set is variable: ', avl_approximate_size(AVL,HeightBound,Size)),
   Size=1000000.
avl_approximate_size(AVL,HeightBound,Size) :- % when the AVL gets too large; not so important that we have a precise estimation anyway
   % so: save some time and just compute height
   avl_height(AVL,Height),
   (Height>HeightBound -> Size is integer(2**Height-1) %,print(avl_aprox(Height,Size)),nl
    ; avl_size(AVL,Size)).

:- block element_of_avl_set_wf3(-,?,?,-,?).
element_of_avl_set_wf3(X,AVL,_ApproxSize,WF1,_WF) :- nonvar(WF1), !,  safe_avl_member(X,AVL).
  % TO DO: if randomise_enumeration_order is true then choose elements in random order
:- if(environ(prob_data_validation_mode,xxxtrue)). % currently disabled due to bug related to 14082013/435_002.mch  TO DO: investigate
element_of_avl_set_wf3((X,Y),AVL,ApproxSize,WF1,WF) :- !,
    %%  ((var(WF1), \+ ground(X)) -> print(avl_relation_check(X,Y)),nl, %%
    %%       copy_term((X,Y),Copy), findall(Copy,safe_avl_member(Copy,AVL),Cs), print(Cs),nl, Cs \=[] %% check that at least one element exists
    %%     ; true),
    couple_element_of_avl_set_wf(X,Y,AVL,ApproxSize,WF1,WF).
:- else.
element_of_avl_set_wf3((X,Y),AVL,ApproxSize,WF1,WF) :- !,
     %print(avl_relation(X,Y)),nl, %%
     ground_value_check(X,GrX),
     block_couple_element_of_avl_set_grX_wf1(X,Y,AVL,ApproxSize,GrX,WF1,WF).
     %when((nonvar(WF1) ; ground(X)), couple_element_of_avl_set(X,Y,AVL,GrX,WF1,WF)).
:- endif.
element_of_avl_set_wf3(X,AVL,_ApproxSize,WF1,_WF) :-
  %print(avl_mem(X,Size,WF1)),portray_custom_explicit_set(avl_set(AVL)),
   when((nonvar(WF1);ground(X)),
       %%( (var(WF1) -> true ; print(selecting(X,Size)), %translate:print_value_variable(X),portray_custom_explicit_set(avl_set(AVL))), %%
       safe_avl_member(X,AVL) %(var(WF1) -> safe_avl_member_ground(X,AVL) ; safe_avl_member(X,AVL))
        %% ,(var(WF1) -> true ; print(chosen(X,Size)),nl) )%%
        ).

:- if(environ(prob_data_validation_mode,true)).
:- public couple_element_of_avl_set_wf/6. % used in conditional if above
:- block couple_element_of_avl_set_wf(-,?,?,?,-,?).
couple_element_of_avl_set_wf(X,Y,AVL,ApproxSize,WF1,WF) :-
    ground_value_check(X,GrX),
    ((nonvar(WF1);nonvar(GrX)) -> couple_element_of_avl_set(X,Y,AVL,GrX,WF1,WF)
     %; true ->  when((nonvar(WF1) ; ground(X)), couple_element_of_avl_set(X,Y,AVL,WF1,WF))
     ; nonvar(X),X=(X1,X2),ground(X1) -> triple_element_of_avl_set(X1,X2,Y,AVL,WF)
     ; nonvar(X),X=(X1,X2) ->
        %print_term_summary(avl_member_blocking(X,Y,AVL)),nl,
        avl_member_blocking((X,Y),AVL),
        (ground(Y),ground(X1) -> safe_avl_member_pair(X,Y,AVL)
          ;  when(ground(X1),(\+ ground(X2) -> triple_element_of_avl_set(X1,X2,Y,AVL,WF) ; true % avl_member_blocking will have done its work
                  )),
             block_couple_element_of_avl_set(X,Y,AVL,WF1,WF)
        )
     ; %when((nonvar(WF1) ; ground(X)), couple_element_of_avl_set(X,Y,AVL,WF1,WF))
       block_couple_element_of_avl_set_grX_wf1(X,Y,AVL,ApproxSize,GrX,WF1,WF)
   /*  ; (simple_avl_type(AVL)
        -> avl_member_blocking((X,Y),AVL) % TO DO: don't call couple_element_of_avl_set ! avoid double traversal !!
         ; true),
        block_couple_element_of_avl_set_grX_wf1(X,Y,AVL,GrX,WF1,WF) */
    ).

:- block block_couple_element_of_avl_set(?,?,?,-,?).
block_couple_element_of_avl_set(X,Y,_AVL,_WF1,_WF) :- ground(X),ground(Y),!.
block_couple_element_of_avl_set(X,Y,AVL,_WF1,_WF) :- safe_avl_member_pair(X,Y,AVL).

triple_element_of_avl_set(X1,X2,Y,AVLRelation,WF) :- % X1 must be ground
    copy_term((X2,Y),(CX2,CY)),
    findall((CX2,CY),safe_avl_member_pair((X1,CX2),CY,AVLRelation),Images),
    %print(images(X,Y,Images)),nl,
    Images \= [],
    construct_avl_from_lists(Images,AVL),
    %print(AVL),
    element_of_custom_set_wf2(AVL,(X2,Y),WF). % will set up waitflag if necessary
:- endif.

% ---------------------------------------------------

test_avl_set(node(((int(2),int(3)),int(6)),true,0,node(((int(1),int(2)),int(2)),true,0,empty,empty),node(((int(3),int(4)),int(12)),true,0,empty,empty))).

%simple_avl_type(node(K,_,_,_,_)) :- simple_value(K). % we can index directly on AVL, without having to normalise inner values
% in particular, we can apply avl_member_blocking

:- assert_must_succeed(( custom_explicit_sets:test_avl_set(A), custom_explicit_sets:avl_member_blocking(((X,Y),Z),A), X=int(2), Y==int(3),Z==int(6) )).
:- assert_must_succeed(( custom_explicit_sets:test_avl_set(A), custom_explicit_sets:avl_member_blocking(((X,Y),Z),A), X=int(3), Y==int(4),Z==int(12) )).
:- assert_must_succeed(( custom_explicit_sets:test_avl_set(A), custom_explicit_sets:avl_member_blocking(((X,Y),Z),A), X=int(1), Y==int(2),Z==int(2) )).
:- assert_must_fail(( custom_explicit_sets:test_avl_set(A), custom_explicit_sets:avl_member_blocking(((X,_Y),_Z),A), X=int(5) )).
% a blocking version of avl_member; will not instantiate the element; just prune

avl_member_blocking(Key, AVL) :- AVL=node(K,_,_,L,R),
   %avl_height(AVL,Height),
   avl_member_blocking4(Key,K,L,R).

avl_member_blocking4(Key,Kavl,L,R) :- L=empty,R=empty,!,
    Key=Kavl.  % we could do equal_object
avl_member_blocking4(Key,Kavl,L,R) :-
    match_possible(Key,Kavl,MatchPossible), % check if in principle a match could occur
    %(MatchPossible==pred_false -> avl_height(L,Height),print('#'(Height)) ; true),
	(Kavl=(_,_) ->
	  (avl_min(R,Knext) -> true ; dif(O,>), Knext=no_match, %print(n(MatchPossible)),
	                              force_comp(MatchPossible,O,'<')),
	  (avl_max(L,Kprev) -> true ; dif(O,<), Kprev=no_match, %print(p(MatchPossible)),
	                              force_comp(MatchPossible,O,'>'))
	  ; Knext = no_match, Kprev = no_match
	),
	%print(avl_mem(Key,K,O, Kprev,Knext)),nl,
	(nonvar(O) -> true
	  /* ; (MatchPossible==pred_false, avl_height(L,Height), Height < 8,
	     copy_term(Key,CKey), \+ safe_avl_member(CKey,L), \+ safe_avl_member(CKey,R))
	     ->  print(cannot_match(Key)),nl,fail */
	  ; compare_blocking(O, Key, Kavl, Kprev,Knext)),
	avl_member_blocking_aux(O, Key, Kavl, L, R).

%force_comp(V,_,_) :- var(V),!.
:- block force_comp(-,?,?).
force_comp(pred_true,_,_).
force_comp(pred_false,R,R).

:- block avl_member_blocking_aux(-,?,?,?,?).
%avl_member_blocking_aux(O, Key, K, L, R) :- print(avl_member_blocking_aux(O, Key, K, L, R)),nl,fail.
avl_member_blocking_aux(<, Key, _K, AVL, _) :- avl_member_blocking(Key, AVL).
avl_member_blocking_aux(=, Key, Key,  _L, _R). % we could use equal_object
avl_member_blocking_aux(>, Key, _K, _, AVL) :- avl_member_blocking(Key, AVL).

% a blocking version of compare
compare_blocking(Res,A,Kavl, Kprev, Knext) :- block_compare(A,Kavl,Res, Kprev, Knext).

:- block block_compare(-,?,?,?,?), block_compare(?,-,?,?,?).
block_compare((A,B),Kavl,Res, Kprev, Knext) :- !,
   (Kavl=(RA,RB) ->
        match_key(Kprev,RA,PA,PB),
        match_key(Knext,RA,NA,NB),
        block_compare(A,RA,ACRes,PA,NA),
        block_compare_aux(ACRes,B,RB,Res,PB,NB)
      ; add_internal_error('Illegal type: ',block_compare((A,B),Kavl,Res, Kprev, Knext)),fail).
% TO DO: same for records; but currently not used anyway
block_compare(int(A),int(B),Res,_,_) :- !, block_compare_atomic(A,B,Res).
block_compare(pred_false,B,Res,_,_) :- !, block_compare_atomic(pred_false,B,Res).
block_compare(pred_true,B,Res,_,_) :- !, block_compare_atomic(pred_true,B,Res).
block_compare(string(A),string(B),Res,_,_) :- !, block_compare_atomic(A,B,Res).
block_compare(fd(A,T),fd(B,T),Res,_,_) :- !, block_compare_atomic(A,B,Res).
block_compare(avl_set(A),Kavl,Res,_,_) :- !,
    convert_to_avl_inside_set(avl_set(A),ConvertedA),compare(Res,ConvertedA,Kavl).
block_compare([],[],Res,_,_) :- !, Res = '='.
block_compare([],_,Res,_,_) :- !, Res = '<'.
block_compare(A,Kavl,Res,_,_) :-
    % does deal with various representations of sets !!  closure/global_set/...
    when(ground(A),
      (convert_to_avl_inside_set(A,ConvertedA),compare(Res,ConvertedA,Kavl))).

match_key((KeyA,KeyB),Key,ResA,ResB) :- !, ResA=KeyA,
 (Key==KeyA -> ResB=KeyB ; ResB = no_match).
match_key(_,_,no_match,no_match).

:- block block_compare_atomic(-,?,?), block_compare_atomic(?,-,?).
block_compare_atomic(A,B,Res) :- compare(Res,A,B).

:- block block_compare_aux(-,?,?,?, ?,?).
block_compare_aux(ACRes,B,D,Res,  Kprev,Knext) :-
    (ACRes='<' -> Res = '<'
      ; ACRes = '>' -> Res = '>'
      ; Kprev=no_match, Knext=no_match -> %print(forcing(B,D)),nl,
           Res = '=' % we cannot match neither previous nor next key: force match
      ; block_compare(B,D,Res,Kprev,Knext)).  % TO DO: check with prev & next value: if no match possible force Res='='

% check if a match is possible between two terms
:- block match_possible(-,?,?), match_possible(?,-,?).
match_possible([],[],Possible) :- !, Possible=pred_true.
match_possible([],avl_set(_),Possible) :- !, Possible=pred_false.
match_possible(avl_set(_),[],Possible) :- !, Possible=pred_false.
match_possible(int(A),int(B),Possible) :- !, match_possible_atomic(A,B,Possible).
match_possible(fd(A,T),fd(B,T),Possible) :- !, match_possible_atomic(A,B,Possible).
match_possible(string(A),string(B),Possible) :- !, match_possible_atomic(A,B,Possible).
match_possible((A1,A2),(B1,B2),Possible) :- !, match_possible(A1,B1,P1),
   match_possible(A2,B2,P2), kernel_equality:conjoin_test(P1,P2,Possible,_WF). %% WF <--- TO DO
match_possible(_,_,pred_true).

:- block match_possible_atomic(-,?,?), match_possible_atomic(?,-,?).
match_possible_atomic(A,B,Res) :- (A==B -> Res=pred_true ; Res=pred_false).

% --------------------------------------------

:- block block_couple_element_of_avl_set_grX_wf1(?, - ,?,?,-,-,?).
block_couple_element_of_avl_set_grX_wf1(X,Y,AVL,ApproxSize,GrX,WF1,WF) :- %print(inverse1(ApproxSize,GrX,WF1,Y)),nl,
    var(GrX), var(WF1),
    !,
    %print(inverse(ApproxSize,GrX,WF1,Y)),nl,
    % we know the result Y but not yet fully the input value X
    (ApproxSize < 129 % TO DO: improve this; unify with inverse_apply_ok(Y,X,AVL,ApproxSize) ?
      -> ground_value_check(Y,GrY)  % wait until Y is fully known
    ; (preference(solver_strength,SS), ApproxSize < 129+SS)
      -> ground_value_check(Y,GrY)
      % TO DO: we could look at avl_min and avl_max and estimate spread of range keys
      ; perfmessage(no_inverse_avl_lookup(ApproxSize,Y)) % do not bind GrY; we wait until GrX or WF1 is bound
    ),
    block_couple_element_of_avl_set_grX_grY_wf1(X,Y,AVL,ApproxSize,GrX,GrY,WF1,WF).
block_couple_element_of_avl_set_grX_wf1(X,Y,AVL,_ApproxSize,GrX,WF1,WF) :-
    couple_element_of_avl_set(X,Y,AVL,GrX,WF1,WF).

:- block block_couple_element_of_avl_set_grX_grY_wf1(?,?,?,?, -,-,-,?).
block_couple_element_of_avl_set_grX_grY_wf1(X,Y,AVL,_ApproxSize, GrX,_GrY,WF1,WF) :-
    var(GrX), var(WF1), % i.e., Y is known
    % we know the result Y but not yet fully the input value X
    %inverse_apply_ok(Y,X,AVL,ApproxSize),
    % print(try_invert_y(Y,ApproxSize,X,GrX)),nl,
    %avl:portray_avl(AVL),nl,
    !,
    inverse_get_possible_values(X,Y,AVL,Res),
    %print(possible_values),nl,translate:print_bvalue(Res),nl,
    Res = avl_set(InvAVL),
    element_of_avl_set_wf(InvAVL,X,WF).
    %couple_element_of_avl_set(X,Y,AVL,GrX,1,WF).
block_couple_element_of_avl_set_grX_grY_wf1(X,Y,AVL,_ApproxSize,GrX,_GrY,WF1,WF) :-
    couple_element_of_avl_set(X,Y,AVL,GrX,WF1,WF).


% special treatment for relations: if the first component is known: then we can check how many images there are
couple_element_of_avl_set(X,Y,AVL,GrX,WF1,_WF) :-
     %print_term_summary(couple_element_of_avl_set(X,Y,AVL,WF1,_WF)),nl,
     %hashing:my_term_hash((X,Y,AVL),Hash), %print(hash(Hash)),nl,
     %(Hash=797296156541305712 -> trace ; true), %1008421951878593614
     nonvar(WF1), var(GrX), %\+ground(X),
     !,  %nl,print_term_summary(couple_element_of_avl_set_nonground(X,Y,AVL,WF1,_WF)),nl,
     safe_avl_member_default((X,Y),AVL).
couple_element_of_avl_set(X,Y,AVLRelation,_GrX,_,WF) :- % X must be ground
    copy_term(Y,CY),
    findall(CY,avl_member_pair_arg1_ground(X,CY,AVLRelation),Images), % should we use Y instead of CY
    %print(images(X,Y,Images)),nl,
    Images \= [],
    construct_avl_from_lists(Images,AVL),
    %print(AVL),
    element_of_custom_set_wf2(AVL,Y,WF). % will set up waitflag if necessary




% set Res -> pred_true or pred_false if membership can be decided early
% interval closures already dealt with by closure_membership
% maximal sets are also already dealt with by membership_custom_set
reify_avl_membership(AVL,Element,Res,FullReification) :-
   is_avl_simple_set(AVL,Type),
   preferences:preference(use_clpfd_solver,true), % to do: require maybe only for integer type !?
    \+ ground_value(Element),
   !,
   reify_avl_mem2(Type,Element,AVL,Res,FullReification).
reify_avl_membership(_,_,_,false).


is_avl_simple_set(node(El,_True,_,_,_),Type) :- simple_type(El,Type).
simple_type(int(_),integer).
simple_type(fd(_,GS),global(GS)).


:- use_module(clpfd_interface,[post_constraint/1, clpfd_reify_inlist/3]).
reify_avl_mem2(integer,int(El),AVL,Res,FullReification) :-
   avl_min(AVL,int(Min)), avl_max(AVL,int(Max)),
   %print(post(El,Min,Max)),nl,
   (reify_integer_avl_mem(AVL,Min,Max)
     ->  clpfd_interface:post_constraint( (El in Min..Max) #<=> FDRes),
         propagate_not_membership(FDRes,Res,int(El,Min,Max)),
         FullReification=false
     ;   avl_domain(AVL,R),project_avl_domain_on_fd(R,FDList),
         clpfd_interface:clpfd_reify_inlist(El,FDList,FDRes),
         %print(clpfd_reify_int_inlist(El,FDList,FDRes)),nl,
         propagate_fd_membership(FDRes,Res,inlist(El,FDList)),
         FullReification=true
   ).
% this could also be enabled with CLPFD = FALSE ?? no overflows are possible
reify_avl_mem2(global(GS),fd(El,GS),AVL,Res,true) :- % print(reify_avl_mem2(global(GS),fd(El,GS),AVL,Res)),nl,nl,
   avl_domain(AVL,R),project_avl_domain_on_fd(R,FDList),
   b_global_sets:b_get_fd_type_bounds(GS,Low,Up),
   (is_full_fdlist(FDList,Low,Up)
     -> % print(full_list(FDList,Low,Up)),nl,nl,trace,
        Res=pred_true % all the values are in the list; it must be a member
        % normally this should also be detected by clpfd_reify_inlist, unless no constraint was set up for El
        % it seems to have an effect for test 426: probcli examples/EventBPrologPackages/SSF/Bepi_Soton/M1_mch.eventb -cbc all -strict -p CLPFD TRUE -p SMT TRUE -strict -p STRICT_RAISE_WARNINGS TRUE
     ; %print(reify(El,FDList,FDRes)),nl,
       clpfd_interface:clpfd_reify_inlist(El,FDList,FDRes),
       % print(clpfd_reify_inlist(El,FDList,FDRes)),nl,trace,
       propagate_fd_membership(FDRes,Res,inlist(El,FDList))).
%reify_avl_mem2(global(GS),fd(El,GS),AVL,Res) :-
%   avl_min(AVL,fd(Min,GS)), avl_max(AVL,fd(Max,GS)),
%   clpfd_interface:post_constraint( (El in Min..Max) #<=> FDRes),
%   propagate_not_membership(FDRes,Res,fd(El,GS,Min,Max)).

% assumes list is sorted
is_full_fdlist([],Low,Up) :- Low>Up.
is_full_fdlist([Low|T],Low,Up) :- L1 is Low+1, is_full_fdlist(T,L1,Up).

% check if avl small enough to call clpfd_reify_inlist
reify_integer_avl_mem(_AVL,Min,Max) :- MaxSizeM1 is Max-Min, MaxSizeM1 =< 20,!.
reify_integer_avl_mem(AVL,_Min,_Max) :- avl_height_less_than(AVL,5).



project_avl_domain_on_fd([],[]).
project_avl_domain_on_fd([H|T],[PH|PT]) :- project_avl_domain(H,PH), project_avl_domain_on_fd(T,PT).
project_avl_domain(int(X),X).
project_avl_domain(fd(X,_),X).


:- block propagate_fd_membership(-,?,?).
 % if we make it propagate_fd_membership(-,-?) Bosch examples becomes much slower ?
 % Indeed: membership_custom_set will already force membership or non-membership !
%propagate_fd_membership(X,M,Info) :- var(X),!, print(propagate_fd(X,M,Info)),nl,  (M=pred_true ->X=1 ; X=0).
propagate_fd_membership(1,pred_true,_Info).
propagate_fd_membership(0,pred_false,_Info).

:- block propagate_not_membership(-,?,?).
propagate_not_membership(1,_,_). % there could be elements in the interval which are not in the set
propagate_not_membership(0,Res,_Info) :- %print(not_mem(_Info)),nl,
    Res=pred_false.

% -----------------

% fails if not possible to quickly compute approximate size
quick_custom_explicit_set_approximate_size(V,_) :- var(V),!,fail.
quick_custom_explicit_set_approximate_size(avl_set(AVL),Size) :- !,
    quick_avl_approximate_size(AVL,Size).
quick_custom_explicit_set_approximate_size(CS,Size) :-
    card_for_specific_custom_set(CS,Size,Code), call(Code).

:- use_module(clpfd_lists,[try_get_fd_value_list/4, get_fd_value/3, in_fd_value_list_wf/4]).
% a membership propagation, but only done if it can be done quickly


% quick_propagation_element_information(Set, Element, WF, PossiblyCompiledSet)
% use last element for next iteration if you call quick_propagation_element_information in a loop
:- block quick_propagation_element_information(-,?,?,?).
quick_propagation_element_information(Set,_El,_,R) :- % print(quick_prop(Set,_El)),nl,
    preferences:preference(use_clpfd_solver,false),
    !, R=Set.
quick_propagation_element_information(avl_set(AVL),Element,WF,NewSet) :- !,
    quick_avl_approximate_size(AVL,Size),
    NewSet=avl_set_with_size(AVL,Size),
    propagate_avl_element_information(Element,AVL,Size,WF).
quick_propagation_element_information(avl_set_with_size(AVL,Size),Element,WF,NewSet) :- !,
    NewSet = avl_set_with_size(AVL,Size),
    propagate_avl_element_information(Element,AVL,Size,WF).
quick_propagation_element_information(closure(P,T,B),Element,WF,NewSet) :- !,
    NewSet = closure(P,T,B),
    element_of_closure(Element,P,T,B,WF).
quick_propagation_element_information(fd_value_list(FDList,GroundList,Type),El,WF,NewSet) :- !,
    NewSet = fd_value_list(FDList,GroundList,Type),
    get_fd_value(Type,El,ElFD),
    in_fd_value_list_wf(GroundList,ElFD,FDList,WF).
quick_propagation_element_information(Set,El,WF,NewSet) :-
    try_get_fd_value_list(Set,Type,FDList,GroundList),!,
    FDList \= [], % if list is empty membership fails
    % print(get_fd_value_list(Type,FDList)),nl,
    NewSet = fd_value_list(FDList,GroundList,Type),
    % clpfd_inlist requires list of integers as second argument
    get_fd_value(Type,El,ElFD),
    % We could apply filter_non_matching_elements here
    in_fd_value_list_wf(GroundList,ElFD,FDList,WF).
%quick_propagation_element_information(Set,El,_) :- print(cannot_prop(Set,El)),nl,fail.
quick_propagation_element_information(Set,_,_,Set).

% -----------------

% infer information about an element of an AVL set
propagate_avl_element_information(Element,AVL,Size,WF) :-  % print(prop_avl(Size)),nl,
  (preferences:preference(use_clpfd_solver,true)
    -> (Size<100 -> %30 which magic constant to use here; use larger value in SMT mode ?
           % print(propagate_avl_element_information_small(Element,AVL,Size)),nl,
          propagate_avl_element_information_small(Element,AVL,WF)
        ; is_avl_fd_index_set(AVL,Type) ->
          %print(avl_simple_type(Type,Size,Element)),
          propagate_avl_element_information_large(Type,Element,AVL),
          (Size < 4000, nonvar(Element), Element = (_,_) % another magic constant
            -> Prio is Size // 60,
               get_wait_flag(Prio,propagate_avl_element_information(Element),WF,LWF),
               propagate_avl_el_large_block(Element,AVL,WF,LWF) % will do precise propagation
            ;  true)
        ; true)
     ; true).
% TO DO: we could call in_nat_range_wf; this way it would also work in non-CLPFD mode

:- block propagate_avl_el_large_block(?,?,?,-).
propagate_avl_el_large_block((A,B),_,_,_) :-
   (ground(A); ground_value(B)), % in first: case we will apply AVL set ; in second case probably no benefit as propagate_avl_element_information_large already propagated first element
   !.
propagate_avl_el_large_block(Element,AVL,WF,_LWF) :-
   %   print(propagating_large_avl(_LWF,Element)),nl,
   % TO DO: maybe look if we should not use clpfd_list, but only upper & lower bound
   propagate_avl_element_information_small(Element,AVL,WF). % will do precise propagation

:- use_module(clpfd_lists,[avl_fd_value_check/4]).
propagate_avl_element_information_small(Element,AVL,WF) :- !,
   avl_fd_value_check(AVL,Element,WF,_FullyChecked).

propagate_avl_element_information_large(Type,El,AVL) :-
    avl_min(AVL,Min), avl_max(AVL,Max),
    % if Size small enough and smaller than Max-Min we call clpfd_inlist on domain
    %print(couple_prj1_in_range(Type,El,Min,Max)),nl,
    couple_prj1_in_range(Type,El,Min,Max).

couple_prj1_in_range(integer,int(El),int(Min),int(Max)) :- clpfd_interface:clpfd_inrange(El,Min,Max).
couple_prj1_in_range(global(GS),fd(El,GS),fd(Min,GS),fd(Max,GS)) :- clpfd_interface:clpfd_inrange(El,Min,Max).
couple_prj1_in_range(couple_prj1(T),(El,_),(Min,_),(Max,_)) :- couple_prj1_in_range(T,El,Min,Max).
couple_prj1_in_range(rec_first_field(Name,T),rec([field(Name,El)|TF]),
                                             rec([field(Name,Min)|TMin]),rec([field(Name,Max)|_])) :-
  (var(TF)
    -> copy_field_names(TMin,TF)  % if Fields not yet instantiated: copy over all fields
     ; true),
  couple_prj1_in_range(T,El,Min,Max).

copy_field_names([],[]).
copy_field_names([field(N,_)|T],[field(N,_)|CT]) :- copy_field_names(T,CT).

% check if the first component of the AVL elements of a type such that we can propagate FD information
is_avl_fd_index_set(node(El,_True,_,_,_),Type) :-
   simple_index_type(El,Type).
simple_index_type((El,_),couple_prj1(T)) :- simple_index_type(El,T).
simple_index_type(int(_),integer).
simple_index_type(fd(_,GS),global(GS)).
simple_index_type(rec(Fields),rec_first_field(Name,T)) :- nonvar(Fields),
   Fields = [field(Name,El)|_],
   simple_index_type(El,T).
%simple_index_type((int(_),_),couple_integer).
%simple_index_type(((int(_),_),_),couple_couple_integer).
%simple_index_type((fd(_,GS),_),couple_global(GS)).


/* avoid instantiating non-normalised with normalised values leading to failure */
:- assert_must_succeed((X=(fd(1,'Name'),fd(2,'Name')), A=node(X,true,0,empty,empty),
  custom_explicit_sets:safe_avl_member(X,A) )).

%safe_avl_member(X,_AVL) :- print(enter_avl_member(X)),nl,fail.
safe_avl_member(X,AVL) :- var(X), !, my_avl_member(X,AVL).
safe_avl_member((X,Y),AVL) :-  !, safe_avl_member_pair(X,Y,AVL).
% TO DO: treat record -> first field = X
safe_avl_member(X,AVL) :- ground_value(X), convert_to_avl_inside_set(X,AX), !, avl_fetch(AX,AVL).
safe_avl_member(X,AVL) :- safe_avl_member_default(X,AVL).
%safe_avl_member(X,_AVL) :- print(exit_avl_member(X)),nl,fail.

% a version of safe_avl_member where the first argument is guaranteed to be ground
% somehow using this seems to slow-down evaluation for vesg_Dec12; Caching ??
%safe_avl_member_ground(X,AVL) :-
%   convert_to_avl_inside_set(X,AX), !, avl_fetch(AX,AVL).
%safe_avl_member_ground((X,Y),AVL) :- !, avl_member_pair_arg1_ground(X,Y,AVL).
%safe_avl_member_ground(X,AVL) :- safe_avl_member_default(X,AVL).

safe_avl_member_pair(X,Y,AVL) :- ground_value(X),!,
   ((ground_value(Y),
     convert_to_avl_inside_set((X,Y),AX))
      -> avl_fetch(AX,AVL)
       ; avl_member_pair_arg1_ground(X,Y,AVL)).
safe_avl_member_pair(X,Y,AVL) :- safe_avl_member_default((X,Y),AVL).

%safe_avl_member_pair_ground(X,Y,AVL) :- convert_to_avl_inside_set((X,Y),AX),!, avl_fetch(AX,AVL).
%safe_avl_member_pair_ground(X,Y,AVL) :- avl_member_pair_arg1_ground(X,Y,AVL).

avl_member_pair_arg1_ground(X,Y,AVL) :- convert_to_avl_inside_set(X,AX), !,
   %statistics(runtime,_),
   get_template(Y,RY,ToUnifyAfter),
   %print(fetch_pair(AX,RY)),nl,
   avl_fetch_pair(AX,AVL,RY),
   %debug:watch(10,custom_explicit_sets:avl_member((AX,RY),AVL)),
   % statistics(runtime,[_,T2]), print(avl_pair_fetch(X,RY,T2)),nl,
   unify_after(ToUnifyAfter). %kernel_objects:equal_object(RY,Y).
avl_member_pair_arg1_ground(X,Y,AVL) :- %print_term_summary(convert_to_avl_inside_set_failed(X,Y,AVL)),nl,
    safe_avl_member_default((X,Y),AVL).

%safe_avl_member_default(PP,X,AVL) :-
%      debug:timer_call(safe_avl_member_default(PP),custom_explicit_sets:safe_avl_member_default1(X,AVL)).
safe_avl_member_default(X,AVL) :- %statistics(runtime,_),
      get_template(X,Template,ToUnifyAfter),
      my_avl_member(Template,AVL), % print_bt_message(avl_member_default(Template)),
     %  statistics(runtime,[_,T2]), print(avl_member(Template,T2)),nl,
      unify_after(ToUnifyAfter). % kernel_objects:equal_object(Template,X)).

unify_after([]).
unify_after([A/B|T]) :- kernel_objects:equal_object(A,B,unify_after),
     unify_after(T).



get_template(A,R,ToUnifyAfter) :-
    (var(A) -> ToUnifyAfter=[A/R]
     ; get_template2(A,R,ToUnifyAfter) -> true
     ; add_internal_error('Could_not_get_template: ',get_template(A,R,_))).

get_template2((A,B),(TA,TB),ToUnifyAfter) :- get_template(A,TA,ToUnifyAfter1), get_template(B,TB,ToUnifyAfter2),
   append(ToUnifyAfter1,ToUnifyAfter2,ToUnifyAfter). % TO DO: use DifferenceLists / DCG
get_template2(int(X),int(X),[]).
get_template2(fd(A,B),fd(A,B),[]).
get_template2([],[],[]).
get_template2(pred_false /* bool_false */,pred_false /* bool_false */,[]).
get_template2(pred_true /* bool_true */,pred_true /* bool_true */,[]).
get_template2([H|T],R,ToUnifyAfter) :-
 ((ground_value(H),ground_value(T))
  -> convert_to_avl_inside_set([H|T],R),ToUnifyAfter=[]
   ;  ToUnifyAfter=[[H|T]/R]).
%   ; R=avl_set(A), ToUnifyAfter=[[H|T]/avl_set(A)]).
get_template2(closure(P,T,B),R,[]) :- ground((P,T,B)),expand_closure_to_avl(P,T,B,R),!.
get_template2(closure(P,T,B),AVL_OR_EMPTY_OR_GS,[closure(P,T,B)/AVL_OR_EMPTY_OR_GS]). % closure could be empty or an infinite global set ?
%get_template2(closure_x(_,_,_),_AVL_OR_EMPTY).
get_template2(avl_set(A),avl_set(NA),[]) :- convert_to_avl_inside_set(avl_set(A),avl_set(NA)). % do we need to normalise here ??
get_template2(string(X),string(X),[]).
get_template2(term(X),term(X),[]).
get_template2(freetype(X),R,[]) :- convert_to_avl_inside_set(freetype(X),R).
get_template2(rec(Fields),rec(TFields),ToUnifyAfter) :- get_fields_template(Fields,TFields,ToUnifyAfter).
get_template2(freeval(ID,Case,Value),freeval(ID,Case,TValue),ToUnifyAfter) :- get_template(Value,TValue,ToUnifyAfter).
get_template2(global_set(GS),R,[]) :- convert_to_avl_inside_set(global_set(GS),R).


get_fields_template(A,R,[rec(A)/rec(R)]) :- var(A),!.
get_fields_template([],[],ToUnifyAfter) :- !, ToUnifyAfter=[].
get_fields_template([field(Name,Val)|T],[field(Name,TVal)|TT],ToUnifyAfter) :- nonvar(Name),!,
   get_template(Val,TVal,ToUnifyAfter1),
   get_fields_template(T,TT,ToUnifyAfter2), append(ToUnifyAfter1,ToUnifyAfter2,ToUnifyAfter).
get_fields_template(A,R,[rec(A)/rec(R)]).


% succeed if we can decide membership of an avl_set on the spot
quick_test_avl_membership(AVL,X,Res) :-
    element_can_be_added_or_removed_to_avl(X),
    convert_to_avl_inside_set(X,AX),
    (avl_fetch(AX,AVL) -> Res=pred_true ; Res=pred_false).

% ---------------------

% a dispatch predicate
my_avl_member(Key,AVL) :-
  (preferences:preference(randomise_enumeration_order,true)
    -> random_avl_member(Key,AVL) ; avl_member_opt(Key,AVL)).
:- use_module(library(random),[random/3]).
random_avl_member(Key,AVL) :- avl_height(AVL,Height), H1 is Height+1, random_avl_member(Key,H1,AVL).
% TO DO: make more intelligent; this is not really a very uniform way of randomly enumerating an AVL set (e.g., Key never occurs between L and R)
random_avl_member(Key, H, node(K,_,_,L,R)) :-
    random(1,H,1), !, H1 is H-1,
   (Key=K ; random_avl_member(Key,H1,L) ; random_avl_member(Key,H1,R)).
random_avl_member(Key, H, node(K,_,_,L,R)) :- random(1,3,1), !, H1 is H-1,
   (random_avl_member(Key,H1,L) ; random_avl_member(Key,H1,R) ; Key=K).
random_avl_member(Key, H, node(K,_,_,L,R)) :- H1 is H-1,
   (random_avl_member(Key,H1,R) ; random_avl_member(Key,H1,L) ; Key=K).

% a variation of avl_member from library(avl) which tries to avoid leaving choice points behind
avl_member_opt(Key, node(K,_,_,L,R)) :-
	(   avl_member_opt(Key, L)
	;   R=empty -> Key = K % avoid trailing choice_point
	;   (Key=K ; avl_member_opt(Key, R))
	).

% ---------------------

 :- use_module(kernel_objects,[check_element_of_wf/3,not_element_of_wf/3]).
element_of_special_closure(interval(LOW,UP),X,WF,_,_,_) :- !,
   %hit_profiler:add_profile_hit(in_nat_range(X,LOW,UP,CondClosure)),
   kernel_objects:in_nat_range_wf(X,int(LOW),int(UP),WF).
element_of_special_closure(member_closure(_ID,_Type,VAL),X,WF,_,_,_) :-
   (VAL=value(_) ; VAL = cartesian_product(b(value(A),_,_),b(value(B),_,_))),!,
   %hit_profiler:add_profile_hit(in_member_closure(X,Par,Typ,Body)),
   (VAL=value(Set) -> kernel_objects:check_element_of_wf(X,Set,WF)
    ; X=(XA,XB),
      kernel_objects:check_element_of_wf(XA,A,WF),
      kernel_objects:check_element_of_wf(XB,B,WF)).
element_of_special_closure(not_member_closure(_ID,_Type,value(Set)),X,WF,_,_,_) :- !,
   %hit_profiler:add_profile_hit(in_not_member_closure(X,Par,Typ,Set)),
    % print(closure_not_member_check(X,Set)),nl,
   kernel_objects:not_element_of_wf(X,Set,WF).
   % we used to have to add enumerator, as not_element_of does not instantiate; e.g. relevant when doing X :: GS - {y}
   % This is no longer required
   % see test 6 (../prob_examples/public_examples/B/FeatureChecks/NotMemberCheck.mch)
   %(ground_value(X) -> true ; (Type=integer, nonvar(Set), Set=avl_set(COMPL_AVL), get_not_member_enum_range(COMPL_AVL,MinFrom,MinTo))
   %      -> enumerate_integer_with_min_range_wf(X,MinFrom,MinTo,WF)
   %   ; b_enumerate:b_tighter_enumerate_single_value(X,Type,not_member_check,WF)).
element_of_special_closure(recursive_special_closure(RId),X,WF,Parameters,PT,CondClosure) :- !,
    add_recursive_parameter(Parameters,PT,X,RId,CondClosure,NewParameters,NewPT,Value),
    element_of_normal_closure(Value,NewParameters,NewPT,CondClosure,WF).
element_of_special_closure(_,X,WF,Parameters,PT,CondClosure) :-
    % none of the special cases above apply after all
    element_of_normal_closure(X,Parameters,PT,CondClosure,WF).

:- block element_of_closure(?,-,?,?,?), element_of_closure(?,?,?,-,?).
% element_of_closure(X,Para,T,Body,_WF): check if X is a member of closure(Para,T,Body)
element_of_closure(X,Parameters,PT,CondClosure,WF) :-
    is_special_closure(Parameters,PT,CondClosure, SpecialClosure),!,
    %print_term_summary(element_of_special_closure(SpecialClosure,X,WF,Parameters,PT,CondClosure)), trace_in_debug_mode,
    element_of_special_closure(SpecialClosure,X,WF,Parameters,PT,CondClosure).
element_of_closure(X,Parameters,PT,CondClosure,WF) :-
    %print_term_summary(element_of_normal_closure(X,Parameters,PT,CondClosure,WF)), trace_in_debug_mode,
    element_of_normal_closure(X,Parameters,PT,CondClosure,WF).
element_of_normal_closure(X,Parameters,PT,CondClosure,WF) :-
   %hit_profiler:add_profile_hit(element_of_closure(X,Parameters,PT,CondClosure)),
                   ~~mnf(lists:same_length(Parameters,ParValues)),
                   ~~mnf(convert_list_into_pairs(ParValues,X)),
                   b_test_closure_wo_enum(Parameters,PT,CondClosure,ParValues,WF).

:- block b_test_closure_wo_enum(?,?,-,?,?).
b_test_closure_wo_enum(Parameters,ParameterTypes,ClosurePred,ParValues,WF) :-
	% ~~mnf(lists:same_length(Parameters,ParValues)),  % not necessary
	store:set_up_localstate(Parameters,ParValues,[],LocalState),
    b_enumerate:b_type_values_in_store(Parameters,ParameterTypes,LocalState),
    %print(test_closure(Parameters)),nl, print_term_summary(b_test_boolean_expression(ClosurePred,LocalState,[],WF)),
    copy_wf_start(WF,InnerWF), % avoid that WF0 actions triggered before we have had a chance to traverse the expression
	b_interpreter:b_test_boolean_expression(ClosurePred,LocalState,[],InnerWF),
	copy_wf_finish(WF,InnerWF).

add_recursive_parameter(Parameters,Types,Value,TId,CondClosure,NewParameters,NewTypes,NewValue) :-
    TId = b(identifier(RId),SetType,_),     % unification replaces: get_texpr_id(TId,RId), get_texpr_type(TId,SetType),
    append(Parameters,[RId],NewParameters),
    append(Types,[SetType],NewTypes),
    %tools_printing:print_term_summary(recursion(Value)),nl,
    NewValue = (Value,closure(Parameters,Types,CondClosure)).

%element_of_closure(int(364),['_zzzz_binary'],[integer],b(member(b(identifier('_zzzz_binary'),integer,[generated]),b(interval(b(value(int(0)),integer,[]),b(value(int(364)),integer,[])),set(integer),[])),pred,[]),wfx(_95929,_1328315,_95389))


% same as above, but without a waitflag
element_of_custom_set(X,CS) :- element_of_custom_set2(CS,X).

element_of_custom_set2(global_set(GS),X) :- !,element_of_global_set(X,GS).
element_of_custom_set2(freetype(ID),_) :- is_maximal_freetype(ID),!. % freetypes are always maximal at the moment
element_of_custom_set2(avl_set(AVL),X) :- !,
     safe_avl_member(X,AVL).
element_of_custom_set2(CS,X) :- init_wait_flags(WF),element_of_custom_set_wf2(CS,X,WF),
	ground_wait_flags(WF).

% ---------------

% function application for closure

% same as check_element_of_wf but does not wait on Y:
% should also work for relation ??

check_element_of_function_closure(X,Y,Parameters,PT,CondClosure,WF) :-
    is_special_closure(Parameters,PT,CondClosure, SpecialClosure),!, % this covers recursive closures
    element_of_special_closure(SpecialClosure,(X,Y),WF,Parameters,PT,CondClosure).
check_element_of_function_closure(X,Y, P,T,ClosureBody, WF) :- % affects test 1312, unless we add s:seq(0..9) before calling num
% a special rule which tries and avoid enumerating solutions to arguments of function application
% usually a function application will either be given all arguments or maybe be used in inverse
    is_converted_lambda_closure(P,T,ClosureBody), %is_converted_non_recursive_lambda_closure(P,T,ClosureBody), % TO DO: also make this work for recursive closures by adding recursive args (see e.g. test 1302)
    is_lambda_closure(P,T,ClosureBody, OtherIDs, OtherTypes, DomainPred, EXPR),
    (debug_mode(on) ->
     print('Apply Fun : '), translate:print_bexpr(DomainPred), print('  |  '), translate:print_bexpr(EXPR),nl,
     get_texpr_info(ClosureBody,I), print(info(I,WF)),nl,
     print_term_summary((X,Y)),nl %,trace
     ; true),
   !,
   % alternative: annotate X,Y as inner variable ?
	b_interpreter:set_up_typed_localstate2(OtherIDs,OtherTypes,ParValues,_TypedVals,[],LocalState,positive),
    convert_list_into_pairs(ParValues,SingleParValue),
    kernel_objects:equal_object_wf(X,SingleParValue,check_element_of_function_closure,WF),
    (is_truth(DomainPred) -> true %, print(truth),nl,nl
      ; init_wait_flags(InnerWF),
        %copy_wf01e_wait_flags(WF,InnerWF), % we could delay copying WF0 until after test_boolean_expression of DomainPred ?
        b_interpreter:b_test_boolean_expression(DomainPred,LocalState,[],InnerWF),
	    ground_wait_flag0(InnerWF), %ground_det_wait_flag(InnerWF),
	    %get_last_wait_flag(check_element_of_function_closure(OtherIDs),WF,LastWF),
	    get_wait_flag(2000000,check_element_of_function_closure(OtherIDs),WF,LastWF), % we could also multiply priorities ?
	    ground_value_check(X,GrX), (var(Y) -> ground_value_check(Y,GrY) ; true),
	    block_copy_waitflag_store(InnerWF,WF,GrX,GrY,LastWF)
    ),
    b_interpreter:b_compute_expression(EXPR,LocalState,[],Y,WF).
check_element_of_function_closure(X,Y, P,T,ClosureBody, WF) :-
   element_of_normal_closure((X,Y),P,T,ClosureBody,WF).

:- block block_copy_waitflag_store(?,?,-,-,-).
block_copy_waitflag_store(InnerWF,WF,_,_,_) :- copy_waitflag_store(InnerWF,WF).

/* -------------- */
/* NOT_ELEMENT_OF */
/* -------------- */

:- use_module(kernel_objects,[not_element_of_global_set/2]).

not_element_of_custom_set(X,CS) :- init_wait_flags(WF),
   not_element_of_custom_set_wf(X,CS,WF),
   ground_wait_flags(WF).
not_element_of_custom_set_wf(X,CS,WF) :-
   not_element_of_custom_set_wf2(CS,X,WF).

not_element_of_custom_set_wf2(global_set(GS),X,_WF) :- not_element_of_global_set(X,GS).
not_element_of_custom_set_wf2(freetype(_),_,_) :- !,fail. % TO DO: what if we have List(1..3) ? can that occur ??
not_element_of_custom_set_wf2(avl_set(node(Y,_,_,empty,empty)),X,WF) :- !,
  %  X /: {Y}   <=>  X /= Y
  %% print(not_eq(X,Y)),nl,when(nonvar(X),(print(neq(X,Y)),nl)),
   kernel_objects:not_equal_object_wf(X,Y,WF). % improve if X is ground
not_element_of_custom_set_wf2(avl_set(AVL),X,_WF) :- !,
         ground_value_check(X,GrX),
         propagate_avl_not_element_information(X,GrX,AVL),
         not_element_of_avl_set_block(GrX,X,AVL).
not_element_of_custom_set_wf2(closure(Parameters,PT,Cond),X,WF) :-
        closure_not_member(X,Parameters,PT,Cond,WF).
%not_element_of_custom_set_wf2(closure_x(Parameters,PT,Cond,Expansion),X,WF) :-
%         ((ground(Expansion),ground(X))
%            -> \+ member(X,Expansion)
%            ;  closure_not_member(X,Parameters,PT,Cond,WF)
%          ).

:- block not_element_of_avl_set_block(-,?,?).
not_element_of_avl_set_block(_,X,AVL) :-
        convert_to_avl_inside_set(X,CX), %print(avl_fetch(CX)),nl,
        \+ avl_fetch(CX,AVL). %% IMPROVE ??

propagate_avl_not_element_information(_,GrEl,_) :- nonvar(GrEl),!.
propagate_avl_not_element_information(Element,_,AVL) :- preferences:preference(use_clpfd_solver,true),
      is_avl_simple_set(AVL,Type), % \+ground(Element) ,
      (Type=integer -> avl_height_less_than(AVL,6) % 16-31 elements - was: avl_size(AVL,Size), Size<20
       ; true),
      !,
      propagate_avl_not_element_information3(Type,Element,AVL).
propagate_avl_not_element_information(_Element,_,AVL) :-
      quick_definitely_maximal_set_avl(AVL),
      !, % we require something not to be an element of the full set; impossible
      %print(not_element_of_full_set),nl,
% to do: check if all but one element is in set
      fail.
propagate_avl_not_element_information(_,_,_).


% try and compute a small finite cardinality; fail if not possible
try_get_finite_max_card_from_value(pred_true,2).
try_get_finite_max_card_from_value(pred_false,2).
try_get_finite_max_card_from_value(fd(_,Type),Card) :- b_global_sets:b_fd_card(Type,Card).
try_get_finite_max_card_from_value((A,B),Card) :-
    try_get_finite_max_card_from_value(A,CA),
    try_get_finite_max_card_from_value(B,CB),
    Card is CA*CB,
    Card < 20000.
% TO DO: add records
try_get_finite_max_card_from_value(avl_set(node(El,_True,_,_,_)),Card) :-
    try_get_finite_max_card_from_value(El,CEl),
    CEl < 16,
    safe_pow2(CEl,Card).


propagate_avl_not_element_information3(integer,int(El),AVL) :-
     avl_domain(AVL,R),project_avl_domain_on_fd(R,FDList),
   % print(posting_not_inlist(integer,El,FDList)),nl,
    clpfd_interface:clpfd_not_inlist(El,FDList).
propagate_avl_not_element_information3(global(GS),FD,AVL) :-
     (var(FD) -> FD = fd(El,GS), b_global_sets:global_type(FD,GS) % set up the constraint; maybe we can detect inconsistency straightaway below
      ; FD = fd(El,GS)),
     avl_domain(AVL,R),project_avl_domain_on_fd(R,FDList), % maybe we can compute directly the complement ?
     clpfd_interface:clpfd_not_inlist(El,FDList).

:- use_module(library(lists),[same_length/2]).

:- block closure_not_member(?,-,?,?,?).
%, closure_not_member(-,?,?,?,?).   /* El is unlikely to be instantiated by not_element_of test , but test 6 requires commenting out block declaration */

closure_not_member(X,Parameters,Types,Body,WF) :-
    is_special_closure(Parameters,Types,Body,SpecialClosure),!,
    not_element_of_special_closure(SpecialClosure,X,WF,Parameters,Types,Body).
closure_not_member(El,Parameters,PT,Cond,WF) :-
    normal_closure_not_member(El,Parameters,PT,Cond,WF).

not_element_of_special_closure(interval(LOW,UP),X,_WF,_Parameters,_Types,_Body) :-
    !,kernel_objects:not_in_nat_range(X,int(LOW),int(UP)).
not_element_of_special_closure(member_closure(_ID,_Type,VAL),X,WF,_Parameters,_Types,_Body) :-
    ( VAL = value(_)
    ; VAL = cartesian_product(b(value(A),_,_),b(value(B),_,_))),!,
    %hit_profiler:add_profile_hit(member(X,Par,Typ,Body)),
    ( VAL=value(Set) -> kernel_objects:not_element_of_wf(X,Set,WF)
    ; kernel_objects:not_is_cartesian_pair(X,A,B,WF)).
not_element_of_special_closure(not_member_closure(_ID,_Type,value(Set)),X,WF,_Parameters,_Types,_Body) :-
    !,kernel_objects:check_element_of_wf(X,Set,WF).
not_element_of_special_closure(recursive_special_closure(RId),X,WF,Parameters,Types,Body) :-
    !,add_recursive_parameter(Parameters,Types,X,RId,Body,NewParameters,NewPT,Value),
    normal_closure_not_member(Value,NewParameters,NewPT,Body,WF).

not_element_of_special_closure(SC,_X,_WF,Parameters,Types,Body) :-
    SC \= interval(_,_),
    SC \= not_member_closure(_,_,_),
    is_definitely_maximal_closure(Parameters,Types,Body),
    !,
    fail.
not_element_of_special_closure(_,X,WF,Parameters,Types,Body) :-
    % falling back to normal test
    normal_closure_not_member(X,Parameters,Types,Body,WF).


normal_closure_not_member(El,Parameters,PT,Cond,WF) :-
   %hit_profiler:add_profile_hit(closure_not_member(El,Parameters,PT,Cond,WF)),
       lists:same_length(Parameters,ParValues),
       convert_list_into_pairs(ParValues,El),
                   % print(not_test_closure(El,Cond)),nl,
       b_not_test_closure_wf(Parameters,PT,Cond,ParValues,WF).




/* -------------------------- */
/* VARIOUS CLOSURE PREDICATES */
/* -------------------------- */


:- use_module(tools,[convert_list_into_pairs/2]).
:- use_module(b_interpreter,[b_test_boolean_expression/4, b_not_test_boolean_expression/4]).
:- use_module(b_enumerate).

  :- assert_pre(custom_explicit_sets:expand_closure_to_list(_,_,ClosureBody,_Result,_Done,_,_WF),
                (nonvar(ClosureBody),
                 bsyntaxtree:check_if_typed_predicate(ClosureBody))).
:- assert_post(custom_explicit_sets:expand_closure_to_list(_,_,_,Result,_Done,_,_WF),
                 b_interpreter:value_type(Result)).

:- block expand_interval_closure_to_avl(-,?,?), expand_interval_closure_to_avl(?,-,?).
expand_interval_closure_to_avl(Low,Up,Result) :-
  % print(expand_interval_to_avl(Low,Up)),nl,
  Delta is Up-Low,
  (Delta>9999 -> perfmessage(expanding_interval(Low,Up)) ; true),
  construct_interval_ord_list(Low,Up,OL),
  ord_list_to_avlset_direct(OL,ARes,expand_interval),
  equal_object(ARes,Result,expand_interval_closure_to_avl).
construct_interval_ord_list(Low,Up,Res) :-
  (Low>Up -> Res = []
    ;  Res = [int(Low)-true|T], L1 is Low+1, construct_interval_ord_list(L1,Up,T)
  ).

:- block expand_interval_closure_to_list(-,?,?,?), expand_interval_closure_to_list(?,-,?,?).
expand_interval_closure_to_list(Low,Up,Result,Done) :-   %print(expand_interval_to_list(Low,Up)),nl,
  construct_interval_list(Low,Up,OL),  %print(done_epxand_interval(Low,Up)),nl,
  equal_object(OL,Result,expand_interval_closure_to_list),
  Done=true.
construct_interval_list(Low,Up,Res) :-
  (Low>Up -> Res = []
    ;  Res = [int(Low)|T], L1 is Low+1, construct_interval_list(L1,Up,T)
  ).

expand_closure_to_list([X],[integer],Body,Result,Done,_,_) :-
    is_interval_closure_body(Body,X,Low,Up),!,
    % print(expanding_interval_closure_to_list(Low,Up)),nl,
    expand_interval_closure_to_list(Low,Up,Result,Done).
expand_closure_to_list([X],[integer],Body,Result,Done,_,_) :-
    is_not_member_value_closure(closure([X],[integer],Body),integer,MS1),
    nonvar(MS1), MS1=avl_set(COMPL_AVL),
    check_valid_avl(COMPL_AVL,expand_closure_to_list([X])),
    !,
%    print(expanding_not_member_value_closure_to_list(COMPL_AVL)),nl,
    expand_integer_not_member_closure_to_list([X],[integer],Body,COMPL_AVL,Result,Done)
    . %,print(result(Result)),nl.
expand_closure_to_list(Par,Types,Body,Result,Done,Source,WF) :- %print(exp_to_list),nl,
    expand_normal_closure(Par,Types,Body,CResult,CDone,expand_closure_to_list(Source)),
    %% print_term_summary(expanded_normal_closure(Par,Types,CResult,CDone)),nl,
    expand_if_avl(CResult,Result,CDone,Done),
    (WF==no_wf_available -> true ;
       % print(lazy_check(Result,CDone,Par)),nl, translate:print_bexpr(Body),nl,
       lazy_check_elements(Result,CDone, Par,Types,Body,WF)).
   %% print_term_summary(expanded(CResult,Result,CDone,Done)).

% Note: does slow down test 1306
:- block lazy_check_elements(-,-, ?,?,?,?).
lazy_check_elements(Result,CDone, _Par,_Types,_Body,_WF) :- (var(Result) ; nonvar(CDone)),!.
lazy_check_elements([H|T],CDone, Par,Types,Body,WF) :- !,
    %nl,print(check_el(H,Par)),nl,
    element_of_closure(H,Par,Types,Body,WF),
    lazy_check_elements(T,CDone, Par,Types,Body,WF).
lazy_check_elements(avl_set(A),_CDone, Par,Types,Body,WF) :- !,
    avl_max(A,X),
    %nl,print(check_el_avl_max(X,Par)),nl,
    element_of_closure(X,Par,Types,Body,WF).
    % TO DO: also check avl_min or even all elements ?
lazy_check_elements(_,_,_,_,_,_).

check_valid_avl(AVL,Origin) :-
    (nonvar(AVL) -> true
       ; add_internal_error('Var avl_set: ', check_valid_avl(AVL,Origin)),fail).

:- block expand_if_avl(?,?,-,?).
expand_if_avl(avl_set(S),Result,_,Done) :- !, % we could transmit a flag to expand_normal_closure so that transform_result_into_set does not expand to avl
    expand_custom_set_to_list2(avl_set(S),Result,Done,expand_if_avl).
expand_if_avl(Res,Result,_,Done) :- check_list(Res,expand_if_avl),
    equal_object(Res,Result), Done=true.

check_list(Res,_) :- nonvar(Res), is_list(Res),!.
check_list(Res,Src) :- add_error(Src,'Could not expand to list: ',Res).
is_list([]). is_list([_|_]).

expand_closure_to_avl_or_list([X],[integer],Body,Result,_CheckTimeouts) :-
    is_interval_closure_body(Body,X,Low,Up),!,
    %print(expanding_interval_closure_to_avl(Low,Up)),nl,
    expand_interval_closure_to_avl(Low,Up,Result).
%expand_closure_to_avl_or_list(P,T,Body,Result) :- is_member_closure(P,T,Body,TS,Set),
%    print(expand_member_closure(P,T,Body,TS,Set)),nl,fail.
expand_closure_to_avl_or_list([X],[integer],Body,Result,_CheckTimeouts) :-
    is_not_member_value_closure(closure([X],[integer],Body),integer,MS1),
    nonvar(MS1), MS1=avl_set(COMPL_AVL),
    check_valid_avl(COMPL_AVL,expand_closure_to_avl_or_list([X])),
    !,
    %print(expanding_not_member_value_closure_to_avl_or_list(COMPL_AVL)),nl,
    expand_integer_not_member_closure_to_list([X],[integer],Body,COMPL_AVL,Result,_Done).
expand_closure_to_avl_or_list(Par,Types,Body,Result,CheckTimeouts) :-
    expand_normal_closure(Par,Types,Body,CResult,_Done,CheckTimeouts), % print(expanded(CResult)),nl, %
    kernel_objects:equal_object(Result,CResult,expand_closure_to_avl_or_list). % may convert to AVL, should we wait for _Done?


expand_closure_to_avl([X],[integer],Body,Result) :-
    is_interval_closure_body(Body,X,Low,Up),!,
    %print(expanding_interval_closure_to_avl(Low,Up)),nl,
    expand_interval_closure_to_avl(Low,Up,Result).
expand_closure_to_avl([X],[integer],Body,Result) :-
    is_not_member_value_closure(closure([X],[integer],Body),integer,MS1),
    nonvar(MS1), MS1=avl_set(COMPL_AVL),
    check_valid_avl(COMPL_AVL,expand_closure_to_avl([X])),
    !,
    % print(expand_integer_not_member_closure_to_avl(COMPL_AVL)),nl,
    expand_integer_not_member_closure_to_avl([X],[integer],Body,COMPL_AVL,Result).
expand_closure_to_avl(Par,Types,Body,Result) :-
   expand_normal_closure(Par,Types,Body,S,_Done,check(expand_closure_to_avl)),
   (ground_value(S) -> convert_to_avl_inside_set(S,R),equal_object(R,Result,expand_closure_to_avl)
    ; print(cannot_convert_closure_value_to_avl(closure(Par,Types,Body))),nl,fail).

expand_integer_not_member_closure_to_avl(Parameters,ParameterTypes,ClosureBody,COMPL_AVL,Result) :-
    expand_integer_not_member_closure_to_list(Parameters,ParameterTypes,ClosureBody,COMPL_AVL,LResult,_Done),
    ord_list_to_avlset_direct(LResult,Result,expand_integer_not_member_closure_to_avl).
expand_integer_not_member_closure_to_list(Parameters,ParameterTypes,ClosureBody,COMPL_AVL,Result,Done) :-
   get_not_member_enum_range(COMPL_AVL,From,TO),
   add_inf_closure_warning(expand_integer_not_member_closure_to_list,Parameters,ParameterTypes,ClosureBody),
   print(not_member_from_to(From,TO)),nl, %%
   generate_not_member_list(From,TO,COMPL_AVL,Result,Done).

generate_not_member_list(From,TO,_,Result,Done) :- From > TO, !, Result = [],Done=true.
generate_not_member_list(From,TO,COMPL_AVL,Result,Done) :- F1 is From+1,
   (avl_fetch(int(From),COMPL_AVL) -> Result = TR ; Result = [int(From)|TR]),
   generate_not_member_list(F1,TO,COMPL_AVL,TR,Done).

get_not_member_enum_range(COMPL_AVL,From,TO) :-
   min_of_explicit_set(avl_set(COMPL_AVL),int(Min)),
   (preference(minint,MININT)->true),
   (Min>MININT -> From = MININT ; From is Min-1),
   max_of_explicit_set(avl_set(COMPL_AVL),int(Max)),
   (preference(maxint,MAXINT)->true),
   (Max<MAXINT -> TO = MAXINT ; TO is Max+1).

% possible values for CheckTimeouts: check, check_no_inf, no_check, ...
expand_normal_closure(Parameters,ParameterTypes,ClosureBody,Result,Done,CheckTimeouts) :-
   ((CheckTimeouts\=no_check, CheckTimeouts \= check_no_inf,
      %dont_expand_this_closure(Parameters,ParameterTypes,ClosureBody)) % comment in if you want to see more warnings
      is_infinite_explicit_set(closure(Parameters,ParameterTypes,ClosureBody)))
     -> add_inf_closure_warning(expand_normal_closure(CheckTimeouts),Parameters,ParameterTypes,ClosureBody)
      ; true),
     expand_normal_closure_memo(CheckTimeouts,Parameters,ParameterTypes,ClosureBody,Result,Done).
     % was expand_normal_closure2

add_inf_closure_warning(Source,Parameters,ParameterTypes,ClosureBody) :-
     preference(warn_when_expanding_infinite_closures,FROM),
     preference(maxint,MAXINT), MAXINT>FROM,!,
     add_closure_warning(Source,Parameters,ParameterTypes,ClosureBody,'### WARNING: expanding infinite comprehension set: ').
add_inf_closure_warning(_,_,_,_).
add_closure_warning(Source,Parameters,_ParameterTypes,_ClosureBody,_MSG) :-
        preference(provide_trace_information,false),preference(strict_raise_warnings,false),!,
        format('### TIME-OUT raised during closure expansion (~w,~w).~n### set TRACE_INFO preference to TRUE for more details.~n',[Parameters,Source]).
add_closure_warning(Source,Parameters,ParameterTypes,ClosureBody,MSG) :-
        preferences:temporary_set_preference(expand_avl_upto,5,CHNG),
        call_cleanup(translate:translate_bvalue(closure(Parameters,ParameterTypes,ClosureBody),CT),
                      preferences:reset_temporary_preference(expand_avl_upto,CHNG)),
        bsyntaxtree:get_texpr_info(ClosureBody,Infos),
        add_warning(Source,MSG,CT,Infos), debug_print(19,'! infos: '), debug_println(Infos). %,trace.


:- use_module(library(terms),[term_hash/3]).

:- dynamic stored_expansion/5.
% a version of closure expansion which memoizes its results; stored_expansion needs to be cleared when new machine loaded
expand_normal_closure_memo(CHECK,Parameters,ParameterTypes,ClosureBody,FullResult,Done) :-
   preferences:preference(use_closure_expansion_memoization,false),!,
   %% print(expand(Parameters,ClosureBody)),nl, %%
   expand_normal_closure2(CHECK,Parameters,ParameterTypes,ClosureBody,FullResult,Done).
expand_normal_closure_memo(CHECK,Parameters,ParameterTypes,ClosureBody,FullResult,Done) :-
   % maybe we should only memo when ClosureWaitVars are ground ?
    term_hash(closure(Parameters,ParameterTypes,ClosureBody),
               [range(smallint),algorithm(sdbm), depth(infinite),if_var(ignore)],Hash),
    %hashing:my_term_hash(closure(Parameters,ParameterTypes,ClosureBody),Hash),
    %inc(Hash), %
    % idea: maybe store expansion only on second hit ?
    (stored_expansion(Hash,Parameters,ParameterTypes,ClosureBody,StoredResult)
       -> %print_term_summary(reusing_expansion(Hash,Parameters,ParameterTypes,ClosureBody,StoredResult)),nl,
          UPV=StoredResult, %state_packing:unpack_value(StoredResult,UPV),
          FullResult = UPV, Done=true
       ;  %statistics(runtime,[T1,_]), %%
          expand_normal_closure2(CHECK,Parameters,ParameterTypes,ClosureBody,FullResult,Done),
          %statistics(runtime,[T2,_]), Time is T2-T1, store_time(Hash,Time),
          ((Done==true/* ,T2-T1>0*/ ) -> PackedValue=FullResult, %state_packing:pack_value(FullResult,PackedValue),
                         assert(stored_expansion(Hash,Parameters,ParameterTypes,ClosureBody,PackedValue)) ; true)
    ).

% utilities to profile expansions
:- public inc/1, store_time/2.
:- dynamic hash_count/2.
inc(Hash) :- (retract(hash_count(Hash,Nr)) -> N1 is Nr+1 ; N1 = 1), assert(hash_count(Hash,N1)).
:- dynamic hash_time/2.
store_time(Hash,Time) :- retractall(hash_time(Hash,_)), assert(hash_time(Hash,Time)).

:- public print_memo/0.
% custom_explicit_sets:print_memo.
print_memo :- stored_expansion(Hash,Parameters,ParameterTypes,ClosureBody,PackedValue),
  hash_count(Hash,Count),  print(Count), print(' : '),
  hash_time(Hash,Time), print(Time),print(' --> '), translate:print_bvalue(closure(Parameters,ParameterTypes,ClosureBody)),
  nl, print('     :  '),translate:print_bvalue(PackedValue),nl,fail.
print_memo :- nl.
:- public reset_memo_table/0.
reset_memo_table :- retractall(hash_count(_,_)), retractall(hash_time(_,_)), retractall(stored_expansion(_,_,_,_,_)).

%spycl([iti0|_]).

expand_normal_closure2(_CHECK,Parameters,ParameterTypes,ClosureBody,FullResult,Done) :-
 % TO DO: add more symbolic member closures who have expression computation code
   is_closure1_value_closure(Parameters,ParameterTypes,ClosureBody,VAL),!,
   %print_term_summary(closure1_expand(VAL)),nl,
   bsets_clp:relational_trans_closure(VAL,FullResult),
   ground_value_check(FullResult,FRGr),
   when(nonvar(FRGr),Done=true).
   %print(compute(closure1(VAL))),nl,
   %when(ground(VAL), (bsets_clp:relational_trans_closure(VAL,Result),
    %                  equal_object(Result,FullResult),Done=true)).
expand_normal_closure2(CHECK,Parameters,ParameterTypes,ClosureBody,FullResult,Done) :-
   % special treatment for lambda closures: Advantage: we don't have to wait for variables in EXPR body of closure
   %  Disadvantage: EXPR only gets evaluated after a solution has been found for args: can mean repeated computations !
   % (cf pas_as_env_inv_cv_sui, negated version of !(cv_i).(cv_i : t_cv_pas => closure(%cv_o2.((...|>> {cv_i} : t_cv_pas <-> t_cv_pas) ASSERTION
   % Advantage: it can solve constraints such as f = %x.(x:1..10|x+y) & f(5)=1005 (finding y without enumeration)
   \+ preferences:preference(use_smt_mode,false),
   is_lambda_closure(Parameters,ParameterTypes,ClosureBody, OtherIDs,OtherTypes, DomainPred, EXPR),
   \+ ground_bexpr(EXPR), % if EXPR is ground, there is nothing to be gained by special treatment here
   !,
   % print(lambda(DomainPred,EXPR)),nl,
   bexpr_variables(DomainPred,ClosureWaitVars),
  % statistics(runtime,[Start,_]),
  % print(expanding_lambda_closure(ClosureWaitVars,Start)),nl,
   (CHECK=no_check -> TIMEOUTCODE = true ;
     TIMEOUTCODE = add_closure_warning(CHECK,Parameters,ParameterTypes,ClosureBody,'TIME-OUT occurred while ProB was expanding: ')),
    (CHECK=check_no_inf -> VIRTUALTIMEOUTCODE=true ; VIRTUALTIMEOUTCODE=TIMEOUTCODE),
    delay_setof_check( ParTuple,
          (custom_explicit_sets:b_test_closure(OtherIDs,OtherTypes,DomainPred,OtherValues,all_solutions),
            ~~mnf(convert_list_into_pairs(OtherValues,ParTuple))
            % TO DO: compile EXPR when we start expanding the closure: to avoid repeated re-computation of expressions for every instance
            ),
          Result, ClosureWaitVars, __Done,
          TIMEOUTCODE,VIRTUALTIMEOUTCODE),
  % statistics(runtime,[ResT,_]), T1 is ResT-Start, print(result_time(T1)),nl,
    init_wait_flags(WF), % TO DO: pass outer WF store ?!
    evaluate_result_expr(Result,EXPR,OtherIDs,EvResult,EvDone,WF),
    when(nonvar(EvDone),(%print(finished(Parameters)),nl, print_term_summary(eq(EvResult,FullResult)),nl,
                         kernel_objects:equal_object(EvResult,FullResult,expand_normal_closure2),Done=true)).
expand_normal_closure2(no_check,Parameters,ParameterTypes,ClosureBody,Result,Done) :- !,
    expand_normal_closure_direct(Parameters,ParameterTypes,ClosureBody,Result,Done).
expand_normal_closure2(CHECK,Parameters,ParameterTypes,ClosureBody,Result,Done) :-
    bexpr_variables(ClosureBody,ClosureWaitVars),
    TIMEOUTCODE = add_closure_warning(CHECK,Parameters,ParameterTypes,ClosureBody,'TIME-OUT occurred while ProB was expanding: '),
    (CHECK=check_no_inf -> VIRTUALTIMEOUTCODE=true ; VIRTUALTIMEOUTCODE=TIMEOUTCODE),
    delay_setof_check( ParTuple,
          custom_explicit_sets:test_closure_and_convert(Parameters,ParameterTypes,ClosureBody, ParTuple),
          Result, ClosureWaitVars, Done, TIMEOUTCODE, VIRTUALTIMEOUTCODE).

expand_normal_closure_direct(Parameters,ParameterTypes,ClosureBody,Result,Done) :-
    bexpr_variables(ClosureBody,ClosureWaitVars),
    delay_setof( ParTuple,
     % TO DO: refresh waitflag in out waitflag store to let all pending code run to completion and avoid spurious WD errors ?
          custom_explicit_sets:test_closure_and_convert(Parameters,ParameterTypes,ClosureBody, ParTuple),
          Result,  ClosureWaitVars, Done).



:- block evaluate_result_expr(-,?,?,?,?,?).
evaluate_result_expr(avl_set(AVL),EXPR,OtherIDs,Res,Done,WF) :-
   avl_domain(AVL,R),
   evaluate_result_expr(R,EXPR,OtherIDs,Res,Done,WF).
evaluate_result_expr([],_EXPR,_OtherIDs,[],Done,WF) :-  %translate:print_bexpr(_EXPR),nl,print(done_evaluate_result_expr(_OtherIDs)),nl,
   ground_wait_flags(WF),
   Done=true.
evaluate_result_expr([ParTuple|T],EXPR,OtherIDs,[FullTuple|ET],Done,WF) :-
   % print(evaluate(ParTuple)),nl,
	%~~mnf(lists:same_length(OtherIDs,ParValues)), % not necessary
	~~pp_mnf(store:set_up_localstate(OtherIDs,ParValues,[],LocalState)),
	~~mnf(convert_list_into_pairs(ParValues,ParTuple)), % bind values in ParTuple to LocalState
	% print(setup_localstate(LocalState)),nl,
   b_interpreter:b_compute_expression(EXPR,LocalState,[],EXPRVALUE,WF),
  % print(expr_value(EXPRVALUE)),nl,
   append(ParValues,[EXPRVALUE],FullValues),
   ~~mnf(convert_list_into_pairs(FullValues,FullTuple)),
   %print(full_tuple(FullTuple)),nl,
   evaluate_result_expr(T,EXPR,OtherIDs,ET,Done,WF).

%:- use_module(library(lists),[prefix_length/3, suffix_length/3]).
% test a closure and convert into pairs; assume we want all solutions
test_closure_and_convert(Parameters,ParameterTypes,b(exists(EParAndTypes,ClosureBody),pred,Info), ParTuple) :-
 % Motivation: enumerating Parameters can be quite inefficient if for example we have something like {x|#y.(y:SmallSet & x=f(y))}
           % maybe only do this in special circumstances ?  domain of EPar much smaller than of Parameters, exists constructed by ran_symbolic ?
           (Parameters == ['_was_lambda_result_']  % at the moment only accept this ; here we are quite sure that we gain by this optimisation
            ; member(dom_range_generated_exists,Info) % parameters were originally from a set comprehension
            ; ClosureBody = b(member(_,_),_,_) % we have a simple projection closure %  TO DO: maybe support other ones as well
            ; %print(check_card(Parameters)),nl,
              basic_type_list_cardinality(ParameterTypes,Card), %print(card(Card)),nl,
              (Card=inf -> true ; Card>10000)
           ),
           b_interpreter:split_names_and_types(EParAndTypes,EPar,ETypes),
           !,
              % print(' Lifting existential quantifier: '), print(EPar),nl, %translate:print_bexpr(ClosureBody),nl,
            % append Parameters at end; in case we have a lambda function
           append(EPar,Parameters,FullPar), length(Parameters,NrParas),
           append(ETypes,ParameterTypes,FullTypes),
           length(EPar,NrExistsParas),
           length(IrrelevantParas,NrExistsParas), length(Suffix,NrParas),
           append(IrrelevantParas,Suffix,FullParList),
             %(EPar=['LV_ma',speedLimitAreasInMA] -> print(par(Parameters)),nl,translate:print_bexpr(ClosureBody),nl
             %, trace, is_lambda_closure(FullPar,FullTypes,ClosureBody, OtherIDs,OtherTypes, DomainPred, EXPR)
             % ; true),
             % print(fullpar(FullPar)),nl,
           custom_explicit_sets:b_test_closure(FullPar,FullTypes,ClosureBody, FullParList,all_solutions),
           convert_list_into_pairs(Suffix,ParTuple). % , print(converted(Prefix,ParTuple)),nl.
test_closure_and_convert(Parameters,ParameterTypes,ClosureBody, ParTuple) :-
           %print(test),nl, translate:print_bexpr(ClosureBody),nl,
           length(Parameters,Len), length(ParValues,Len),
           b_test_closure(Parameters,ParameterTypes,ClosureBody,ParValues,all_solutions),
           convert_list_into_pairs(ParValues,ParTuple). % ,print(solution(ParTuple)),nl,nl.

% compute cardinality of a list of basic types
basic_type_list_cardinality([],1).
basic_type_list_cardinality([BasicType|T],Res) :-
   basic_type_list_cardinality(T,TCard),
   (TCard=inf -> Res=inf
    ; kernel_objects:max_cardinality(BasicType,Card),
      kernel_objects:safe_mul(Card,TCard,Res)
   ).

% for lambda closures we can set up a second waitflag for the expression and only ground it when body enumeration finished
% idea is to avoid perturbation of constraint solving of main closure predicate by lambda expression, see test 1737
% something like %(x,y).(x:1..200 & y:1..100 & y+x<259 & y*x>10|(y+x*x+y) mod 100) is faster
% this is slower : %(x,y).(x:1..200 & y:1..100 |(y+x*x+y))
% currently this slows down test 1336
:- block b_test_closure(?,?,-,?,?).
b_test_closure(Parameters,ParameterTypes,ClosureBody, FullParValues, NegationContext) :-
     \+ preferences:preference(use_smt_mode,false), % TO DO: enable in normal mode when performance of 1336 fixed
     % print(test_closure(Parameters,FullParValues)),nl,
     is_lambda_closure(Parameters,ParameterTypes,ClosureBody, OtherIDs,OtherTypes, DomainPred, EXPR),
     % TO DO: detect not only equalities at end, but any equality which is irrelevant for the rest
     % nl,print(lambda_closure(OtherIDs)),nl, translate:print_bexpr(EXPR),nl,
     append(ParValues,[LambdaResult],FullParValues),
     !,
	b_interpreter:set_up_typed_localstate2(OtherIDs,OtherTypes,ParValues,TypedVals,[],LocalState,NegationContext),
	init_wait_flags(WF),
	b_interpreter:b_test_boolean_expression(DomainPred,LocalState,[],WF),
	%print('PRED: '),translate:print_bexpr(ClosureBody),nl,
	(project_away_useless_enumeration_values(DomainPred,TypedVals,EnumVals) -> true ; EnumVals=TypedVals),
    b_enumerate:b_tighter_enumerate_values(EnumVals,WF),
    init_wait_flags(WF2),
    b_compiler:b_optimize(EXPR,[],LocalState,[],CEXPR,WF), % already pre-compile lookup, without constraint processing; is not sufficient for test 1336
    %print(compiled), translate:print_bexpr(CEXPR),nl,
    %ground_wait_flag0(WF),
    ground_wait_flags(WF),
	b_interpreter:b_compute_expression(CEXPR,LocalState,[],LambdaResult,WF2),
    ground_wait_flags(WF2).
b_test_closure(Parameters,ParameterTypes,Closure,ParValues,NegationContext) :-
    %  tools:print_bt_message(b_test_closure_testing_closure(Parameters,ParValues)), %%
	% ~~mnf(lists:same_length(Parameters,ParValues)),  % not necessary
	%~~pp_mnf(store:set_up_localstate(Parameters,ParValues,[],LocalState)),
	b_interpreter:set_up_typed_localstate2(Parameters,ParameterTypes,ParValues,TypedVals,[],LocalState,NegationContext),
     %  print_message(b_interpreter:b_test_boolean_expression(Closure,LocalState,[],WF)),
	init_wait_flags(WF),
	% print(init_wf(WF)),nl,
	%external_functions:observe_parameters(Parameters,LocalState), %%
	~~pp_cll(b_interpreter:b_test_boolean_expression(Closure,LocalState,[],WF)),
	% tools:print_bt_message(tested_bool_expr), translate:print_bexpr(Closure),nl,
	% TO DO: detect useless Values to enumerate; e.g., SLOT-PERFORMANCE2 : if Closure is member predicate for AVL value which already binds Value
	(project_away_useless_enumeration_values(Closure,TypedVals,EnumVals) -> true ; EnumVals=TypedVals),
    b_enumerate:b_tighter_enumerate_values(EnumVals,WF),
        % tools:print_bt_message(grounding_closure_constraint_prop_wait_flags(Parameters,WF)), ground_wait_flag0(WF),portray_waitflags(WF), %%
    ground_wait_flags(WF). %% Do not generate spurious error messages
%% error if it persists will be a pending co-routine ?!
     % TO DO: use create_inner_wait_flags when using test_closure and then not ground_enumeration_finished; to avoid spurious error messages inside

% TO DO: try and generalize this treatment (applicable for SLOT-PERFORMANCE2 at the moment)
% i.e. also treat (x,y):AVL & OTHERPRED
project_away_useless_enumeration_values(b(member(A,b(value(V),_,_)),_,_),TypedVals,EnumVals) :-
   nonvar(V), V=avl_set(_),
   %print(projecting_away(TypedVals)),nl,
   project(A,TypedVals,EnumVals).

project(b(couple(A,B),_,_),TypedVals,EnumVals) :- !,
   project(A,TypedVals,TV1),
   project(B,TV1,EnumVals).
project(b(identifier(ID),T,_),TypedVals,EnumVals) :- % the identifier is bound by the member test; we do not need to enumerate it
   select(typedval(_,T,ID,_),TypedVals,Rest),
   debug_println(9,not_enumerating_inside_closure(ID)),
   !,
   EnumVals = Rest.
project(_,TV,TV).


:- block b_not_test_closure_wf(?,?,?,-,?).
b_not_test_closure_wf(Parameters,ParameterTypes,Closure,ParValues,WF) :-
	% ~~mnf(lists:same_length(Parameters,ParValues)),  % not necessary
	~~pp_mnf(store:set_up_localstate(Parameters,ParValues,[],LocalState)),
	~~pp_mnf(b_enumerate:b_type_values_in_store(Parameters,ParameterTypes,LocalState)),
	%%init_wait_flags(WF),
    %   print_message(b_interpreter:b_not_test_boolean_expression(Closure,LocalState,[],WF)),
	~~pp_cll(b_interpreter:b_not_test_boolean_expression(Closure,LocalState,[],WF)),
	%%%ground_constraintprop_wait_flags(WF),
	get_last_wait_flag(b_not_test_closure_wf(Parameters),WF,WF2),
	b_not_test_closure_enum(Parameters,ParameterTypes,LocalState,WF,WF2).
	%%   ,ground_enumeration_finished_flag(WF).

:- block b_not_test_closure_enum(-,?,?,?,?).
b_not_test_closure_enum(Parameters,ParameterTypes,LocalState,WF,WF2) :-
    ~~mnf(b_enumerate:b_extract_typedvalc(Parameters,ParameterTypes,LocalState,TypedVals)),
    (var(WF2) -> ground_typedvals_check(TypedVals,GrVals) ; true),
    b_not_test_closure_enum_aux(GrVals,WF2,TypedVals,WF).

:- block b_not_test_closure_enum_aux(-,-,?,?).
b_not_test_closure_enum_aux(_,_,TypedVals,WF) :-
    b_enumerate:b_tighter_enumerate_values(TypedVals,WF).
  % , print(finished_enum(Parameters)),nl.


:- use_module(library(terms)).
% check whether a VARIABLE occurs inside a closure
closure_occurs_check(VARIABLE,_Par,_ParTypes,ClosureBody) :- expression_contains_setvar(ClosureBody,VARIABLE).
%   /* occurs check;  x = closure1(x) ; for other closures this cannot happen ???!!! TO DO: Check */
%  custom_explicit_sets:is_closure1_value_closure(Par,ParTypes,ClosureBody,Val),
%  contains_var(VARIABLE,Val).

expression_contains_setvar(b(E,_,_),Variable) :- !,
    expression_contains_setvar_aux(E,Variable).
expression_contains_setvar(E,V) :- add_internal_error('Illegal Expression: ', expression_contains_setvar(E,V)),
    contains_var(V,E).

expression_contains_setvar_aux(value(Val),Variable) :- !,value_contains_setvar(Val,Variable).
% a few very common cases for performance; currently this predicate is often called for recursive functions
expression_contains_setvar_aux(identifier(_),_) :- !,fail.
expression_contains_setvar_aux(equal(A,B),Variable) :- !,
   (expression_contains_setvar(A,Variable) -> true ; expression_contains_setvar(B,Variable)).
expression_contains_setvar_aux(conjunct(A,B),Variable) :- !,
   (expression_contains_setvar(A,Variable) -> true ; expression_contains_setvar(B,Variable)).
expression_contains_setvar_aux(function(A,B),Variable) :- !,
   (expression_contains_setvar(A,Variable) -> true ; expression_contains_setvar(B,Variable)).
expression_contains_setvar_aux(union(A,B),Variable) :- !,
   (expression_contains_setvar(A,Variable) -> true ; expression_contains_setvar(B,Variable)).
expression_contains_setvar_aux(couple(A,B),Variable) :- !,
   (expression_contains_setvar(A,Variable) -> true ; expression_contains_setvar(B,Variable)).
% the rest via safe_syntaxelement:
expression_contains_setvar_aux(Expr,V) :- bsyntaxtree:safe_syntaxelement(Expr,Subs,_Names,_,_),!,
    member(Sub,Subs), expression_contains_setvar(Sub,V),!.
expression_contains_setvar_aux(E,V) :- add_internal_error('Illegal Expression: ', expression_contains_setvar_aux(E,V)),
    contains_var(V,E).

value_contains_setvar(Val,V) :- var(Val),!,Val==V.
value_contains_setvar(avl_set(_),_V) :- !, fail. % assume avl_set always properly grounded; avoid looking inside
value_contains_setvar(closure(_,_,Body),V) :- !,
   expression_contains_setvar(Body,V).
value_contains_setvar(int(_),_) :- !,fail. % we check for set variables
value_contains_setvar(global_set(_),_) :- !,fail. % we check for set variables
value_contains_setvar(freetype(_),_) :- !,fail. % we check for set variables
value_contains_setvar(freeval(_ID,_Case,Val),V) :- !, value_contains_setvar(Val,V).
value_contains_setvar(string(_),_) :- !,fail. % we check for set variables
value_contains_setvar(fd(_,_),_) :- !,fail. % we check for set variables
value_contains_setvar((A,B),V) :- !, (value_contains_setvar(A,V) ;  value_contains_setvar(B,V)).
value_contains_setvar([A|B],V) :- !, (value_contains_setvar(A,V) ;  value_contains_setvar(B,V)).
value_contains_setvar(Val,V) :- %print(check(Val,V)),nl,
    contains_var(V,Val).

% ------------------
